close all;

// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// Read config
//@#include "SW_config_v4.mod"
@#define DO_SIMULATE=1
@#define SEPARATE_TREND=0
@#define SEPARATE_NX=0
@#define LABOR_ONLY=0
@#include "NK_LABOR_ONLY_override.mod"
@#define SUB_SAMPLE=0
@#define TBILL_SHOCK=0
@#define SMOOTH_TAX=1
@#define CAP_U_IS_DEPRECIATION=0
@#define DEBT_LAGS=0
@#define Y_LAGS=0
@#define CHECK_LOADINGS=0
@#define SMALL_SE=0
@#define DO_NARRATIVE=0
@#define DO_TAX=1

// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// Declare parameters accordingly
@#include "NK_declarations_Foresight_ABCD.mod"

// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// Define initial parameter values
@#include "NK_initial_Foresight_ABCD.mod"

// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// Allow to override initial parameters and activate simulation
//@#define SIMUL_T=500
@#define SIMUL_T=240
se_s=1;
se_b=0;

@#define DO_SIMULATE=1 
@#define CAP_U_IS_DEPRECIATION=0
@#define DO_COST_CHANNEL=1
@#define COMPLEMENT_G=0 

// Sets permanent options
//@#include "NK_permanent_v1.mod"

// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// Include model equations
@#include "NK_model_equations_Foresight_ABCD.mod"
@#include "NK_Shocks_Foresight_ABCD.mod"

// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// Verify steady state (and compute it for some of the observation equations)
@#include "NK_steady_Foresight_ABCD.mod"
//steady;

// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// B-Kahn condition check
//check;

// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// DO_SIMULATE==1
   stoch_simul(irf=100, periods=@{SIMUL_T}, nograph, nomoments, nofunctions) 
            mc
            c
            y
            gc
            nx
            @#if LABOR_ONLY==0
                zcap
                rk
                k
                kp
                inve
                pk
                dinv
                drev_k
                inve_obs
                m_CI
                m_CI_lvl 
                dtau_k
            @#endif
            pinf
            w
            r
            dtau_l
            s
            debt
            lab
            dtau_c
            real_r
            rev_l
            Egc
            dy
            dc
            dg
            dw
            infobs
            tb3
            dtau_l_obs
            tauP
            labobs
            drev_l
            drev_c
            debt_obs
            DEBT_Y
            gc_obs
            y_obs
            c_obs
            m_signal
            a_signal
            g_signal
            g_signal_def_lvl
            m_PI
            m_signal_futures 
            m_signal_lvl 
            m_signal_futures_lvl 
            a_signal_lvl 
            g_signal_lvl 
            m_PI_lvl 
            a
            b
            u_g
            qs
            ms
            spinf
            sw
            u_t_k
            u_t_l
            u_t_c
            u_s
            ;
%    stoch_simul(irf=100, nograph, nomoments) 
%                a  b g qs  ms  spinf wf c inve y lab pinf w r  labprod labprod_net labprodf yf labf kp kpf wf invef
%                @#if DO_TAX>0 && DO_TAX_OBS>0
%                          dtau_l debt dtau_k drev_l drev_k drev_c dexp_s gc u_t_l u_t_k dtau_lf dtau_kf debtf
%                @#endif
%                @#if DO_ANTICIPATED==1
%                        dNews zetaP zetaG u_g 
%                @#endif
%                ;

ActualParams=[se_a     crhoa    se_b     crhob    se_g     crhog    se_t_l   crho_tl  se_m     crhoms   se_pinf  crhopinf]';

display([se_a oo_.dr.ghu(oo_.dr.inv_order_var(strmatch('y', M_.endo_names, 'exact')),strmatch('ea', M_.exo_names)) oo_.dr.ghu(oo_.dr.inv_order_var(strmatch('gc', M_.endo_names, 'exact')),strmatch('ea', M_.exo_names)) crhoa se_g se_m]);


display([oo_.dr.ghu(oo_.dr.inv_order_var(strmatch('gc', M_.endo_names, 'exact')),find(oo_.dr.ghu(oo_.dr.inv_order_var(strmatch('gc', M_.endo_names, 'exact')),:)~=0)); ...
            oo_.dr.ghu(oo_.dr.inv_order_var(strmatch('dtau_l_obs', M_.endo_names, 'exact')),find(oo_.dr.ghu(oo_.dr.inv_order_var(strmatch('gc', M_.endo_names, 'exact')),:)~=0)); ...
            oo_.dr.ghu(oo_.dr.inv_order_var(strmatch('robs', M_.endo_names, 'exact')),find(oo_.dr.ghu(oo_.dr.inv_order_var(strmatch('gc', M_.endo_names, 'exact')),:)~=0)); ...
            oo_.dr.ghu(oo_.dr.inv_order_var(strmatch('y_obs', M_.endo_names, 'exact')),find(oo_.dr.ghu(oo_.dr.inv_order_var(strmatch('gc', M_.endo_names, 'exact')),:)~=0)); ...
            oo_.dr.ghu(oo_.dr.inv_order_var(strmatch('ln_debt_obs', M_.endo_names, 'exact')),find(oo_.dr.ghu(oo_.dr.inv_order_var(strmatch('gc', M_.endo_names, 'exact')),:)~=0)); ...
            oo_.dr.ghu(oo_.dr.inv_order_var(strmatch('infobs', M_.endo_names, 'exact')),find(oo_.dr.ghu(oo_.dr.inv_order_var(strmatch('gc', M_.endo_names, 'exact')),:)~=0))]);

ObsNames = {'y';'gc';'inve';'dtau_l';'DEBT_Y';'pinf';'r';'Ex_g';'Ex_dtau_l'};
AltObsNames = {'y';'gc';'inve';'dtau_l';'DEBT_Y';'pinf';'r';'Ex_y';'Ex_c'};
MoneyObsNames = {'y';'gc';'inve';'dtau_l';'DEBT_Y';'pinf';'r';'Ex_y';'Ex_g';'Ex_pinf'};

ShockNames = {'ea';'eg';'eqs';'e_t_l';'e_s';'epinf';'em';'e_f_g';'e_f_t_l'};
TFPShockNames = {'ea';'eg';'eqs';'e_t_l';'e_s';'epinf';'em';'e_f_g';'e_f_a'};
MoneyShockNames = {'ea';'eg';'eqs';'e_t_l';'e_s';'epinf';'em';'e_f_g';'e_f_t_l';'e_f_m'};

% ObsNames = {'y';'gc';'inve';'dtau_l';'DEBT_Y';'pinf';'r';'Ex_g';'Ex_dtau_l';'Ex_r'};
% AltObsNames = {'y';'gc';'inve';'dtau_l';'DEBT_Y';'pinf';'r';'Ex_y';'Ex_c'; 'Ex_r'};

% ShockNames = {'ea';'eg';'eqs';'e_t_l';'e_s';'epinf';'em';'e_f_g';'e_f_t_l';'e_f_m'};
% TFPShockNames = {'ea';'eg';'eqs';'e_t_l';'e_s';'epinf';'em';'e_f_g';'e_f_a';'e_f_m'};

ObsIndices = zeros(length(ObsNames),1);
AltObsIndices = zeros(length(AltObsNames),1);
MoneyObsIndices = zeros(length(AltObsNames),1);
ShockIndices= zeros(length(ObsNames),1);
TFPShockIndices= zeros(length(ObsNames),1);

for vv = 1:length(ObsNames )
    ObsIndices(vv,1) = oo_.dr.inv_order_var( find(strcmp(ObsNames{vv}, cellstr(M_.endo_names)))) ;
    AltObsIndices(vv,1) = oo_.dr.inv_order_var( find(strcmp(AltObsNames{vv}, cellstr(M_.endo_names)))) ;
    ShockIndices(vv,1) = find(strcmp(ShockNames{vv}, cellstr(M_.exo_names))) ;
    TFPShockIndices(vv,1) = find(strcmp(TFPShockNames{vv}, cellstr(M_.exo_names))) ;
end;

for vv = 1:length(MoneyObsNames )
    MoneyObsIndices(vv,1) = oo_.dr.inv_order_var( find(strcmp(MoneyObsNames{vv}, cellstr(M_.endo_names)))) ;
    MoneyShockIndices(vv,1) = find(strcmp(MoneyShockNames{vv}, cellstr(M_.exo_names))) ;
end;

StateIndices = M_.nstatic + (1: (M_.npred + M_.nboth) );


AA = oo_.dr.ghx(StateIndices,:);
BB = oo_.dr.ghu(StateIndices,ShockIndices);
TFPBB = oo_.dr.ghu(StateIndices,TFPShockIndices);
MoneyBB = oo_.dr.ghu(StateIndices,MoneyShockIndices);
CC = oo_.dr.ghx(ObsIndices,:);
DD = oo_.dr.ghu(ObsIndices,ShockIndices);
TFPDD = oo_.dr.ghu(AltObsIndices,TFPShockIndices);
MoneyDD = oo_.dr.ghu(MoneyObsIndices,MoneyShockIndices);
MoneyCC = oo_.dr.ghx(MoneyObsIndices,:);
AltCC = oo_.dr.ghx(AltObsIndices,:);
AltDD = oo_.dr.ghu(AltObsIndices,ShockIndices);

ABCD = AA - BB * inv(DD) * CC;
display(max(abs(eig(ABCD))));

ABCD = AA - BB * inv(DD) * CC;
display(max(abs(eig(ABCD))));

ABCD_no_tax = AA - BB(:,1:end-1) * inv(DD(1:end-1,1:end-1)) * CC(1:end-1,:);
display(max(abs(eig(ABCD_no_tax))));

ABCD_small = AA - BB(:,1:end-2) * inv(DD(1:end-2,1:end-2)) * CC(1:end-2,:);
display(max(abs(eig(ABCD_small))));

display('alt');
AltABCD = AA - BB * inv(AltDD) * AltCC;
display(max(abs(eig(AltABCD))));

NoInvABCD = AA - BB(:,[1:2, 4:end]) * inv(AltDD([1:2, 4:end],[1:2, 4:end])) * AltCC([1:2, 4:end],:);
display(max(abs(eig(NoInvABCD))));

NoInvABCD_small = AA - BB(:,[1:end-2]) * inv(AltDD([1:2, 4:end-1],[1:end-2])) * AltCC([1:2, 4:end-1],:);
display(max(abs(eig(NoInvABCD_small))));

NoInvABCD_small_fiscal = AA - BB(:,[1:end-2]) * inv(DD([1:2, 4:end-1],[1:end-2])) * CC([1:2, 4:end-1],:);
display(max(abs(eig(NoInvABCD_small_fiscal))));

display('TFP')
TFPABCD = AA - TFPBB * inv(TFPDD) * CC;
display(max(abs(eig(TFPABCD))));

display('Money')
MoneyABCD = AA - MoneyBB * inv(MoneyDD) * MoneyCC;
display(max(abs(eig(MoneyABCD))));
