close all;

// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@#define DO_SIMULATE=1
@#define SEPARATE_TREND=0
@#define SEPARATE_NX=0
@#define LABOR_ONLY=0
@#define SUB_SAMPLE=0
@#define TBILL_SHOCK=0
@#define SMOOTH_TAX=1
@#define DEBT_LAGS=0
@#define Y_LAGS=0
@#define CHECK_LOADINGS=0
@#define SMALL_SE=0
@#define DO_NARRATIVE=0
@#define DO_TAX=1

// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// Declare parameters accordingly
@#include "NK_declarations_Foresight_ABCD.mod"

// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// Define initial parameter values
@#include "NK_initial_Foresight_ABCD.mod"

// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// Allow to override initial parameters and activate simulation
//@#define SIMUL_T=500
@#define SIMUL_T=0
se_s=1;
se_b=0;

@#define DO_SIMULATE=1 
@#define CAP_U_IS_DEPRECIATION=0
@#define DO_COST_CHANNEL=1
@#define COMPLEMENT_G=0 

@#include "NK_override_v2.mod"

// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// Include model equations
@#include "NK_model_equations_Foresight_ABCD.mod"
@#include "NK_Shocks_Foresight_ABCD.mod"

// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// Verify steady state (and compute it for some of the observation equations)
@#include "NK_steady_v1.mod"

// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@#if DO_SIMULATE==1
   stoch_simul(irf=0, periods=@{SIMUL_T}, nograph, nomoments, nofunctions) 
            mc
            c
            y
            gc
            nx
            @#if LABOR_ONLY==0
                zcap
                rk
                k
                kp
                inve
                pk
                dinv
                drev_k
                inve_obs
                m_CI
                m_CI_lvl 
                dtau_k
            @#endif
            pinf
            w
            r
            dtau_l
            s
            debt
            lab
            dtau_c
            real_r
            rev_l
            Egc
            dy
            dc
            dg
            dw
            infobs
            tb3
            dtau_l_obs
            tauP
            labobs
            drev_l
            drev_c
            debt_obs
            DEBT_Y
            gc_obs
            y_obs
            c_obs
            m_signal
            a_signal
            g_signal
            g_signal_def_lvl
            m_PI
            m_signal_futures 
            m_signal_lvl 
            m_signal_futures_lvl 
            a_signal_lvl 
            g_signal_lvl 
            m_PI_lvl 
            a
            b
            u_g
            qs
            ms
            spinf
            sw
            u_t_k
            u_t_l
            u_t_c
            u_s
            ;
@#else
	error('Full information estimation not implemented in this version');
@#endif

