% compare Del-Negro & Schorfheide Cholesky identification with my IV
% approach

%% Use mat_draws to compute analogue; compare R_IV and first three identified shocks

new_R_IV=R_IV;
if ~exist('DNS_R_IV', 'var')
    DNS_R_IV = cell(mz,1);
    for jj=1:mz
        DNS_R_IV{jj}=nan(m,h+1);
    end
    for dd=1:DD
        Bc=reshape(mat_draws.B(dd,1:NoParamsC*m),NoParamsC,m);
        S_1=reshape(mat_draws.V(dd,:),m+mz,m+mz);

%         K_core=[reshape(Bc(1:m*OriginalData.k, :)', m, m*OriginalData.k); eye((OriginalData.k-1)*m), zeros((OriginalData.k-1)*m, m)];
        K_core=[reshape(Bc(1:m*OriginalData.k, :)', m, m*OriginalData.k); eye((OriginalData.k-1)*m), zeros((OriginalData.k-1)*m, m)];

        current_chol = chol(S_1(1:m,1:m), 'lower') * DSGE_Q(:,1:mz, dd);
        current_vec = [current_chol ; zeros((OriginalData.k-1)*m, mz)];
        for jj=1:mz
            for s=1:h+1 % h+1 allows to compute the change in expected inflation
                %accumulated IR or regular IR
                DNS_R_IV{jj}(:, s,dd)=[eye(m), zeros(m, (OriginalData.k-1)*m)]*K_core^(s-1)*current_vec(:, jj)/current_chol(jj,CholToIV(jj));
                new_R_IV{jj,1}(:,s,:) = (R_IV{jj,1}(:,s,:) ./ repmat(R_IV{jj,1}(CholToIV(jj),1,:), [size(R_IV{jj,1},1), 1, 1]) );
            end
        end
        if mod(dd,50)==0
            fprintf('.');
        end
        if mod(dd,1000)==0
            fprintf('\n');
        end
    end
end

if ~exist('AddTerm', 'var')
    AddTerm = '';
end
return;
%% comparison

close all
for i=1:m
    for jj=1:mz
    %     figure(jj);
        YData=prctile(squeeze(new_R_IV{jj,1}(i,1:h,:))',[(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)]);
        [~, my_fig]=my_make_IRF(h-1,YData','DoAreaPlot', true, 'YLabel',Units{i},'XLabel','quarters');
        hold all    
        
        Plot_DSGE_IRF=prctile(squeeze(DSGE_IRF(i,1:h,jj,:))', [(100-CI_lvl([2 1]))/2 50 100-(100-CI_lvl)/2]');    
        Plot_DNS_IRF=prctile(squeeze(DNS_R_IV{jj}(i,1:h,:) ), [(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)],2);

        hndl=my_make_IRF(h-1,Plot_DNS_IRF,'DoOverLap', my_fig.Number, 'YLabel',Units(i),'XLabel','');
        set(gcf, 'name', [Labels{i} ' to  ' Labels{CholToIV(jj)}]);
    %     plot(prctile(squeeze(R_IV{jj,2}(i,:,:)), [5 50 95],2), '-r')
    %     plot(0:20, prctile(squeeze(R_IV{jj,1}(i,:,:)), [5 50 95],2), '--k', 'LineWidth',2 )
        plot([0 20], [0 0], '-b');
        if DO_PRINT
            print('-depsc', [GraphFolder '/DNS_IRF_' Labels{i} '_' regexprep( Labels{CholToIV(jj)}, ' ', '_') AddTerm VAR_suffix '.eps']);                    
        end
        
        % now plot with gray area the DSGE-VAR with DNS-IRF
        close(gcf)
        [~, my_fig]=my_make_IRF(h-1,Plot_DNS_IRF,'DoAreaPlot', true, 'YLabel',Units{i},'XLabel','quarters');
        hold all    

        hndl=my_make_IRF(h-1,Plot_DSGE_IRF','DoOverLap', my_fig.Number, 'YLabel',Units(i),'XLabel','');
        set(gcf, 'name', [Labels{i} ' to  ' Labels{CholToIV(jj)}]);
    %     plot(prctile(squeeze(R_IV{jj,2}(i,:,:)), [5 50 95],2), '-r')
    %     plot(0:20, prctile(squeeze(R_IV{jj,1}(i,:,:)), [5 50 95],2), '--k', 'LineWidth',2 )
        plot([0 20], [0 0], '-b');
        if DO_PRINT
            print('-depsc', [GraphFolder '/DSGE_DNS_' Labels{i} '_' regexprep( Labels{CholToIV(jj)}, ' ', '_') AddTerm VAR_suffix '.eps']);                    
        end

        if isequal(Labels{i}, 'Y')
            close(gcf);
            YData=prctile(squeeze(new_R_IV{jj,1}(i,1:h,:)-0.2*new_R_IV{jj,1}(strcmp(Labels,'G'),1:h,:))',[(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)]);
            [~, my_fig]=my_make_IRF(h-1,YData','DoAreaPlot', true, 'YLabel',Units{i},'XLabel','quarters');
            hold all    
        
            Plot_DNS_IRF=prctile(squeeze(DNS_R_IV{jj}(i,1:h,:) - 0.2*DNS_R_IV{jj}(strcmp(Labels,'G'),1:h,:)), [(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)],2);
            hndl=my_make_IRF(h-1,Plot_DNS_IRF,'DoOverLap', my_fig.Number, 'YLabel',Units(i),'XLabel','');

            set(gcf, 'name', ['Private Y to  ' Labels{CholToIV(jj)}]);
            plot([0 20], [0 0], '-b');
            if DO_PRINT
                print('-depsc', [GraphFolder '/DNS_IRF_PrivY_' regexprep( Labels{CholToIV(jj)}, ' ', '_') AddTerm VAR_suffix '.eps']);                    
            end; 
        end;
        if isequal(Labels{i}, 'FFR')
            close(gcf);
            YData=prctile(squeeze(new_R_IV{jj,1}(i,1:h,:)-new_R_IV{jj,1}(strcmp(Labels,'Inf'),2:h+1,:))',[(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)]);
            [~, my_fig]=my_make_IRF(h-1,YData','DoAreaPlot', true, 'YLabel',Units{i},'XLabel','quarters');
            hold all    
        
            Plot_DNS_IRF=prctile(squeeze(DNS_R_IV{jj}(i,1:h,:) - DNS_R_IV{jj}(strcmp(Labels,'Inf'),2:h+1,:)), [(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)],2);
            hndl=my_make_IRF(h-1,Plot_DNS_IRF,'DoOverLap', my_fig.Number, 'YLabel',Units(i),'XLabel','');

            set(gcf, 'name', ['Private Y to  ' Labels{CholToIV(jj)}]);
            plot([0 20], [0 0], '-b');
            if DO_PRINT
                print('-depsc', [GraphFolder '/DNS_IRF_real_rate_' regexprep( Labels{CholToIV(jj)}, ' ', '_') AddTerm VAR_suffix '.eps']);                    
            end; 
        end;
    end;
end;
close all
% 
%                 hold on;
%             else
%                 figure;
%                 YData=0;
%             end;
%             plot([0 (h-1)], [0 0],'-k');
%             hold on;
%             title([Labels{i} ' to unit shock in ' Labels{CholToIV(j)}]);
%             if WHICH_DATA==-1
%                 xlabel('months');
%             else
%                 xlabel('quarters');
%             end
%             ylabel(Units{i});
%             grid on;
%             set(findall(gcf,'type','axes'),'fontsize',18);
%             set(findall(gcf,'type','text'),'fontSize',18);      
%             if min(ylim)<0 && max(ylim)>0
%                 plot([0 h-1], [0 0], '-k');
%             end;
%             if DO_PRINT 
%                 print('-depsc', [GraphFolder '/IRF_' regexprep( Labels{i}, ' ', '_') '_' regexprep( Labels{CholToIV(j)}, ' ', '_') AddTerm VAR_suffix 'IV_simple.eps']);
%             end;            
%             
% %             error('add IRF if variable ends in "_Y"');
%             
%             if DO_IV~=0
% 
%                 hndl2=plot(0:1:(h-1), prctile(squeeze(R_IV{j,2}(i,1:h,:)+R_IV{j,2}(strcmp('Y',Labels),1:h,:)*ADD_Y)',[(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)])/RameyScaling_IV{j,2});
%                 set(hndl2, {'LineWidth'}, {1;2;3;2;1},{'LineStyle'}, {'-';'-';'-';'-';'-'}, {'Color'}, {SecondColor;SecondColor;SecondColor;SecondColor;SecondColor});
