%Set parameters and priors
    tic;
    switch MY_PRIOR
        case 1 %Minnesota
            % Done Stacking, compute prior/posterior for reduced form
            Y_pre=YY(1:max(OriginalData.k,2),:);
            std_pre=std(Y_pre);
            mean_pre=mean(Y_pre);

            preLambda=[0.2 1 m+2 1 1];
            DumY_l=NaN(OriginalData.k*m,m);
            DumX_l=NaN(OriginalData.k*m,size(X,2));
            for qq=1:OriginalData.k
                DumY_l(((qq-1)*m+1):(qq*m),:)=preLambda(1)*diag(std_pre.*(1-StationaryPrior))*(qq==1 & MY_PRIOR==1);
                DumX_l(((qq-1)*m+1):(qq*m),:)=[zeros(m,m*(qq-1)),preLambda(1)*diag(std_pre)*qq^preLambda(2), zeros(m,m*(OriginalData.k-qq)+size(X,2)-m*OriginalData.k)];
            end
            DumY_var=repmat(diag(std_pre),preLambda(3),1);
            DumX_var=repmat(zeros(m,size(X,2)),preLambda(3),1);
            DumY_sum=diag(mean_pre)*preLambda(4);
            DumX_sum=[repmat(diag(mean_pre*preLambda(4)),1,OriginalData.k), zeros(m,size(X,2)-m*OriginalData.k)];

            DumY_mean=mean_pre*preLambda(5);
            DumX_mean=[repmat(mean_pre*preLambda(5),1,OriginalData.k), [preLambda(5), zeros(1,size(X,2)-m*OriginalData.k-1)]];
            nu_prior=preLambda(3); 

            Y_old=Y;
            X_old=X;
            Y_dum=[DumY_mean; DumY_sum; DumY_var; DumY_l];
            X_dum=[DumX_mean; DumX_sum; DumX_var; DumX_l];
            Y=[DumY_mean; DumY_sum; DumY_var; DumY_l; Y];
            X=[DumX_mean; DumX_sum; DumX_var; DumX_l; X];

            B_prior=(X_dum'*X_dum)\(X_dum'*Y_dum);

            % Make sure the timing of the instruments is aligned
            IV=[NaN(1+m+preLambda(3)*m+OriginalData.k*m,size(IV,2)); IV];
            if DO_DISPLAY~=0
                if exist('quarter','var')
                    quarter=[NaN(1+m+preLambda(3)*m+OriginalData.k*m,1); quarter];
                end
            end
            
        case 2
                % Set variable and shock lists for DSGE prior
                if ~DoResumeSampling
                    VariableList=cell(length(Labels),3);
                    ShockList=cell(m-mP,1);
                    for vv=1:length(Labels)
                        idx=strmatch(Labels{vv},DSGE_VAR_MAP(:,2), 'exact');
                        VariableList{vv,1}=DSGE_VAR_MAP{idx,1};
                        VariableList{vv,2}=DSGE_VAR_MAP{idx,3};
                        VariableList{vv,3}=(vv>(m-mP));
                        if vv<=m_all-mP
                            ShockList{vv}=DSGE_VAR_MAP{idx,4};
                        end
                    end
                    
                    % Preserve actual data
                    OriginalData.T=T;
                    OriginalData.NO_TREND=NO_TRend;
                    OriginalData.rhomax=rhomax;
                    OriginalData.floor_T_B=floor(DSGE_lambda*T);
                    OriginalData.floor_T_S=floor(DSGE_lambda_S*T);
    %                 OriginalData.OriginalData.k=OriginalData.k;
                    OriginalData.Y=gpuArray(Y);
                    OriginalData.Xz=gpuArray(Xz);
                    OriginalData.IV=gpuArray(IV);
                    OriginalData.Xy=gpuArray(Xy);

                    OriginalData.NoXz=size(Xz,2);
                    OriginalData.NoParamsC=m*OriginalData.k+ConstantTerms;
                end
                % for initialization, no need to draw at random

                DO_COMPUTE_LL=0;
                if MY_PRIOR==2 
                    my_dynare_read_write_prior_script;
                    % If DO_M_FILE_ONLY==1, Dynare does not re-compile the mod file but works with the .m-file directly.
                    DO_M_FILE_ONLY=0; % Setting this to zero should make the three lines of code below unnecessary
                    DoMean=0;
                    DONT_DRAW=0;
                    my_draw=PriorStructure.prior_m;
                    
                    set_DSGE_VAR_Prior_m_long_GPU_v1;
                    prior_beta=beta_0;
                    prior_N0=full(N_XX_0_tilde);
                    proposal_S_prior=S_prior;
                    
                    DO_M_FILE_ONLY=1;
                    
                    % delete time-consuming & redundant commands in m-file

                    DynareMFile  = regexp( fileread( [regexprep(ModFile, '.mod', '') '.m' ] ), '\n', 'split');
                    DeleteLine=find(strncmp('save',DynareMFile,4));
                    for ii=0:12
                        DynareMFile{DeleteLine+ii}=[];
                    end
                    ModFile_new=tempname;
                    ModFile_new=[pwd '/DynareTmp/' ModFile_new(length(tempdir)+1:end)];
                    copyfile(['../' ModFile ],[ModFile_new '.mod' ]);
                    fid = fopen([ModFile_new '.m' ], 'w');
                    fprintf(fid, '%s\n', DynareMFile{:});
                    fclose(fid);
                    clear([regexprep(ModFile, '.mod', '') '.m' ]);
                    
                    if DO_HISTORICAL
                        DO_SIMULATE=2;
                        my_dynare_read_write_prior_script;
                        cd ..
                        evalc(['dynare ' ModFile ' noclearall ']);
                        cd VAR;
                        DynareMFile  = regexp( fileread( [regexprep(ModFile, '.mod', '') '.m' ] ), '\n', 'split');
                        DeleteLine=find(strncmp('save',DynareMFile,4));
                        for ii=0:12
                            DynareMFile{DeleteLine+ii}=[];
                        end
                        KalmanModFile=tempname;
                        KalmanModFile=[pwd '/DynareTmp/' KalmanModFile(length(tempdir)+1:end)];
                        copyfile(['../' ModFile ],[KalmanModFile '.mod' ]);
                        fid = fopen([KalmanModFile '.m' ], 'w');
                        fprintf(fid, '%s\n', DynareMFile{:});
                        fclose(fid);
                        clear([regexprep(ModFile, '.mod', '') '.m' ]);
                    end
                    ModFile=[ModFile_new '.mod'];
                end
                
                if DO_DISPLAY~=0 
                    if exist('quarter','var')
                        quarter=[NaN( length(Y_dum),1) ; quarter];
                    end
                end
                
                if MY_PRIOR==2 
                    DoMean=0; % make sure later draws are at random
                end
                
 
            disp('******************************************************************************************************');
 
            disp('******************************************************************************************************');
        otherwise
            nu_prior=0; % Jeffrey's prior is incorporated by drawing from the Wishart directly with subtracting m df

            OriginalData.T=T;
            OriginalData.Y=Y;
            OriginalData.Xz=Xz;
            OriginalData.IV=IV;
            OriginalData.Xy=Xy;    
            proposal_S_prior=zeros(m+mz,m+mz);
            prior_N0=zeros(NoParamsC*m+mz*NoXz,NoParamsC*m+mz*NoXz);
            prior_beta=zeros(NoParamsC*m+mz*NoXz,1);

    end
    
    ssXY=zeros(size(X,2),size(Y,2));
    ssX=zeros(size(X,2),size(X,2)); % (m*OriginalData.k+ConstantTerms) x (m*OriginalData.k+ConstantTerms) - first constant term applies to instruments
    for tt=1:length(X)
        ssX=ssX+X(tt,:)'*X(tt,:);
        ssXY=ssXY+X(tt,:)'*Y(tt,:);
    end

    %OLS estimation - this equals CMLE
    B_hat=ssX\ssXY;
    nu_T=size(Y,1); % OriginalData.k is already taken care of
    nu_posterior=nu_prior+T;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   
IndexData=(nu_T-T)+1:nu_T;
IndexPrior=1:(nu_T-T);
NoPrior=nu_T-T;

X_Gibbs=sparse([kron(eye(m,'gpuArray'),OriginalData.Xy), zeros(T*m,NoXz*mz,'gpuArray'); zeros(T*mz,(m*OriginalData.k+ConstantTerms)*m,'gpuArray'), kron(eye(mz,'gpuArray'),OriginalData.Xz)]);
Y_Gibbs=[reshape(OriginalData.Y,T*m,1);reshape(OriginalData.IV,T*mz,1)];

if exist('prior_N0','var') && MY_PRIOR~=0
    if DSGE_lambda>=100 % check if prior is close to putting all weight on the DSGE model
        beta_initial=prior_beta;
    else
        beta_initial=(X_Gibbs'*X_Gibbs+prior_N0)\(X_Gibbs'*Y_Gibbs+prior_N0*prior_beta);
    end
    
    myBy=reshape(beta_initial(1:m*NoParamsC),NoParamsC,m);
    myBz=reshape(beta_initial(m*NoParamsC+1:end),(size(X_Gibbs,2)-NoParamsC*m)/mz,mz);
else
    myBy=OriginalData.Xy\OriginalData.Y;
    myBz=OriginalData.Xz\OriginalData.IV;
end

K_hat=[reshape(myBy(1:m*OriginalData.k, :)', m, m*OriginalData.k); eye((OriginalData.k-1)*m,'gpuArray'), zeros((OriginalData.k-1)*m, m,'gpuArray')];

NoParamsBeta0=numel(myBy)+numel(myBz);
DimV=m+mz;

S_Data=@(By,Bz) [((Y-Xy*By)'*(Y-Xy*By)), ((Y-Xy*By)'*(Z-Xz*Bz)); ((Z-Xz*Bz)'*(Y-Xy*By)), ((Z-Xz*Bz)'*(Z-Xz*Bz))];

if MY_PRIOR==34
    my_debug_dummy_prior;
    % note: (Xz_dum, Z_dum) are independent of moments and is set above.
    Xy_dum = chol(NXX, 'upper') * sqrt(floor_T_B / length(NXX) );
    B_prior = reshape( prior_beta(1:ModelStructure.m * NoParamsC) ,NoParamsC,ModelStructure.m);
    Y_dum = Xy_dum * B_prior;
    Xy=[Xy_dum; OriginalData.Xy];
    Xz=[Xz_dum; OriginalData.Xz];
    Y=[Y_dum; OriginalData.Y];
    Z=[Z_dum; OriginalData.IV];
end

S_posterior=@(By,Bz) (nu_prior/nu_posterior)*proposal_S_prior+ (T/nu_posterior)*(1/T)*[((Y-Xy*By)'*(Y-Xy*By)), ((Y-Xy*By)'*(Z-Xz*Bz)); ...
                        ((Z-Xz*Bz)'*(Y-Xy*By)), ((Z-Xz*Bz)'*(Z-Xz*Bz))];

OldAcceptanceRate = -1;
MeanAcceptanceRate = -1;
                    
% Prepare for imputation of missing variables
my_Configure_Missing_Imputation_GPU;

% Other setup
log_ll=@(By,Bz,V) -(DimV*T/2)*log(2*pi)-(T/2)*2 * sum(full(-log(diag(chol(V))))) - (1/2) *  SSR_Data(By,Bz,V);
if (MY_PRIOR==2 || MY_PRIOR==3 || MY_PRIOR==33          ) && WhichChol~=2 && WhichChol~=3 && WhichChol~=1
    log_prior=@(By,Bz,V) -(NoParamsBeta0/2)*log(2*pi) + (1/2) *2 * sum(full(-log(diag(ichol(N_0_tilde))))) + ...
        - (1/2) * SSR_Prior_tilde(By,Bz,proposal_S_prior)  + ... Gaussian part with covariance matrix inv(X_0_tilde'*X_0_tilde') based on S_prior. Corresponds to N(beta_0, inv(X_0(S_prior)'X_0(S_prior)))
        -( (nu_prior-NoParamsBeta0)/2 ) * (DimV*log(2)+2 * sum(-log(diag(chol(nu_prior*proposal_S_prior)))) )+ ...
        -logMvGamma( (nu_prior-NoParamsBeta0) / 2,DimV) + ...
        -(1/2) * trace( V \ (nu_prior*proposal_S_prior))+((nu_prior-NoParamsBeta0-DimV-1)/2) * (2 * sum(-log(diag(chol(V)))) ); % Wishart part for inv(V)
    % log-conditional posterior for coefficients
    % beta|N(V) ~ N(beta_0 , N(V)^{-1} )
    log_cond_posterior_B=@(beta,beta_mean,N_sparse) -(NoParamsBeta0/2)*log(2*pi) + (1/2) *2 * sum(full(-log(diag(ichol(N_sparse))))) + ...
        - (1/2) * full((beta-beta_mean)'*(N_sparse\(beta-beta_mean))); % last row: inv(A)*B=A\B;
    % log-conditional posterior for variance -- adjusted for degrees of freedom
    % S|B ~ W_DimV( SSR_0 + SSR_data, nu_prior )
    log_cond_posterior_V=@(By,Bz,V)  -( (nu_posterior-NoParamsBeta0)/2 ) * (DimV*log(2)+2 * sum(-log(diag(chol(S_posterior(By,Bz)*nu_posterior)))) )+ ...
        -logMvGamma( (nu_posterior-NoParamsBeta0) / 2,m) + ...
        -(1/2) * trace( V \ (S_posterior(By,Bz)*nu_posterior))+((nu_posterior-NoParamsBeta0-m-1)/2) * (2 * sum(-log(diag(chol(V)))) );
end

    
    % R is used to save the IRFs
    R=cell(m); %j, s, d
    %x(:, end-1:end)=[ones(n,1) ,cumsum(ones(n, 1))];
    if DO_DISPLAY
        why;
    end
    
    %   S_prior is only included via the dummy observations
    if DSGE_lambda_S>=100 && MY_PRIOR~=0
        S_0=proposal_S_prior;
    else
        S_0=S_posterior(myBy,myBz);
    end
    dim_N_XY=(m*OriginalData.k+ConstantTerms)*m+mz*NoXz;
    vecB_0=[myBy(:); myBz(:)];
    GibbsCorr=zeros(DD*GibbsSkip+GibbsBurnIn,2);
    if MY_PRIOR==2 && ~DoResumeSampling
        DONT_DRAW=0; %get new draws
        set_DSGE_VAR_Prior_m_long_GPU_v1; % initial draw
        DO_M_FILE_ONLY=1;
        if ~DoResumeSampling
            mat_draws.S=NaN(DD*DrawsMultiple, PriorStructure.param_no);
            mat_draws.accept=NaN(DD*DrawsMultiple, 1,'single');
            MH_BurnIn_draws.S=NaN(GibbsBurnIn, PriorStructure.param_no);
            MH_BurnIn_draws.accept=NaN(GibbsBurnIn, 1,'single');
            MH_BurnIn_draws.accept_pr=NaN(GibbsBurnIn, 1);
        end
        DONT_DRAW=1; %prevent uncontrolled draws

        % suppress warning message, but not the actual warning
        warning('off','MATLAB:nearlySingularMatrix');
        fmin_density_options=optimset('Display','iter', 'MaxFunEval', 5e3, 'MaxIter', 1e3, 'TolFun', 1e-2);
        start_draw=PriorStructure.prior_m(:);

        % check whether initial parameter draw can work. Otherwise, draw from prior.
        trial_val=my_Dynare_DSGEVAR_Prior_fcn_GPU_v1( ModFile, M_,oo_, OriginalData, ModelStructure, PriorStructure,DSGE_lambda, DSGE_lambda_S, ...
                                        CoreList(1:(ModelStructure.m+ModelStructure.mP),:), InstrumentList, ShockList, ...
                                        start_draw, ...
                                        reshape(vecB_0(1:m*(m*OriginalData.k+ConstantTerms),1), m*OriginalData.k+ConstantTerms, m), reshape(vecB_0( (m*(m*OriginalData.k+ConstantTerms)+1):end,1), NoXz, mz), S_0, 0, ZeroMean);
        while trial_val==-inf
            my_DSGE_Parameter_Prior_draw_m;   
            start_draw=my_draw; % random draw from prior that works.
            trial_val=my_Dynare_DSGEVAR_Prior_fcn_GPU_v1( ModFile, M_,oo_, OriginalData, ModelStructure, PriorStructure,DSGE_lambda, DSGE_lambda_S, ...
                                            CoreList(1:(ModelStructure.m+ModelStructure.mP),:), InstrumentList, ShockList, ...
                                            start_draw, ...
                                            reshape(vecB_0(1:m*(m*OriginalData.k+ConstantTerms),1), m*OriginalData.k+ConstantTerms, m), reshape(vecB_0( (m*(m*OriginalData.k+ConstantTerms)+1):end,1), NoXz, mz), S_0, 0, ZeroMean);
        end


        FindMax=1;
        if exist('intermediate_step.mat', 'file')==2
            load intermediate_step;
            if SEED~=15
                IgnoreChars=3;
            else
                IgnoreChars=0;
            end
            if isequal(MatFile_VAR_PostFix(1:end-IgnoreChars),VAR_PostFix(1:end-IgnoreChars)) ...
                    && isequal(MatFile_ParamNames,PriorStructure.param_name) ...
                    && isequal(MatFile_Prior_Structure, PriorStructure)
                FindMax=0;
            end
        end
        if FindMax
            tic; start_time=cputime;
            if DSGE_lambda>=100 && DSGE_lambda_S>=100
                % simplify using that the draws of B, V are not random.
                [x_sol,val_sol]=fminunc(@(x) -my_Dynare_DSGEVAR_Prior_fcn_GPU_v1( ModFile, M_,oo_, OriginalData, ModelStructure, PriorStructure,DSGE_lambda, DSGE_lambda_S, ...
                                                    CoreList(1:(ModelStructure.m+ModelStructure.mP),:), InstrumentList, ShockList, ...
                                                    my_DSGE_Parameter_Prior_draw_from_real(PriorStructure, x), ...
                                                    reshape(vecB_0(1:m*(m*OriginalData.k+ConstantTerms),1), m*OriginalData.k+ConstantTerms, m), reshape(vecB_0( (m*(m*OriginalData.k+ConstantTerms)+1):end,1), NoXz, mz), S_0, -1, ZeroMean), ...
                                                    my_DSGE_Parameter_reverse(PriorStructure, start_draw), fmin_density_options );
            else
                [x_sol,val_sol]=fminunc(@(x) -my_Dynare_DSGEVAR_Prior_fcn_GPU_v1( ModFile, M_,oo_, OriginalData, ModelStructure, PriorStructure,DSGE_lambda, DSGE_lambda_S, ...
                                                CoreList(1:(ModelStructure.m+ModelStructure.mP),:), InstrumentList, ShockList, ...
                                                my_DSGE_Parameter_Prior_draw_from_real(PriorStructure, x), ...
                                                reshape(vecB_0(1:m*(m*OriginalData.k+ConstantTerms),1), m*OriginalData.k+ConstantTerms, m), reshape(vecB_0( (m*(m*OriginalData.k+ConstantTerms)+1):end,1), NoXz, mz), S_0, 0, ZeroMean), ...
                                                my_DSGE_Parameter_reverse(PriorStructure, start_draw), fmin_density_options );
            end
            run_time=cputime-start_time; toc; disp(num2str(run_time,'total run-time in seconds %1.2f'));
            draw_sol=my_DSGE_Parameter_Prior_draw_from_real(PriorStructure, x_sol);

            MatFile_ParamNames=PriorStructure.param_name;
            MatFile_VAR_PostFix=VAR_PostFix;
            MatFile_Prior_Structure=PriorStructure;            
            save('intermediate_step.mat', 'draw_sol','val_sol', 'MatFile_VAR_PostFix','MatFile_ParamNames', 'MatFile_Prior_Structure');
        end
        
        % Initialize parameter values
        [val_sol,~, ~, prior_N0, prior_beta, proposal_S_prior] =...
            my_Dynare_DSGEVAR_Prior_fcn_GPU_v1( ModFile, M_,oo_, OriginalData, ModelStructure, PriorStructure,DSGE_lambda, DSGE_lambda_S, ...
                    CoreList(1:(ModelStructure.m+ModelStructure.mP),:), InstrumentList, ShockList, draw_sol, ...
                    reshape(vecB_0(1:m*(m*OriginalData.k+ConstantTerms),1), m*OriginalData.k+ConstantTerms, m), reshape(vecB_0( (m*(m*OriginalData.k+ConstantTerms)+1):end,1), NoXz, mz), S_0, 0, ZeroMean);
        val_sol=-val_sol;
        if exist('val_hessian', 'var')
            if min(eig(val_hessian))>0 %also ok with imaginary numbers
                CholInvHessian=chol(inv(val_hessian), 'lower')/2;
            else
                CholInvHessian=diag(max([PriorStructure.prior_s(:)*0.1,abs(draw_sol)*0.1]')')/20;
            end
        else
                CholInvHessian=diag(max([PriorStructure.prior_s(:)*0.1,abs(draw_sol)*0.1]')')/20;        
        end
        
        warning('on','MATLAB:nearlySingularMatrix'); 
        disp([char(PriorStructure.param_name), num2str(draw_sol, '%1.2f :: ' ), num2str(PriorStructure.prior_m(:), '%1.2f' ) ]);

        my_draw=draw_sol;
 
        S_posterior=@(By,Bz) (nu_prior/nu_posterior)*proposal_S_prior + (T/nu_posterior)*(1/T)*[((OriginalData.Y-OriginalData.Xy*By)'*(OriginalData.Y-OriginalData.Xy*By)), ...
            ((OriginalData.Y-OriginalData.Xy*By)'*(CurrentZ-OriginalData.Xz*Bz)); ((CurrentZ-OriginalData.Xz*Bz)'*(OriginalData.Y-OriginalData.Xy*By)), ...
            ((CurrentZ-OriginalData.Xz*Bz)'*(CurrentZ-OriginalData.Xz*Bz))];
        
        NoBurnIns=3;
    elseif MY_PRIOR~=3
        if ~exist('Prior_rho', 'var')
            Prior_rho=NaN;
        end
        NoBurnIns=1;
    end
    
    if MY_PRIOR~=3 || ( WhichChol==2 || WhichChol==3 || WhichChol==1)
        DSGE_Rotate=eye(mz);
    end    
    % Save the VAR parameters
    if ~DoResumeSampling
        mat_draws.B=NaN(DD*DrawsMultiple,NoParamsBeta0);
        mat_draws.V=NaN(DD*DrawsMultiple,DimV^2);
    else
        mat_draws.B=[mat_draws.B;NaN((DD-DD_old)*DrawsMultiple,NoParamsBeta0)];
        mat_draws.V=[mat_draws.V; NaN((DD-DD_old)*DrawsMultiple,DimV^2)];
    end
        
    %----------------------------------------------------------------------------------------------------------%
    %                                           S A M P L E R
    %----------------------------------------------------------------------------------------------------------%
   
    AcceptDraw=0;
    UseInvariantProb=0;
        
    if DoResumeSampling
        d=DD_old+NoBurnIns;
    else
        MH_ScaleFactor=10;
        if ~exist('UseStudentDist', 'var')
            UseStudentDist=0;
        end
        if ~exist('StudentDF', 'var')
            StudentDF=10;
        end
        if ~exist('DoRandomBlocking', 'var')
            DoRandomBlocking=0;
        end
        
        d=0;
    end
    
    % d=1: Compute variance-covariance matrix
    % d=2: Calibrate scale
    % d=3: Burn-in
    while d<DD+NoBurnIns
    	d=d+1;
        if d==NoBurnIns
            GibbsBurnIn=min(5e4,GibbsBurnIn*GibbsSkip);
        end
        % Draw for the core from a Gibbs-Sampler
        gg=0;
        while gg<(GibbsSkip+(d<=NoBurnIns)*GibbsBurnIn)
 
            gg=gg+1;
 
            if MY_PRIOR==2 % implement Metropolis-within-Gibbs step
                
                current_draw=my_draw;
                if d<=2
                    % During Burn-In, use RW proposal density with independent increments based on scaled prior standard deviation
                    if mod(gg-1,250)==0 && gg>1
                        OldAcceptanceRate = MeanAcceptanceRate;
                        
                        MeanAcceptanceRate = mean(MH_BurnIn_draws.accept((gg-250):(gg-1),1));
                        
                        MH_ScaleFactor=MH_ScaleFactor/(1+2*sign(MeanAcceptanceRate-TargetScale).*(MeanAcceptanceRate-TargetScale).^2/TargetScale);
                        disp([num2str(gg) ' :: ' num2str(MeanAcceptanceRate) ' :: ' num2str(mean(MH_BurnIn_draws.accept_pr((gg-250):(gg-1),1))) ' :: ' ...
                            num2str( MH_ScaleFactor*(1+2*sign(MeanAcceptanceRate-TargetScale).*(MeanAcceptanceRate-TargetScale).^2/TargetScale) ) ' :-> ' num2str(MH_ScaleFactor) ]);
                        
                        % in second step, check if the acceptance rate seems to have converged
                        if abs(OldAcceptanceRate - MeanAcceptanceRate)< 0.005 && abs(MeanAcceptanceRate-TargetScale)<0.05 && d==2;
                            gg = (GibbsSkip+(d<=NoBurnIns)*GibbsBurnIn);
                        end
                    end
                end
                
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                %   Randomly assing blocks
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                [NoBlocks,BlockIndices]=my_RandomBlock(PriorStructure.param_no, 0.15);
                proposal_draw=current_draw;
                AcceptDraw=0;                   

                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                %   Gibbs step for structural parameters
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

                my_draw_theta_blocks_GPU;

                % During BurnIn, save winning draw for subsequent calibration
                if d<=2
                    MH_BurnIn_draws.accept_pr(gg,1)=gather(AcceptDrawPr);
                    MH_BurnIn_draws.accept(gg,1)=single(AcceptDraw);
                    MH_BurnIn_draws.S(gg,:)=my_draw(:)';
                end
            end
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %   Gibbs step for coefficients and covariance
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            my_draw_B_V_manual_GPU;
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %   Gibbs step for missing instruments
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            my_imputation_GPU;
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %   Display information and continue
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

            if DO_DISPLAY 
                fprintf('%1.0f :: ', [d-NoBurnIns gg rr UseInvariantProb]);
                fprintf('%1.2f :: ', AcceptDraw );                
                
                if MY_PRIOR==2   || MY_PRIOR==3  || MY_PRIOR==33
                    fprintf('eig(Prior S) %1.4f :: ', Prior_eig_S_Prior);
                    fprintf('prior rho %1.4f :: ', Prior_rho);
                    fprintf('llhood %1.4f :: ', ( -(T/2)*(m+mz)*log(2*pi) - (OriginalData.T/2)*2*sum(log(diag(chol(S_1)))) - (1/2)*trace( S_1\S_Data(Bc,Bz) ) ));
                end
                fprintf('eig(S) %1.4f :: ', max(eig(S_1)));
                fprintf('rho %1.4f ', rho);
                fprintf('\n');
            end
        end
        if d>NoBurnIns
            mat_draws.B(d-NoBurnIns,:)=gather([Bc(:)' Bz(:)']);
            mat_draws.V(d-NoBurnIns,:)=gather(S_1(:)');
            mat_draws.MaxEigs(d-NoBurnIns,:)=gather([Prior_rho rho max(eig(S_1))]);
            mat_draws.LogL(d-NoBurnIns,1)= ( -(OriginalData.T/2)*(m+mz)*log(2*pi) - (1/2)*gather(OriginalData.T*2*sum(log(diag(chol(S_1)))) + trace( S_1\S_Data(Bc,Bz) ) ));
        end
        % adjust proposal density

        if MY_PRIOR==2                    
            if d>NoBurnIns
                mat_draws.S(d-NoBurnIns,:)=current_draw(:)';
                mat_draws.accept(d-NoBurnIns,1)=single(AcceptDraw);
            % here: computation of density
            elseif d==1
                CholInvHessian=diag(max([PriorStructure.prior_s(:)*0.1,abs(draw_sol)*0.1]')'/MH_ScaleFactor); % use variance-covariance matrix calibrated in "first round" with constant scale factor                
                Proposal_Cov_chol=chol(cov(MH_BurnIn_draws.S), 'lower'); % Cholesky decomposition of covariance of structural draws during BurnIn
                MH_ScaleFactor=2.5;
            end
        end

        % print progress on screen 
        if DO_DISPLAY
            if mod(d-NoBurnIns, 100)==0
                fprintf('%1.2fpc', 100*(d-NoBurnIns)/DD);
                if mod(d-NoBurnIns, 2e3)==0
                    fprintf('\n');
                end
            end
        end
    end

if DO_DISPLAY
    fprintf('\n');
end


toc;