function [CorrMatrix, my_fig]=my_ACF_plot(data, min_lag, max_lag)

BaseData=data(1-min_lag:end-max_lag,:);
BaseRank=tiedrank(BaseData);
CorrMatrix=NaN(1-min_lag+max_lag,2);

SampleLength=length(BaseData);
for ll=min_lag:max_lag
	CurrentData=data(1-min_lag+ll:end-max_lag+ll,:);
	CurrentRank=tiedrank(CurrentData);
	
	CorrMatrix(1-min_lag+ll,1)=nancorr(BaseData, CurrentData);
	CorrMatrix(1-min_lag+ll,2)=nancorr(BaseRank, CurrentRank); %1-6 * sum( (BaseRank-CurrentRank).^2 ) / (SampleLength*(SampleLength^2-1));

end;

figure;
h=area([min_lag-0.3 max_lag+0.3], norminv(0.95)*[1 1]/sqrt(SampleLength-1), -norminv(0.95)/sqrt(SampleLength-1));
set(h, 'FaceColor',[1 1 1]*0.8);
hold all;
fig_hndl1=stem((min_lag:max_lag)-0.25,CorrMatrix(:,1));
fig_hndl2=stem( (min_lag:max_lag)+0.25 ,CorrMatrix(:,2));
my_fig=[fig_hndl1(:); fig_hndl2(:)];
axis([min_lag-0.3 max_lag+0.3 ylim]);
legend(my_fig, {'Pearson'; 'Spearman'}, 'Location', 'Best', 'FontSize', 16);
set(findall(gcf,'type','axes'),'fontsize',18);
set(findall(gcf,'type','text'),'fontSize',18);        
ylabel('autocorrelation');
xlabel('lags');
legend('boxoff');
grid on;
