% Use a combination of Geweke and Chib to compute the marginal likelihood
if ~exist('DO_VAR_LL', 'var')
    DO_VAR_LL=0;
end


% DD=500;
if DSGE_lambda_S>=100 && DSGE_lambda>=100
    ML.DD=2;
else
    ML.DD=2e3;
end
ML.GibbsSkip=1;
ML.GibbsBurnIn=1e3;
ML.Blocks_Inner=1;
ML.Threshold=2e3;

try
    if existsOnGPU(S_1)
		fprintf(2,'\n Converting GPU arrays \n');
		OriginalData.Y=gather(OriginalData.Y);
		OriginalData.Xy=gather(OriginalData.Xy);
		OriginalData.Xz=gather(OriginalData.Xz);
		OriginalData.IV=gather(OriginalData.IV);
		X_Gibbs = gather(X_Gibbs);
		Y_Gibbs = gather(Y_Gibbs);

		DS = gather(DS);

		S_1 = gather(S_1);
		vecB_1 = gather(vecB_1);
		S_0 = gather(S_0);
		vecB_0 = gather(vecB_0);

		RESIDUALS = gather(RESIDUALS);
		CurrentZ = gather(CurrentZ);

		myBz=gather(myBz);
		myBy=gather(myBy);
		Bz=gather(Bz);
		Bc=gather(Bc);
        Vinv_yy=gather(Vinv_yy);
        Vinv_zz=gather(Vinv_zz);
        Vinv_yz=gather(Vinv_yz);
        Vinv_zy=gather(Vinv_zy);
        Vinv=gather(Vinv);

		prior_N0=gather(prior_N0);
		prior_beta=gather(prior_beta);
		S_prior=gather(S_prior);
		proposal_beta = gather(proposal_beta);
		proposal_S_prior = gather(proposal_S_prior);
		current_S_prior=gather(current_S_prior);
		B_prior=gather(B_prior);
		res_all_all_beta=gather(res_all_all_beta);
		res_all_var =gather(res_all_var);
        switch mz
            case 3            
                if sum(MISSING_1 )>0
                	res_1_given2_3_beta =gather(res_1_given2_3_beta );
        			res_1_given2_3_var =gather(res_1_given2_3_var);
                end
                if sum(MISSING_2 )>0
                    res_2_given1_3_beta =gather(res_2_given1_3_beta );
                	res_2_given1_3_var =gather(res_2_given1_3_var);
                end
                if sum(MISSING_3 )>0
        			res_3_given1_2_beta =gather(res_3_given1_2_beta);
                	res_3_given1_2_var =gather(res_3_given1_2_var );
                end
                if sum(MISSING_1_3)>0
        			res_1_3_given2_beta =gather(res_1_3_given2_beta);
                    res_1_3_given2_var =gather(res_1_3_given2_var);
                end
                if sum(MISSING_1_2)>0
                	res_1_2_given3_beta =gather(res_1_2_given3_beta );
        			res_1_2_given3_var  =gather(res_1_2_given3_var );
                end
                if sum(MISSING_2_3)>0
        			res_2_3_given1_beta =gather(res_2_3_given1_beta);
                	res_2_3_given1_var =gather(res_2_3_given1_var);
                end
            case 2
                if sum(MISSING_1 )>0
                    res_1_given2_beta  =gather(res_1_given2_beta );
                    res_1_given2_var =gather(res_1_given2_var);
                end
                if sum(MISSING_2 )>0
                    res_2_given1_beta =gather(res_2_given1_beta );
                    res_2_given1_var=gather(res_2_given1_var);
                end
        end
		fprintf(2,'\n Success converting GPU arrays \n');
    end
catch
		fprintf(2,'\n Problem converting GPU arrays \n');
end

% p_barB_Y_i=NaN(DD,1);

% ModelStructure.MISSING_ALL=MISSING_ALL;
% switch ModelStructure.mz
%     case 3
% 	ModelStructure.MISSING_1_2=MISSING_1_2;
% 	ModelStructure.MISSING_1_3=MISSING_1_3;
% 	ModelStructure.MISSING_2_3=MISSING_2_3;
% 	ModelStructure.MISSING_1=MISSING_1;
% 	ModelStructure.MISSING_2=MISSING_2;
% 	ModelStructure.MISSING_3=MISSING_3;
%     case 2
% 	ModelStructure.MISSING_1=MISSING_1;
% 	ModelStructure.MISSING_2=MISSING_2;
%     case 1
% 	ModelStructure.MISSING_1=MISSING_1;
% end
ModelStructure.DD=ML.DD;
ModelStructure.nu_prior=nu_prior;
ModelStructure.nu_posterior=nu_posterior;
ModelStructure.GibbsSkip=5;
ModelStructure.GibbsBurnIn=min(100,ML.GibbsBurnIn);
ModelStructure.DSGE_lambda=DSGE_lambda;
ModelStructure.DSGE_lambda_S=DSGE_lambda_S;
% ModelStructure.imp_all_idx=imp_all_idx;
% ModelStructure.res_all_all_idx=res_all_all_idx;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% STEP 1: COMPUTE POSTERIOR MEANS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

post_mean_theta=mean(mat_draws.S,1)';
post_mean_beta=mean(mat_draws.B,1)';
post_mean_By = reshape(post_mean_beta(1:NoParamsC*ModelStructure.m),NoParamsC,ModelStructure.m);
post_mean_Bz = reshape(post_mean_beta(NoParamsC*ModelStructure.m+1:end),size(myBz));
post_mean_V=reshape(mean(mat_draws.V,1)',(ModelStructure.m+ModelStructure.mz),(ModelStructure.m+ModelStructure.mz));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% STEP 2: COMPUTE THE CONDITIONAL POSTERIOR
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% STEP 3: Geweke-Chib
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ThetaVar=cov(mat_draws.S(:,1:PriorStructure.param_no_eff));
ThetaMean=mean(mat_draws.S(:,1:PriorStructure.param_no_eff))';

ModelStructure.NoParamsC=NoParamsC;
GewekeAlpha=0.05;

log_f_alpha=@(S,alpha) (-log(1-alpha) - (PriorStructure.param_no_eff/2)*log(2*pi) - (1/2)*logdet(ThetaVar) ...
    -(1/2) * (S(:)-ThetaMean)'*(ThetaVar\(S(:)-ThetaMean))) ...
    +log( +(chi2inv(1-alpha,PriorStructure.param_no_eff)>=(S(:)-ThetaMean)'*(ThetaVar\(S(:)-ThetaMean))) ) ;

% log_f_weights=NaN(DD,5);


% DD_Inner=1e3;

if DD>ML.Threshold
    THETA_IDX=ceil(1:DD/ML.Threshold:DD);
else
    THETA_IDX=1:DD;
end

No_Theta_Samples=length(THETA_IDX);
log_f_weights=NaN(No_Theta_Samples,1);
log_prior=NaN(No_Theta_Samples,1);
log_density_estimate=NaN(No_Theta_Samples,1);
log_density_estimate_VAR=NaN(No_Theta_Samples,2);
VAR_py_theta=NaN(No_Theta_Samples,1);

tic;
for dd=1:No_Theta_Samples
    theta_idx=THETA_IDX(dd);
        % is density at current already the relevant Kernel?
        % Do I have to add the data density to density at current? 
%     [log_post_kernel_hyper, NewDrawNeeded, my_log_prior, N_prior, beta_prior, S_prior, Prior_rho, Prior_eig_S_Prior, py_VAR]        
    [~, ~, bar_theta_prior, bar_theta_N0, bar_theta_beta0, bar_theta_S_prior,~,~,VAR_py_theta(dd)]=...
        my_Dynare_DSGEVAR_Prior_fcn_v3( ModFile, M_,oo_,  OriginalData, ModelStructure,PriorStructure,DSGE_lambda, DSGE_lambda_S, ...
                CoreList(1:(ModelStructure.m+ModelStructure.mP),:), InstrumentList, ShockList, mat_draws.S(theta_idx,:), ...
                reshape(vecB_0(1:m*(m*OriginalData.k+ConstantTerms)), m*OriginalData.k+ConstantTerms, m), ...
                reshape(vecB_0( (m*(m*OriginalData.k+ConstantTerms)+1):end), NoXz, mz), S_0, 0, ZeroMean, 1);
            
    S_posterior=@(By,Bz) (nu_prior/nu_posterior)*bar_theta_S_prior + (T/nu_posterior)*(1/T)*[((OriginalData.Y-OriginalData.Xy*By)'*(OriginalData.Y-OriginalData.Xy*By)), ...
        ((OriginalData.Y-OriginalData.Xy*By)'*(OriginalData.IV-OriginalData.Xz*Bz)); ((OriginalData.IV-OriginalData.Xz*Bz)'*(OriginalData.Y-OriginalData.Xy*By)), ...
        ((OriginalData.IV-OriginalData.Xz*Bz)'*(OriginalData.IV-OriginalData.Xz*Bz))];

%     log_prior(dd)=my_DSGE_Parameter_Prior_density(PriorStructure, mat_draws.S(dd,:)); % the prior itself is simple to get...
    log_prior(dd)=sum(bar_theta_prior);
    
        % Initialize the sampler.
    S_0=reshape( mat_draws.V(theta_idx,:),(ModelStructure.m+ModelStructure.mz),(ModelStructure.m+ModelStructure.mz));
    vecB_0=mat_draws.B(theta_idx,:);

    % Use the same parameters for the Gibbs sampler as for the full posterior
    NoBurnIns=1; % The SUR sampler needs no calibration prior to burn-in
    for bb=1:ML.Blocks_Inner
        Cond_Posterior.B=NaN(ML.DD ,NoParamsBeta0);
        Cond_Posterior.V=NaN(ML.DD ,DimV^2);
        Cond_Posterior.Z =NaN(ML.DD, size(OriginalData.IV,1), ModelStructure.mz );


%         GibbsBurnIn=ML.DD_Inner;

        d=0;
        tstart=tic;
        while d<ML.DD+NoBurnIns
            d=d+1;
            if d==NoBurnIns
                GibbsBurnIn=min(5e3,ML.GibbsBurnIn*ML.GibbsSkip);
            end
            % Draw for the core from a Gibbs-Sampler
            gg=0;
            while gg<(ML.GibbsSkip+(d<=NoBurnIns)*ML.GibbsBurnIn)

                gg=gg+1;

                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                %   Gibbs step for coefficients and covariance
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

                my_draw_B_V_manual;

                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                %   Gibbs step for missing instruments
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

                my_imputation;
%                 if mod(gg,ML.GibbsSkip)==0
%                     fprintf('.');
%                     if mod(gg,50)==0 || mod(d,50)==0
%                         fprintf([num2str(dd) '::' num2str(bb) '::' num2str(d) '. \n']);
%                     end
%                 end
            end
            if mod(d,50)==0
                fprintf('.');
            end

            Cond_Posterior.V(max(1,d-NoBurnIns),:)=S_1(:);
            Cond_Posterior.B(max(1,d-NoBurnIns),:)=vecB_1;
            Cond_Posterior.Z(max(1,d-NoBurnIns),:,:)=CurrentZ;

        end
% return;
        % this function takes a few seconds to run
%         log_density_estimate((dd-1)*ML.Blocks_Inner+bb,1)=my_Chib_Likelihood_fcn(bar_theta_beta0, bar_theta_N0, bar_theta_S_prior, Cond_Posterior, OriginalData, ModelStructure, ML.DD);
        log_density_estimate((dd-1)*ML.Blocks_Inner+bb,1)=my_Chib_Likelihood_missing_fcn(bar_theta_beta0, bar_theta_N0, bar_theta_S_prior, Cond_Posterior, OriginalData, ModelStructure, ML.DD);
        
        if DO_VAR_LL
            log_density_estimate_VAR((dd-1)*ML.Blocks_Inner+bb,:)=my_Chib_Likelihood_VAR_fcn(bar_theta_beta0, bar_theta_N0, bar_theta_S_prior, Cond_Posterior, OriginalData, ModelStructure, ML.DD);
        end
        fprintf([num2str(dd) '::' num2str(bb) '::' num2str(d) '::' num2str(toc(tstart), '%1.0f') '. \n']);
    end
    log_f_weights((dd-1)*ML.Blocks_Inner+(1:ML.Blocks_Inner),1) = log_f_alpha(mat_draws.S(theta_idx,1:PriorStructure.param_no_eff), GewekeAlpha);
    
%     log_f_weights((dd-1)*Blocks_Inner+(1:Blocks_Inner),2) = log_f_alpha(mat_draws.S(dd,:), GewekeAlpha-0.01);
%     log_f_weights((dd-1)*Blocks_Inner+(1:Blocks_Inner),3) = log_f_alpha(mat_draws.S(dd,:), GewekeAlpha);
%     log_f_weights((dd-1)*Blocks_Inner+(1:Blocks_Inner),4) = log_f_alpha(mat_draws.S(dd,:), GewekeAlpha+0.01);
%     log_f_weights((dd-1)*Blocks_Inner+(1:Blocks_Inner),5) = log_f_alpha(mat_draws.S(dd,:), 0.1);
end

% log_p_Y=NaN(1,5);
% for gg=1:5
gg=1;
log_p_Y=-( log(mean(exp( ...
    log_f_weights(1:No_Theta_Samples*ML.Blocks_Inner,gg)-kron(log_prior(1:No_Theta_Samples), ones(ML.Blocks_Inner,1))-log_density_estimate(1:No_Theta_Samples) ...
	-max(log_f_weights(1:No_Theta_Samples*ML.Blocks_Inner,gg)-kron(log_prior(1:No_Theta_Samples), ones(ML.Blocks_Inner,1))-log_density_estimate(1:No_Theta_Samples))))) ...
    +max(log_f_weights(1:No_Theta_Samples*ML.Blocks_Inner,gg)-kron(log_prior(1:No_Theta_Samples), ones(ML.Blocks_Inner,1))-log_density_estimate(1:No_Theta_Samples) ) );

SUR_VAR_log_p_Y=-( log(mean(exp( ...
    log_f_weights(1:No_Theta_Samples*ML.Blocks_Inner,gg)-kron(log_prior(1:No_Theta_Samples), ones(ML.Blocks_Inner,1))-log_density_estimate_VAR(1:No_Theta_Samples,1) ...
	-max(log_f_weights(1:No_Theta_Samples*ML.Blocks_Inner,gg)-kron(log_prior(1:No_Theta_Samples), ones(ML.Blocks_Inner,1))-log_density_estimate_VAR(1:No_Theta_Samples,1))))) ...
    +max(log_f_weights(1:No_Theta_Samples*ML.Blocks_Inner,gg)-kron(log_prior(1:No_Theta_Samples), ones(ML.Blocks_Inner,1))-log_density_estimate_VAR(1:No_Theta_Samples,1) ) );

if DO_VAR_LL
    alt_SUR_VAR_log_p_Y=-( log(mean(exp( ...
        log_f_weights(1:No_Theta_Samples*ML.Blocks_Inner,gg)-kron(log_prior(1:No_Theta_Samples), ones(ML.Blocks_Inner,1))-log_density_estimate_VAR(1:No_Theta_Samples,2) ...
        -max(log_f_weights(1:No_Theta_Samples*ML.Blocks_Inner,gg)-kron(log_prior(1:No_Theta_Samples), ones(ML.Blocks_Inner,1))-log_density_estimate_VAR(1:No_Theta_Samples,2))))) ...
        +max(log_f_weights(1:No_Theta_Samples*ML.Blocks_Inner,gg)-kron(log_prior(1:No_Theta_Samples), ones(ML.Blocks_Inner,1))-log_density_estimate_VAR(1:No_Theta_Samples,2) ) );
end
VAR_log_p_Y=log(mean(exp(VAR_py_theta-max(VAR_py_theta))))+max(VAR_py_theta);

toc;

TmpSum=log_f_weights(1:No_Theta_Samples*ML.Blocks_Inner,gg)-kron(log_prior(1:No_Theta_Samples), ones(ML.Blocks_Inner,1))-log_density_estimate(1:No_Theta_Samples);
ConvergencePlot=NaN(No_Theta_Samples*ML.Blocks_Inner,1);
ConvergencePlot_simple=NaN(No_Theta_Samples*ML.Blocks_Inner,1);
for dd=1:No_Theta_Samples
    ConvergencePlot(dd)=log(mean(exp(TmpSum(1:dd)-max(TmpSum(1:dd)))))+max(TmpSum(1:dd));
    ConvergencePlot_simple(dd)=log(mean(exp(TmpSum(1:dd))));
end
% ConvergencePlot_simple=cumsum(TmpSum)./(1:No_Theta_Samples)';

if ispc && usejava('jvm')
    figure;
    plot(ConvergencePlot);
else
    display(ConvergencePlot(100:100:end)'-ConvergencePlot(end));
end