function p_Y_theta_Chib=my_Chib_Likelihood_missing_fcn(prior_beta, prior_N0,proposal_S_prior, posterior_structure, OriginalData, ModelStructure, DD)
% Use Chib (1995, JASA) method to compute the marginal likelihood


p_barB_Y_i=NaN(DD,1);
ell_i =NaN(DD,1);

post_mean_beta=mean(posterior_structure.B,1)';
post_mean_By = reshape(post_mean_beta(1:ModelStructure.NoParamsC*ModelStructure.m),ModelStructure.NoParamsC,ModelStructure.m);
Bc=post_mean_By ; % this is for imputation only
post_mean_Bz = reshape(post_mean_beta(ModelStructure.NoParamsC*ModelStructure.m+1:end),[OriginalData.NoXz, ModelStructure.mz]);
Bz=post_mean_Bz ; % this is for imputation only
post_mean_V=reshape(mean(posterior_structure.V,1)',(ModelStructure.m+ModelStructure.mz),(ModelStructure.m+ModelStructure.mz));
post_mean_z=OriginalData.IV;
post_mean_z(ModelStructure.MISSING_ALL,:)=OriginalData.Xz(ModelStructure.MISSING_ALL,:)*post_mean_Bz;
ModelStructureFieldNames=fieldnames(ModelStructure);
switch ModelStructure.mz
    case 3
        if any(strcmp('MISSING_1_2',ModelStructureFieldNames))
            post_mean_z(ModelStructure.MISSING_1_2,1:2)=OriginalData.Xz(ModelStructure.MISSING_1_2,:)*post_mean_Bz(:,1:2);
        end
        if any(strcmp('MISSING_1_3',ModelStructureFieldNames))
            post_mean_z(ModelStructure.MISSING_1_3,[1 3])=OriginalData.Xz(ModelStructure.MISSING_1_3,:)*post_mean_Bz(:,[1 3]);
        end
        if any(strcmp('MISSING_2_3',ModelStructureFieldNames))
            post_mean_z(ModelStructure.MISSING_2_3,[2 3])=OriginalData.Xz(ModelStructure.MISSING_2_3,:)*post_mean_Bz(:,2:3);
        end
        if any(strcmp('MISSING_1',ModelStructureFieldNames))
            post_mean_z(ModelStructure.MISSING_1,1)=OriginalData.Xz(ModelStructure.MISSING_1,:)*post_mean_Bz(:,1);
        end
        if any(strcmp('MISSING_2',ModelStructureFieldNames))
            post_mean_z(ModelStructure.MISSING_2,2)=OriginalData.Xz(ModelStructure.MISSING_2,:)*post_mean_Bz(:,2);
        end
        if any(strcmp('MISSING_3',ModelStructureFieldNames))
            post_mean_z(ModelStructure.MISSING_3,3)=OriginalData.Xz(ModelStructure.MISSING_3,:)*post_mean_Bz(:,3);
        end
    case 2
        if any(strcmp('MISSING_1',ModelStructureFieldNames))
            post_mean_z(ModelStructure.MISSING_1,1)=OriginalData.Xz(ModelStructure.MISSING_1,:)*post_mean_Bz(:,1);
        end
        if any(strcmp('MISSING_2',ModelStructureFieldNames))
            post_mean_z(ModelStructure.MISSING_2,2)=OriginalData.Xz(ModelStructure.MISSING_2,:)*post_mean_Bz(:,2);
        end
end

MISSING_ALL=ModelStructure.MISSING_ALL;
m=ModelStructure.m;% this is for imputation only
mz=ModelStructure.mz;% this is for imputation only

NoParamsBeta0=numel(prior_beta);

NXyXy=OriginalData.Xy'*OriginalData.Xy;
NXyXz=OriginalData.Xy'*OriginalData.Xz;
NXzXz=OriginalData.Xz'*OriginalData.Xz;

NXyY=OriginalData.Xy'*OriginalData.Y;
NXzY=OriginalData.Xz'*OriginalData.Y;

SSR_data=@(myBy,myBz, Z) [OriginalData.Y-OriginalData.Xy*myBy, Z-OriginalData.Xz*myBz ]' ... 
    *[OriginalData.Y-OriginalData.Xy*myBy, Z-OriginalData.Xz*myBz ];

for dd=1:DD
    Current_Z=reshape(posterior_structure.Z(dd,:,:), [OriginalData.T, ModelStructure.mz] );
    NXyZ=OriginalData.Xy'*Current_Z;
    NXzZ=OriginalData.Xz'*Current_Z;
    
    V_current=reshape(posterior_structure.V(dd,:),(ModelStructure.m+ModelStructure.mz),(ModelStructure.m+ModelStructure.mz));
    
    %piece-wise inverse
    Vinv_yy=inv(V_current(1:ModelStructure.m,1:ModelStructure.m)-( V_current(1:ModelStructure.m,ModelStructure.m+(1:ModelStructure.mz))/(V_current(ModelStructure.m+(1:ModelStructure.mz),ModelStructure.m+(1:ModelStructure.mz))) )*V_current(ModelStructure.m+(1:ModelStructure.mz),1:ModelStructure.m));
    Vinv_zz=inv(V_current(ModelStructure.m+(1:ModelStructure.mz),ModelStructure.m+(1:ModelStructure.mz))-( V_current(ModelStructure.m+(1:ModelStructure.mz),1:ModelStructure.m)/(V_current(1:ModelStructure.m,1:ModelStructure.m)) )*V_current(1:ModelStructure.m,ModelStructure.m+(1:ModelStructure.mz)));
    Vinv_yz=-V_current(1:ModelStructure.m,1:ModelStructure.m)\(V_current(1:ModelStructure.m,ModelStructure.m+(1:ModelStructure.mz))*Vinv_zz);
    Vinv_zy=-Vinv_zz*V_current(ModelStructure.m+(1:ModelStructure.mz),1:ModelStructure.m)/V_current(1:ModelStructure.m,1:ModelStructure.m);
    Vinv=[Vinv_yy, Vinv_yz; Vinv_zy Vinv_zz];

    XkronX=[kron(Vinv_yy,NXyXy) kron(Vinv_yz,NXyXz ); ...
                        kron(Vinv_zy,NXyXz') kron(Vinv_zz,NXzXz)];
                    
    XkronY=zeros(NoParamsBeta0, 1);
    for m_idx1=1:(ModelStructure.m+ModelStructure.mz)
        % loop over all forecast errors and instruments
        % forecast error
        if m_idx1<=ModelStructure.m
            % forecast error x forecast error
                XkronY(OriginalData.NoParamsC*(m_idx1-1)+(1:OriginalData.NoParamsC),1) = ...
                    XkronY(OriginalData.NoParamsC*(m_idx1-1)+(1:OriginalData.NoParamsC),1) +NXyY(:,1:ModelStructure.m)*Vinv(m_idx1,1:ModelStructure.m)';
            % forecast error x instrument
                XkronY(OriginalData.NoParamsC*(m_idx1-1)+(1:OriginalData.NoParamsC),1) = ...
                    XkronY(OriginalData.NoParamsC*(m_idx1-1)+(1:OriginalData.NoParamsC),1) +NXyZ*Vinv(m_idx1,ModelStructure.m+1:end)';
        else
            % instrument x forecast error
            XkronY(OriginalData.NoParamsC*ModelStructure.m+OriginalData.NoXz*(m_idx1-ModelStructure.m-1)+(1:OriginalData.NoXz),1) = ...
                XkronY(OriginalData.NoParamsC*ModelStructure.m+OriginalData.NoXz*(m_idx1-ModelStructure.m-1)+(1:OriginalData.NoXz),1) +NXzY(:,1:ModelStructure.m)*Vinv(m_idx1,1:ModelStructure.m)';
            % instrument x instrument
            XkronY(OriginalData.NoParamsC*ModelStructure.m+OriginalData.NoXz*(m_idx1-ModelStructure.m-1)+(1:OriginalData.NoXz),1) = ...
                XkronY(OriginalData.NoParamsC*ModelStructure.m+OriginalData.NoXz*(m_idx1-ModelStructure.m-1)+(1:OriginalData.NoXz),1) +NXzZ*Vinv(m_idx1,ModelStructure.m+1:end)';
        end
    end    
    
    NXX_SUR_combined_i = XkronX + prior_N0 ;
    NXY_SUR_combined_i = XkronY + prior_N0  * prior_beta;
    cond_post_mean_i = NXX_SUR_combined_i \ NXY_SUR_combined_i;

    p_barB_Y_i(dd,1)=...
        -(NoParamsBeta0/2) * log(2 * pi) ...
        +(1/2) * logdet(NXX_SUR_combined_i) ...
        -(1/2) * (post_mean_beta - cond_post_mean_i)' * NXX_SUR_combined_i * (post_mean_beta - cond_post_mean_i);

    S_1 = post_mean_V;
    my_imputation_LLhood;
    ell_i = ...
        -( (ModelStructure.m+ModelStructure.mz) *OriginalData.T /2 ) * log(2*pi) ...
        -( OriginalData.T / 2) * logdet(post_mean_V) ...
        -( 1 / 2) * trace(post_mean_V \ SSR_data(post_mean_By,post_mean_Bz, Current_Z) );
end

% Now draw V given B
p_barV_Y_i=NaN(DD,1); % initialize
df_SSR_prior=OriginalData.floor_T_S+ModelStructure.NoParamsC*0;
df_post=OriginalData.T+OriginalData.floor_T_S+ModelStructure.NoParamsC*0;

if ModelStructure.DSGE_lambda_S<100
    d=0;
    while d<ModelStructure.DD
        d=d+1;
        CurrentZ=reshape(posterior_structure.Z(dd,:,:), [OriginalData.T, ModelStructure.mz] );


        S_posterior= (ModelStructure.nu_prior/ModelStructure.nu_posterior)*proposal_S_prior+ (OriginalData.T/ModelStructure.nu_posterior)*(1/OriginalData.T)*[((OriginalData.Y-OriginalData.Xy*post_mean_By)'*(OriginalData.Y-OriginalData.Xy*post_mean_By)), ...
            ((OriginalData.Y-OriginalData.Xy*post_mean_By)'*(CurrentZ-OriginalData.Xz*post_mean_Bz)); ...
                                ((CurrentZ-OriginalData.Xz*post_mean_Bz)'*(OriginalData.Y-OriginalData.Xy*post_mean_By)), ((CurrentZ-OriginalData.Xz*post_mean_Bz)'*(CurrentZ-OriginalData.Xz*post_mean_Bz))];
        DS=chol(inv(S_posterior)/ModelStructure.nu_posterior);
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %   Gibbs step for coefficients and covariance
        %   Here: Direct sampling, no Gibbs needed
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        gg=0;
        while gg<(ModelStructure.GibbsSkip+(d<=1)*ModelStructure.GibbsBurnIn)

            gg=gg+1;
            S_1 = inv(wishrnd(DS'*DS,ModelStructure.nu_posterior, DS));

            my_imputation_LLhood;

            S_posterior= (ModelStructure.nu_prior/ModelStructure.nu_posterior)*proposal_S_prior+ (OriginalData.T/ModelStructure.nu_posterior)*(1/OriginalData.T)*[((OriginalData.Y-OriginalData.Xy*post_mean_By)'*(OriginalData.Y-OriginalData.Xy*post_mean_By)), ...
                ((OriginalData.Y-OriginalData.Xy*post_mean_By)'*(CurrentZ-OriginalData.Xz*post_mean_Bz)); ...
                                    ((CurrentZ-OriginalData.Xz*post_mean_Bz)'*(OriginalData.Y-OriginalData.Xy*post_mean_By)), ((CurrentZ-OriginalData.Xz*post_mean_Bz)'*(CurrentZ-OriginalData.Xz*post_mean_Bz))];
            DS=chol(inv(S_posterior)/ModelStructure.nu_posterior);
        end
        SSR_combined = S_posterior*ModelStructure.nu_posterior;    

        % Compute running mean
        p_barV_Y_i(d) = ...
            -(1/2) * trace( S_1 \ SSR_combined ) ... 
            -( (df_post - ModelStructure.m -ModelStructure.mz -1) / 2) * logdet(S_1) ... 
            -logMvGamma( df_post /2 , ModelStructure.m + ModelStructure.mz) ... 
            -( df_post * (ModelStructure.m+ModelStructure.mz) / 2) * log(2) ... 
            +(  df_post / 2) * logdet(SSR_combined) ... 
            ;    
    end
    p_barV_Y=log(mean(exp(p_barV_Y_i-max(p_barV_Y_i))))+max(p_barV_Y_i);
else
    
    S_1 = proposal_S_prior;
    
    
    d=0;
    while d<ModelStructure.DD
        d=d+1;

        my_imputation_LLhood;

        S_posterior= (ModelStructure.nu_prior/ModelStructure.nu_posterior)*proposal_S_prior+ (OriginalData.T/ModelStructure.nu_posterior)*(1/OriginalData.T)*[((OriginalData.Y-OriginalData.Xy*post_mean_By)'*(OriginalData.Y-OriginalData.Xy*post_mean_By)), ...
            ((OriginalData.Y-OriginalData.Xy*post_mean_By)'*(CurrentZ-OriginalData.Xz*post_mean_Bz)); ...
                                ((CurrentZ-OriginalData.Xz*post_mean_Bz)'*(OriginalData.Y-OriginalData.Xy*post_mean_By)), ((CurrentZ-OriginalData.Xz*post_mean_Bz)'*(CurrentZ-OriginalData.Xz*post_mean_Bz))];
        
        SSR_combined = S_posterior*ModelStructure.nu_posterior;    

        % Compute running mean
        p_barV_Y_i(d) = ...
            -(1/2) * trace( S_1 \ SSR_combined ) ... 
            -( (df_post - ModelStructure.m -ModelStructure.mz -1) / 2) * logdet(S_1) ... 
            -logMvGamma( df_post /2 , ModelStructure.m + ModelStructure.mz) ... 
            -( df_post * (ModelStructure.m+ModelStructure.mz) / 2) * log(2) ... 
            +(  df_post / 2) * logdet(SSR_combined) ... 
            ;    

    end
    p_barV_Y=log(mean(exp(p_barV_Y_i-max(p_barV_Y_i))))+max(p_barV_Y_i);
        
end

% (1a)
p_barB_Y = log(mean(exp(p_barB_Y_i-max(p_barB_Y_i))))+max(p_barB_Y_i);
ell = log(mean(exp(ell_i-max(ell_i))))+max(ell_i);
prior = ...
    -(NoParamsBeta0/2) * log(2 * pi) ... ok
    +(1/2) * logdet(prior_N0) ... ok
    -(1/2) * (post_mean_beta - prior_beta)' * prior_N0 * (post_mean_beta - prior_beta)... ok
    -(1/2) * trace( post_mean_V \ (df_SSR_prior*proposal_S_prior) ) ... ok
    -( (df_SSR_prior  - ModelStructure.m -ModelStructure.mz -1) / 2) * logdet(post_mean_V) ... ok - note the minus here that takes care of the inverse
    -logMvGamma( (df_SSR_prior ) /2 , ModelStructure.m + ModelStructure.mz) ... ok 
    -( (df_SSR_prior * (ModelStructure.m +ModelStructure.mz) ) / 2) * log(2) ... ok
    +( (df_SSR_prior ) / 2) * logdet(df_SSR_prior*proposal_S_prior) ... ok -
    ;
if isempty(OriginalData.IV)
    OriginalData.IV=NaN(OriginalData.T,0);
end

% marginal likelihood
p_Y_theta_Chib = ell + prior - p_barV_Y - p_barB_Y;

