% Write missing data file

if DO_IMPUTATION==1
    % Prepare for imputation of missing variables
    MISSING_VALS = OriginalData.IV==0;
    MISSING_CASES= sum(MISSING_VALS,1)>0;
    MISSING_ALL = all(MISSING_VALS,2);
    res_all_all_idx = [ones(1,m), zeros(1, mz)]==1;
    imp_all_idx = [zeros(1,m), ones(1, mz)] ;
    % error('construction of missing indices is wrong!')
    % error('MISSING_2 and _2_3 must exclude aggregate!')
    if mz==3
        MISSING_1 = MISSING_VALS(:,1) & ~MISSING_ALL ;
        res_1_given2_3_idx = [ones(1,m), 0, 1,1]==1;
        imp_1_given2_3_idx = (ones(1,m+mz)-res_1_given2_3_idx )==1;

        MISSING_2 = MISSING_VALS(:,2) & ~MISSING_ALL ;
        res_2_given1_3_idx = [ones(1,m+1), 0, 1]==1;
        imp_2_given1_3_idx = (ones(1,m+mz)-res_2_given1_3_idx )==1;

        MISSING_3 = MISSING_VALS(:,3) & ~MISSING_ALL ;
        res_3_given1_2_idx = [ones(1,m+2), 0]==1;
        imp_3_given1_2_idx = (ones(1,m+mz)-res_3_given1_2_idx )==1;

        MISSING_1_3 = all(MISSING_VALS(:,[1 3]),2) & ~MISSING_ALL ;
        res_1_3_given2_idx = [ones(1,m), 0,1, 0]==1;
        imp_1_3_given2_idx = (ones(1,m+mz)-res_1_3_given2_idx)==1 ;

        MISSING_1_2 = all(MISSING_VALS(:,[1 2]),2) & ~MISSING_ALL ;
        res_1_2_given3_idx = [ones(1,m), 0,0, 1]==1;
        imp_1_2_given3_idx = (ones(1,m+mz)-res_1_2_given3_idx)==1 ;

        MISSING_2_3 = all(MISSING_VALS(:,2:3),2) & ~MISSING_ALL ;
        res_2_3_given1_idx = [ones(1,m+1), 0, 0]==1;
        imp_2_3_given1_idx = (ones(1,m+mz)-res_2_3_given1_idx)==1 ;
    elseif mz==2
        MISSING_1 = MISSING_VALS(:,1) & ~MISSING_ALL ;
        res_1_given2_idx = [ones(1,m), 0, 1]==1;
        imp_1_given2_idx = (ones(1,m+mz)-res_1_given2_idx )==1;

        MISSING_2 = MISSING_VALS(:,2) & ~MISSING_ALL ;
        res_2_given1_idx = [ones(1,m+1), 0]==1;
        imp_2_given1_idx = (ones(1,m+mz)-res_2_given1_idx )==1;  
    end;

    CurrentZ=OriginalData.IV;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % version for the original Gibbs sampler
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    fid = fopen(['my_imputation_GPU.m' ], 'w');
    % fid = fopen(['test.m' ], 'w');
    
    if sum(MISSING_CASES)>0
        %fprintf(fid, '%s\n', 'function CurrentZ=my_imputation(OriginalData,S_1, Bc, Bz)');
        fprintf(fid, '%s\n', '% automatically generated by my_Configure_Missing_Imputation');
        fprintf(fid, '%s\n', '');
        fprintf(fid, '%s\n', 'CurrentZ=OriginalData.IV;');
        fprintf(fid, '%s\n', 'RESIDUALS = [OriginalData.Y-OriginalData.Xy*Bc, OriginalData.IV-OriginalData.Xz*Bz];');
        if sum(MISSING_ALL)>0
            fprintf(fid, '%s\n', 'res_all_all_beta = S_1(m+1:end, 1:m) / S_1(1:m,1:m) ; ');
            fprintf(fid, '%s\n', 'res_all_var = S_1(imp_all_idx==1,imp_all_idx==1) - res_all_all_beta* S_1(1:m,1:m)*res_all_all_beta'';');
            fprintf(fid, '%s\n', 'CurrentZ(MISSING_ALL,:) = RESIDUALS(MISSING_ALL,res_all_all_idx)*res_all_all_beta'' + randn(sum(MISSING_ALL),mz, ''gpuArray'')*chol(res_all_var, ''lower'')'' + OriginalData.Xz(MISSING_ALL,:)*Bz;');
        end
        switch mz
            case 3            
                if sum(MISSING_1 )>0
                    fprintf(fid, '%s\n', 'res_1_given2_3_beta = S_1(m+1, res_1_given2_3_idx) / S_1(res_1_given2_3_idx,res_1_given2_3_idx) ;');
                    fprintf(fid, '%s\n', 'res_1_given2_3_var = S_1(imp_1_given2_3_idx,imp_1_given2_3_idx) - res_1_given2_3_beta* S_1(res_1_given2_3_idx,res_1_given2_3_idx)*res_1_given2_3_beta'';');
                    fprintf(fid, '%s\n', 'CurrentZ(MISSING_1,1) = RESIDUALS(MISSING_1,res_1_given2_3_idx)*res_1_given2_3_beta'' + sqrt(res_1_given2_3_var)*randn(sum(MISSING_1),1, ''gpuArray'') + OriginalData.Xz(MISSING_1,:)*Bz(:,1);');
                end;
                if sum(MISSING_2 )>0
                    fprintf(fid, '%s\n', 'res_2_given1_3_beta = S_1(m+2, res_2_given1_3_idx) / S_1(res_2_given1_3_idx,res_2_given1_3_idx) ;');
                    fprintf(fid, '%s\n', 'res_2_given1_3_var = S_1(imp_2_given1_3_idx,imp_2_given1_3_idx) - res_2_given1_3_beta* S_1(res_2_given1_3_idx,res_2_given1_3_idx)*res_2_given1_3_beta'';');
                    fprintf(fid, '%s\n', 'CurrentZ(MISSING_2,2) = RESIDUALS(MISSING_2,res_2_given1_3_idx)*res_2_given1_3_beta'' + sqrt(res_2_given1_3_var )*randn(sum(MISSING_2),1, ''gpuArray'') + OriginalData.Xz(MISSING_2,:)*Bz(:,2);');
                end;
                if sum(MISSING_3 )>0
                    fprintf(fid, '%s\n', 'res_3_given1_2_beta = S_1(imp_3_given1_2_idx, res_3_given1_2_idx) / S_1(res_3_given1_2_idx,res_3_given1_2_idx) ;');
                    fprintf(fid, '%s\n', 'res_3_given1_2_var = S_1(imp_3_given1_2_idx,imp_3_given1_2_idx) - res_3_given1_2_beta* S_1(res_3_given1_2_idx,res_3_given1_2_idx)*res_3_given1_2_beta'';');
                    fprintf(fid, '%s\n', 'CurrentZ(MISSING_3,3) = RESIDUALS(MISSING_3,res_3_given1_2_idx)*res_3_given1_2_beta'' + sqrt(res_3_given1_2_var )*randn(sum(MISSING_3),1, ''gpuArray'') + OriginalData.Xz(MISSING_3,:)*Bz(:,2);');
                end;
                if sum(MISSING_1_3)>0
                    fprintf(fid, '%s\n', 'res_1_3_given2_beta = S_1(imp_1_3_given2_idx,res_1_3_given2_idx)*inv(S_1(res_1_3_given2_idx,res_1_3_given2_idx));');
                    fprintf(fid, '%s\n', 'res_1_3_given2_var = S_1(imp_1_3_given2_idx,imp_1_3_given2_idx) - res_1_3_given2_beta* S_1(res_1_3_given2_idx,res_1_3_given2_idx)*res_1_3_given2_beta'';');
                    fprintf(fid, '%s\n', 'CurrentZ(MISSING_1_3,[1 3]) = RESIDUALS(MISSING_1_3,res_1_3_given2_idx)*res_1_3_given2_beta'' + randn(sum(MISSING_1_3),2, ''gpuArray'')*chol(res_1_3_given2_var , ''lower'')''+ OriginalData.Xz(MISSING_1_3,:)*Bz(:,[1,3]);');
                end;
                if sum(MISSING_1_2)>0
                    fprintf(fid, '%s\n', 'res_1_2_given3_beta = S_1(imp_1_2_given3_idx,res_1_2_given3_idx)*inv(S_1(res_1_2_given3_idx,res_1_2_given3_idx));');
                    fprintf(fid, '%s\n', 'res_1_2_given3_var = S_1(imp_1_2_given3_idx,imp_1_2_given3_idx) - res_1_2_given3_beta* S_1(res_1_2_given3_idx,res_1_2_given3_idx)*res_1_2_given3_beta'';');
                    fprintf(fid, '%s\n', 'CurrentZ(MISSING_1_2,[1 3]) = RESIDUALS(MISSING_1_2,res_1_2_given3_idx)*res_1_2_given3_beta'' + randn(sum(MISSING_1_2),2, ''gpuArray'')*chol(res_1_2_given3_var , ''lower'')''+ OriginalData.Xz(MISSING_1_2,:)*Bz(:,[1,2]);');
                end;
                if sum(MISSING_2_3)>0
                    fprintf(fid, '%s\n', 'res_2_3_given1_beta = S_1(imp_2_3_given1_idx,res_2_3_given1_idx)*inv(S_1(res_2_3_given1_idx,res_2_3_given1_idx));');
                    fprintf(fid, '%s\n', 'res_2_3_given1_var = S_1(imp_2_3_given1_idx,imp_2_3_given1_idx) - res_2_3_given1_beta* S_1(res_2_3_given1_idx,res_2_3_given1_idx)*res_2_3_given1_beta'';');
                    fprintf(fid, '%s\n', 'CurrentZ(MISSING_2_3,[2 3]) = RESIDUALS(MISSING_2_3,res_2_3_given1_idx)*res_2_3_given1_beta'' + randn(sum(MISSING_2_3),2, ''gpuArray'')*chol(res_2_3_given1_var , ''lower'')''+ OriginalData.Xz(MISSING_2_3,:)*Bz(:,[2,3]);');
                end;
            case 2
                if sum(MISSING_1 )>0
                    fprintf(fid, '%s\n', 'res_1_given2_beta = S_1(imp_1_given2_idx, res_1_given2_idx) / S_1(res_1_given2_idx,res_1_given2_idx) ;');
                    fprintf(fid, '%s\n', 'res_1_given2_var = S_1(imp_1_given2_idx,imp_1_given2_idx) - res_1_given2_beta* S_1(res_1_given2_idx,res_1_given2_idx)*res_1_given2_beta'';');
                    fprintf(fid, '%s\n', 'CurrentZ(MISSING_1,1) = RESIDUALS(MISSING_1,res_1_given2_idx)*res_1_given2_beta'' + sqrt(res_1_given2_var)*randn(sum(MISSING_1),1, ''gpuArray'') + OriginalData.Xz(MISSING_1,:)*Bz(:,1);');
                end;
                if sum(MISSING_2 )>0
                    fprintf(fid, '%s\n', 'res_2_given1_beta = S_1(imp_2_given1_idx, res_2_given1_idx) / S_1(res_2_given1_idx,res_2_given1_idx) ;');
                    fprintf(fid, '%s\n', 'res_2_given1_var = S_1(imp_2_given1_idx,imp_2_given1_idx) - res_2_given1_beta* S_1(res_2_given1_idx,res_2_given1_idx)*res_2_given1_beta'';');
                    fprintf(fid, '%s\n', 'CurrentZ(MISSING_2,2) = RESIDUALS(MISSING_2,res_2_given1_idx)*res_2_given1_beta'' + sqrt(res_2_given1_var )*randn(sum(MISSING_2),1, ''gpuArray'') + OriginalData.Xz(MISSING_2,:)*Bz(:,2);');
                end;
        end;
    end;

    fclose(fid);

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % version for the Gibbs sampler in the likelihood computation that uses
    % ModelStructure
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    fid = fopen(['my_imputation_LLhood_GPU.m' ], 'w');
    % fid = fopen(['test.m' ], 'w');
    
    if sum(MISSING_CASES)>0
        %fprintf(fid, '%s\n', 'function CurrentZ=my_imputation(OriginalData,S_1, Bc, Bz)');
        fprintf(fid, '%s\n', '% automatically generated by my_Configure_Missing_Imputation');
        fprintf(fid, '%s\n', '');
        fprintf(fid, '%s\n', 'CurrentZ=OriginalData.IV;');
        fprintf(fid, '%s\n', 'RESIDUALS = [OriginalData.Y-OriginalData.Xy*Bc, OriginalData.IV-OriginalData.Xz*Bz];');
        if sum(MISSING_ALL)>0
            fprintf(fid, '%s\n', 'res_all_all_beta = S_1(ModelStructure.m+1:end, 1:ModelStructure.m) / S_1(1:ModelStructure.m,1:ModelStructure.m) ; ');
            fprintf(fid, '%s\n', 'res_all_var = S_1(ModelStructure.imp_all_idx==1,ModelStructure.imp_all_idx==1) - res_all_all_beta* S_1(1:ModelStructure.m,1:ModelStructure.m)*res_all_all_beta'';');
            fprintf(fid, '%s\n', 'CurrentZ(ModelStructure.MISSING_ALL,:) = RESIDUALS(ModelStructure.MISSING_ALL,ModelStructure.res_all_all_idx)*res_all_all_beta'' + randn(sum(ModelStructure.MISSING_ALL),ModelStructure.mz, ''gpuArray'')*chol(res_all_var, ''lower'')'' + OriginalData.Xz(ModelStructure.MISSING_ALL,:)*Bz;');
            ModelStructure.MISSING_ALL=MISSING_ALL;
            ModelStructure.imp_all_idx=imp_all_idx;
            ModelStructure.res_all_all_idx=res_all_all_idx;
        end
        switch mz
            case 3            
                if sum(MISSING_1 )>0
                    fprintf(fid, '%s\n', 'res_1_given2_3_beta = S_1(ModelStructure.m+1, ModelStructure.res_1_given2_3_idx) / S_1(ModelStructure.res_1_given2_3_idx,ModelStructure.res_1_given2_3_idx) ;');
                    fprintf(fid, '%s\n', 'res_1_given2_3_var = S_1(ModelStructure.imp_1_given2_3_idx,ModelStructure.imp_1_given2_3_idx) - res_1_given2_3_beta* S_1(ModelStructure.res_1_given2_3_idx,ModelStructure.res_1_given2_3_idx)*res_1_given2_3_beta'';');
                    fprintf(fid, '%s\n', 'CurrentZ(ModelStructure.MISSING_1,1) = RESIDUALS(ModelStructure.MISSING_1,ModelStructure.res_1_given2_3_idx)*res_1_given2_3_beta'' + sqrt(res_1_given2_3_var)*randn(sum(ModelStructure.MISSING_1),1, ''gpuArray'') + OriginalData.Xz(ModelStructure.MISSING_1,:)*Bz(:,1);');
                    ModelStructure.MISSING_1=MISSING_1;
                    ModelStructure.res_1_given2_3_idx=res_1_given2_3_idx;
                    ModelStructure.imp_1_given2_3_idx=imp_1_given2_3_idx;
                end;
                if sum(MISSING_2 )>0
                    fprintf(fid, '%s\n', 'res_2_given1_3_beta = S_1(ModelStructure.m+2, ModelStructure.res_2_given1_3_idx) / S_1(ModelStructure.res_2_given1_3_idx,ModelStructure.res_2_given1_3_idx) ;');
                    fprintf(fid, '%s\n', 'res_2_given1_3_var = S_1(ModelStructure.imp_2_given1_3_idx,ModelStructure.imp_2_given1_3_idx) - res_2_given1_3_beta* S_1(ModelStructure.res_2_given1_3_idx,ModelStructure.res_2_given1_3_idx)*res_2_given1_3_beta'';');
                    fprintf(fid, '%s\n', 'CurrentZ(ModelStructure.MISSING_2,2) = RESIDUALS(ModelStructure.MISSING_2,ModelStructure.res_2_given1_3_idx)*res_2_given1_3_beta'' + sqrt(res_2_given1_3_var )*randn(sum(ModelStructure.MISSING_2),1, ''gpuArray'') + OriginalData.Xz(ModelStructure.MISSING_2,:)*Bz(:,2);');
                    ModelStructure.MISSING_2=MISSING_2;
                    ModelStructure.res_2_given1_3_idx=res_2_given1_3_idx;
                    ModelStructure.imp_2_given1_3_idx=imp_2_given1_3_idx;
                end;
                if sum(MISSING_3 )>0
                    fprintf(fid, '%s\n', 'res_3_given1_2_beta = S_1(ModelStructure.imp_3_given1_2_idx, ModelStructure.res_3_given1_2_idx) / S_1(ModelStructure.res_3_given1_2_idx,ModelStructure.res_3_given1_2_idx) ;');
                    fprintf(fid, '%s\n', 'res_3_given1_2_var = S_1(ModelStructure.imp_3_given1_2_idx,ModelStructure.imp_3_given1_2_idx) - res_3_given1_2_beta* S_1(ModelStructure.res_3_given1_2_idx,ModelStructure.res_3_given1_2_idx)*res_3_given1_2_beta'';');
                    fprintf(fid, '%s\n', 'CurrentZ(ModelStructure.MISSING_3,3) = RESIDUALS(ModelStructure.MISSING_3,ModelStructure.res_3_given1_2_idx)*res_3_given1_2_beta'' + sqrt(res_3_given1_2_var )*randn(sum(ModelStructure.MISSING_3),1, ''gpuArray'') + OriginalData.Xz(ModelStructure.MISSING_3,:)*Bz(:,2);');
                    ModelStructure.MISSING_3=MISSING_3;
                    ModelStructure.res_3_given1_2_idx=res_3_given1_2_idx;
                    ModelStructure.imp_3_given1_2_idx=imp_3_given1_2_idx;
                end;
                if sum(MISSING_1_3)>0
                    fprintf(fid, '%s\n', 'res_1_3_given2_beta = S_1(ModelStructure.imp_1_3_given2_idx,ModelStructure.res_1_3_given2_idx)*inv(S_1(ModelStructure.res_1_3_given2_idx,ModelStructure.res_1_3_given2_idx));');
                    fprintf(fid, '%s\n', 'res_1_3_given2_var = S_1(ModelStructure.imp_1_3_given2_idx,ModelStructure.imp_1_3_given2_idx) - res_1_3_given2_beta* S_1(ModelStructure.res_1_3_given2_idx,ModelStructure.res_1_3_given2_idx)*res_1_3_given2_beta'';');
                    fprintf(fid, '%s\n', 'CurrentZ(ModelStructure.MISSING_1_3,[1 3]) = RESIDUALS(ModelStructure.MISSING_1_3,ModelStructure.res_1_3_given2_idx)*res_1_3_given2_beta'' + randn(sum(ModelStructure.MISSING_1_3),2, ''gpuArray'')*chol(res_1_3_given2_var , ''lower'')''+ OriginalData.Xz(ModelStructure.MISSING_1_3,:)*Bz(:,[1,3]);');
                    ModelStructure.MISSING_1_3=MISSING_1_3;
                    ModelStructure.res_1_3_given2_idx=res_1_3_given2_idx;
                    ModelStructure.imp_1_3_given2_idx=imp_1_3_given2_idx;
                end;
                if sum(MISSING_1_2)>0
                    fprintf(fid, '%s\n', 'res_1_2_given3_beta = S_1(ModelStructure.imp_1_2_given3_idx,ModelStructure.res_1_2_given3_idx)*inv(S_1(ModelStructure.res_1_2_given3_idx,ModelStructure.res_1_2_given3_idx));');
                    fprintf(fid, '%s\n', 'res_1_2_given3_var = S_1(ModelStructure.imp_1_2_given3_idx,ModelStructure.imp_1_2_given3_idx) - res_1_2_given3_beta* S_1(ModelStructure.res_1_2_given3_idx,ModelStructure.res_1_2_given3_idx)*res_1_2_given3_beta'';');
                    fprintf(fid, '%s\n', 'CurrentZ(ModelStructure.MISSING_1_2,[1 3]) = RESIDUALS(ModelStructure.MISSING_1_2,ModelStructure.res_1_2_given3_idx)*res_1_2_given3_beta'' + randn(sum(ModelStructure.MISSING_1_2),2, ''gpuArray'')*chol(res_1_2_given3_var , ''lower'')''+ OriginalData.Xz(ModelStructure.MISSING_1_2,:)*Bz(:,[1,2]);');
                    ModelStructure.MISSING_1_2=MISSING_1_2;
                    ModelStructure.res_1_2_given3_idx=res_1_2_given3_idx;
                    ModelStructure.imp_1_2_given3_idx=imp_1_2_given3_idx;
                end;
                if sum(MISSING_2_3)>0
                    fprintf(fid, '%s\n', 'res_2_3_given1_beta = S_1(ModelStructure.imp_2_3_given1_idx,ModelStructure.res_2_3_given1_idx)*inv(S_1(ModelStructure.res_2_3_given1_idx,ModelStructure.res_2_3_given1_idx));');
                    fprintf(fid, '%s\n', 'res_2_3_given1_var = S_1(ModelStructure.imp_2_3_given1_idx,ModelStructure.imp_2_3_given1_idx) - res_2_3_given1_beta* S_1(ModelStructure.res_2_3_given1_idx,ModelStructure.res_2_3_given1_idx)*res_2_3_given1_beta'';');
                    fprintf(fid, '%s\n', 'CurrentZ(ModelStructure.MISSING_2_3,[2 3]) = RESIDUALS(ModelStructure.MISSING_2_3,ModelStructure.res_2_3_given1_idx)*res_2_3_given1_beta'' + randn(sum(ModelStructure.MISSING_2_3),2, ''gpuArray'')*chol(res_2_3_given1_var , ''lower'')''+ OriginalData.Xz(ModelStructure.MISSING_2_3,:)*Bz(:,[2,3]);');
                    ModelStructure.MISSING_2_3=MISSING_2_3;
                    ModelStructure.res_2_3_given1_idx=res_2_3_given1_idx;
                    ModelStructure.imp_2_3_given1_idx=imp_2_3_given1_idx;
                end;
            case 2
                if sum(MISSING_1 )>0
                    fprintf(fid, '%s\n', 'res_1_given2_beta = S_1(ModelStructure.imp_1_given2_idx, ModelStructure.res_1_given2_idx) / S_1(ModelStructure.res_1_given2_idx,ModelStructure.res_1_given2_idx) ;');
                    fprintf(fid, '%s\n', 'res_1_given2_var = S_1(ModelStructure.imp_1_given2_idx,ModelStructure.imp_1_given2_idx) - res_1_given2_beta* S_1(ModelStructure.res_1_given2_idx,ModelStructure.res_1_given2_idx)*res_1_given2_beta'';');
                    fprintf(fid, '%s\n', 'CurrentZ(ModelStructure.MISSING_1,1) = RESIDUALS(ModelStructure.MISSING_1,ModelStructure.res_1_given2_idx)*res_1_given2_beta'' + sqrt(res_1_given2_var)*randn(sum(ModelStructure.MISSING_1),1, ''gpuArray'') + OriginalData.Xz(ModelStructure.MISSING_1,:)*Bz(:,1);');
                    ModelStructure.MISSING_1=MISSING_1;
                    ModelStructure.res_1_given2_idx=res_1_given2_idx;
                    ModelStructure.imp_1_given2_idx=imp_1_given2_idx;
                end;
                if sum(MISSING_2 )>0
                    fprintf(fid, '%s\n', 'res_2_given1_beta = S_1(ModelStructure.imp_2_given1_idx, ModelStructure.res_2_given1_idx) / S_1(ModelStructure.res_2_given1_idx,ModelStructure.res_2_given1_idx) ;');
                    fprintf(fid, '%s\n', 'res_2_given1_var = S_1(ModelStructure.imp_2_given1_idx,ModelStructure.imp_2_given1_idx) - res_2_given1_beta* S_1(ModelStructure.res_2_given1_idx,ModelStructure.res_2_given1_idx)*res_2_given1_beta'';');
                    fprintf(fid, '%s\n', 'CurrentZ(ModelStructure.MISSING_2,2) = RESIDUALS(ModelStructure.MISSING_2,ModelStructure.res_2_given1_idx)*res_2_given1_beta'' + sqrt(res_2_given1_var )*randn(sum(ModelStructure.MISSING_2),1, ''gpuArray'') + OriginalData.Xz(ModelStructure.MISSING_2,:)*Bz(:,2);');
                    ModelStructure.MISSING_2=MISSING_2;
                    ModelStructure.res_2_given1_idx=res_2_given1_idx;
                    ModelStructure.imp_2_given1_idx=imp_2_given1_idx;
                end;
        end;
    end;

    fclose(fid);

else
    fid = fopen('my_imputation.m', 'w');
        fprintf(fid, '%s\n', '% automatically generated by my_Configure_Missing_Imputation');
        fprintf(fid, '%s\n', '');
    fclose(fid);
    
end;