function IRF_IV=my_IRF_IV(MyCov,Wc,~, MySwitch)
% IRF_IV=my_IRF_IV(MyCov,Wc,IV, MySwitch)
% chooses how to factor S1 S1'
% Returns vector of impact IRF

switch MySwitch
    case 1
       [b11iSig,b21iSig,SigmaTSigmaTp ]=my_MR_identification(MyCov,Wc);
       SigmaT=chol(SigmaTSigmaTp,'lower');

       IRF_IV= [b11iSig;b21iSig]*SigmaT;
    case 4
       [b11iSig,b21iSig,SigmaTSigmaTp ]=my_MR_identification(MyCov,Wc);
       P=eye(size(SigmaTSigmaTp));
       P=P(:,end:-1:1);
       SigmaT=P*chol(P*SigmaTSigmaTp*P', 'lower')*P';
       if norm(SigmaT*SigmaT' - SigmaTSigmaTp)/norm(SigmaTSigmaTp)>1e-6
            error('Upper triangular decomposition doesn''t work')
       end

       IRF_IV= [b11iSig;b21iSig]*SigmaT;       
    case 2
        [b11iSig,b21iSig,SigmaTSigmaTp ]=my_MR_identification(MyCov,Wc);
        s1 = sqrt(SigmaTSigmaTp(1,1));
        rho_a  = SigmaTSigmaTp(2,1)/s1;
        s2 = sqrt(SigmaTSigmaTp(2,2)-rho_a^2);
        SigmaT = [s1 0 ; rho_a s2];

       IRF_IV= [b11iSig;b21iSig]*SigmaT;
    case 3
        [b11iSig,b21iSig,SigmaTSigmaTp ]=my_MR_identification(MyCov,Wc);
        s2 = sqrt(SigmaTSigmaTp(2,2));
        rho2  = SigmaTSigmaTp(1,2)/s2;
        s1 = sqrt(SigmaTSigmaTp(1,1)-rho2^2);
        SigmaT = [s1 rho2; 0 s2];

       IRF_IV= [b11iSig;b21iSig]*SigmaT;
    otherwise
        error('choose valid option to factor S1xS1'' ');
end
