% Compute IRF in loop
OriginalIdx = 1:(m+mz);
SortedIdx = [CholToIV, setdiff(OriginalIdx, CholToIV)];
RestoreIdx = arrayfun(@(x) find(SortedIdx==x,1), OriginalIdx);

% create reshuffled S_1
tmp_S_1=S_1(SortedIdx,SortedIdx); 

% inverse of Wc-draw is Sigma-analogue
CholSigma=chol(S_1(1:m,1:m))'; % don't reshuffle this 
IV_cov=tmp_S_1( m+(1:mz),1:m); % but reshuffle this ...
Wc_res=tmp_S_1(1:m,1:m);       % ... and reshuffle this 


% j indexes the shock, not the variable
NoError=1;

if DO_IV~=0 && NO_IRF==0
    % add a column of ones to account for the fact that over the shorter sample, the error term may have a non-zero mean
    U=[Y_res(:,1:m), ones(length(Y),1)];
    U=U(~any(isnan(IV),2),:);

    U_estimate=[U_prior; U];
    IV_estimate=[IV_prior; Z];

    nu_T_F=length(U_estimate);
    
    ff=0;
%     return;
    while ff<2 && NoError
        ff=ff+1;
        MyCov=IV_cov;

        try
            if ff==1
                IRF_IV(1:m,:)=my_IRF_IV(MyCov,Wc_res,IV_estimate, abs(WhichChol))*DSGE_Rotate;
            else
                if WhichChol<=0
                    NormDraw = randn(mz,mz);
                    [Rotation,DiagR] = qr(NormDraw);
                    Rotation=Rotation*diag(sign(diag(DiagR)));
                else
                    Rotation = eye(mz);
                end
                IRF_IV(1:m,:)=my_IRF_IV(MyCov,Wc_res,IV_estimate, 4)*Rotation; 
            end
            IRF_IV = IRF_IV(RestoreIdx(1:m),:);
        catch ME
            fprintf(2,[ME.message '\n']);
            NoError=0;
        end
 
            qIV = CholSigma(1:m,1:m)\IRF_IV(1:m,:);
            CholSigma_All=CholSigma;

        if DO_POLICY_RULES==1
            Q=[qIV, null(qIV')];
            A_inverse(:,:,ff)=inv(CholSigma(1:m,1:m)*Q);
        end
        

        if DO_UHLIG_FACTOR==1
            [~, Rot]=my_summed_forecast_error(K, [IRF_IV; zeros((OriginalData.k-1)*m_all,size(IRF_IV,2))], m_all,OriginalData.k,idx_Uhlig_var,min_h_Uhlig,max_h_Uhlig);
            % Reorder variables if needed
            if idx_Uhlig_var~=CholToIV(1)
                RotQ=zeros(mz,mz);
                RotQ(1,(CholToIV==idx_Uhlig_var))= 1;
                tmp_array=setdiff(CholToIV,idx_Uhlig_var);
                for mm=2:mz
                    RotQ(mm,find(CholToIV==tmp_array(mm-1)))= 1;
                end
                Rot=Rot*RotQ;
            end
            IRF_IV=IRF_IV*Rot;
        end

        IdentifiedShocks_IV(:,:,ff)=Y_res(end-(T-1):end,1:m)*(S_1(1:m,1:m)\IRF_IV(1:m,:));
        if DO_HISTORICAL==1
            qIV = CholSigma(1:m,1:m)\IRF_IV(1:m,:);
            Q=[qIV, null(qIV')];
            AllShocks=Y_res(end-(T-1):end,1:m)*(S_1(1:m,1:m)\(CholSigma(1:m,:)*Q));
            for s_idx=1:m
                Theory_VAR(:,s_idx,ff)=eye(m_all,OriginalData.k*m_all)*diag( reshape( (speye((OriginalData.k*m_all)^2)-sparse(kron(OriginalData.k,OriginalData.k)) ) ...
                    \reshape( sparse([CholSigma_All; zeros(m_all*(OriginalData.k-1),m)]*Q(:,s_idx))*sparse([CholSigma_All; zeros(m_all*(OriginalData.k-1),m)]*Q(:,s_idx))',(OriginalData.k*m_all)^2,1), OriginalData.k*m_all,OriginalData.k*m_all) );            
            end
            FEVD(:,:,:,ff)=my_FEVD(K, [CholSigma_All*Q; zeros((OriginalData.k-1)*m_all,m)],m_all,[1 4 8 20]);
            %initialize
            ShockContributions_IV(1,:,:,ff)=[[CholSigma_All; zeros(m_all*(OriginalData.k-1),m)]*Q*0, X(1,1:(m_all*OriginalData.k))', zeros(m_all*OriginalData.k,1)];
            for t_idx=1:T
                ShockContributions_IV(t_idx+1,:,:,ff)=OriginalData.k*squeeze(ShockContributions_IV(t_idx,:,:,ff)) ... %initial conditions
                    +[[CholSigma_All; zeros(m_all*(OriginalData.k-1),m)]*Q*diag(AllShocks(t_idx,:)), ... % new shock
                    zeros(m_all*OriginalData.k,1),[B_all((m_all*OriginalData.k+1):end,:)'*X(t_idx,(m_all*OriginalData.k+1):end)'; zeros(m_all*(OriginalData.k-1),1)]]; % trend/mean
            end
            if norm( abs(sum(squeeze(ShockContributions_IV(2:end,1:m,:,ff)),3)./Y(end-(T-1):end,:))-1,'inf' )>1e-4
                ShockContributions_IV(:,:,:,ff)=NaN;
            end
        end

        IV_Shock{ff,1}=[IRF_IV; zeros(m_all*(OriginalData.k-1), ShockNo)];            

    end

    if NoError
        cc=1;
        for jj=1:ShockNo
            for ff=1:2
                if DO_MR_Normal
                    if ~DY_NORMALIZATION
                        IV_Shock{ff,cc}(:,jj)=IV_Shock{ff,cc}(:,jj)/IV_Shock{ff,cc}(CholToIV(jj),jj);
                    else
                        if Labels{jj}=='G'
                            idx_d_Y=strmatch('DY',upper(Labels),'exact');
                            IV_Shock{ff,cc}(:,jj)=IV_Shock{ff,cc}(:,jj)/(IV_Shock{ff,cc}(CholToIV(jj),jj)+IV_Shock{ff,cc}(idx_d_Y,jj));
                        else
                            IV_Shock{ff,cc}(:,jj)=IV_Shock{ff,cc}(:,jj)/IV_Shock{ff,cc}(CholToIV(jj),jj);
                        end
                    end
                end
                current_R_IV{jj,ff}(:,1, cc)=[eye(m_all), zeros(m_all, (OriginalData.k-1)*m_all)]*IV_Shock{ff,cc}(:,jj);
                for s=2:h+1
                    %accumulated IR or regular IR
                    current_R_IV{jj,ff}(:, s,cc)=[eye(m_all), zeros(m_all, (OriginalData.k-1)*m_all)]*K^(s-1)*IV_Shock{ff,cc}(:,jj);
                end
            end
            if jj>length(DO_IV_CHOL_RES)*(DO_IV_CHOL_RES>0)
                Selection=zeros(size(IV,2),1);
                Selection(jj-length(DO_IV_CHOL_RES)*(DO_IV_CHOL_RES>0))=1;
            end
        end
        if DO_IV_CHOL_RES>0        
            current_CorrFhatFdraw(cc)=corr(reshape(IV_cov(:,[1:(CholToIV(1)-1) CholToIV(1)+1:end]), (m-1)*size(IV,2),1),MyCov(:));
        else
            current_CorrFhatFdraw(cc)=corr(reshape(IV_cov(:,1:m), m*size(IV,2),1),MyCov(:));
        end
        for kk=1:ShockNo
            current_CorrIVChol(cc,kk)=corr(IV_Shock{1}(1: m_all,kk),CholSigma_All(:,kk));
        end
    end
else
    CholSigma_All=CholSigma;
end

if DO_CHOL && NoError
    % do Cholesky for every single variable, extract the right response later
    CholSigma_IRF=CholRotatePre*chol(CholRotatePre'*CholSigma_All*CholSigma_All'*CholRotatePre, 'lower')*CholRotatePre';
    
    for jj=1:m
        %initial impact
        if DO_MR_Normal
            if ~DY_NORMALIZATION
                CholSigma_IRF(:,jj)=CholSigma_IRF(:,jj)/CholSigma_IRF(jj,jj);
            else
                if Labels{jj}=='G'
                    idx_d_Y=strmatch('DY',upper(Labels),'exact');
                    CholSigma_IRF(:,jj)=CholSigma_IRF(:,jj)/(CholSigma_IRF(jj,jj)+CholSigma_IRF(idx_d_Y,jj));
                else
                    CholSigma_IRF(:,jj)=CholSigma_IRF(:,jj)/CholSigma_IRF(jj,jj);
                end
            end
        end
        shock=[CholSigma_IRF(:,jj); zeros(m_all*(OriginalData.k-1), 1)];
        current_R{jj}(:,1)=[eye(m_all), zeros(m_all, (OriginalData.k-1)*m_all)]*shock;
        for s=2:h+1
            %accumulated IR or regular IR
            current_R{jj}(:, s)=[eye(m_all), zeros(m_all, (OriginalData.k-1)*m_all)]*K^(s-1)*shock;
        end
    end
end