function [a11iSig,a21iSig,SigmaTSigmaTp ]=my_MR_identification(MyCov,Wc)
% Uses the Mertens-Raven code for IV-based identification

%the covariance between proxies and eps_st is Phi. Phi B' is the covariance of the proxies with the observed
%residuals, i.e. the variance of interest
Phib = MyCov;
mz=size(MyCov,1);
Phib11  = Phib(1:mz,1:mz);
Phib21  = Phib(1:mz,mz+1:size(MyCov,2));
kappa = (Phib11\Phib21)';             
Sig11   = Wc(1:mz,1:mz);
Sig21   = Wc(mz+1:size(MyCov,2),1:mz);
Sig22   = Wc(mz+1:size(MyCov,2),mz+1:size(MyCov,2));
ZZp     = kappa*Sig11*kappa'-(Sig21*kappa'+kappa*Sig21')+Sig22; 
a12a12p = (Sig21- kappa*Sig11)'*(ZZp\(Sig21- kappa*Sig11));
a11a11p = Sig11-a12a12p; 
a22a22p = Sig22+kappa*(a12a12p-Sig11)*kappa';
a12ia22   = ((Sig21- kappa*Sig11)'+a12a12p*kappa')/(a22a22p'); 
a11iSig = inv( eye(mz)-a12ia22*kappa );
a21iSig = kappa/(eye(mz)-a12ia22*kappa); 

SigmaTSigmaTp =( eye(mz)-a12ia22*kappa ) * a11a11p * ( eye(mz)-a12ia22*kappa )'; 