close all;

if ~exist('GraphFolder','var')
    GraphFolder='Graphs';
end

DO_CHOL = false;

%% Compute IRFs?
if NO_IRF~=1
    %Also: Other IRFs are now still needed.
    if isnan(R_IV{1,1}(1)) % if this is empty, it must mean that the IRFs have not been computed
        
        for dd=1:DD %size(mat_draws.B,1)
            % 1) Reconstruct Wc, B/K, then call "my_IRF_loop_v8"
            Bc=reshape(mat_draws.B(dd,1:NoParamsC*m),NoParamsC,m);
            Bz=reshape(mat_draws.B(dd,NoParamsC*m+1:NoParamsBeta0),NoXz,mz);
            S_1=reshape(mat_draws.V(dd,:),m+mz,m+mz);
        
            K_core=[reshape(Bc(1:m*OriginalData.k, :)', m, m*OriginalData.k); eye((OriginalData.k-1)*m), zeros((OriginalData.k-1)*m, m)];

            K=K_core;
            B_all=Bc;

            Y_res=Y-Xy*Bc;      
            
            if ispc
                Y_res = gather(Y_res);
                K = gather(K);
                K_hat = gather(K_hat);
            else
                try 
                    if existsOnGPU(Y_res)
                        % convert from GPU array to CPU
                        Y_res=gather(Y_res);
                        K = gather(K);
                        K_hat = gather(K_hat);
                    end
                end
            end
            run my_IRF_loop_v8;
            
            % 2) Save policy rule input
            for ff=1:2
                if DO_POLICY_RULES==1
                    if d>NoBurnIns
                          mat_draws.A_inverse((d-NoBurnIns-1)+1,:,:,ff)=reshape(A_inverse(:,:,ff),[1,m,m]);
                    end
                end
            end
            
            % 3) Save results
                for ff=1:2
                    if DO_POLICY_RULES==1
                        mat_draws.A_inverse((dd-1)+1,:,:,ff)=reshape(A_inverse(:,:,ff),[1,m,m]);
                    end

                    if DO_IV~=0
                        historical_draws.R_IdentifiedShocks(:,:,dd,ff)=IdentifiedShocks_IV(:,:,ff);
                    end
                end
                if d>NoBurnIns
                    for jj=1:ShockNo
                        for ff=1:2
                            R_IV{jj,ff}(1:m_all, :,(dd-1)+1)=current_R_IV{jj,ff}(:,:, :);
                        end
                    end
                    if DO_CHOL
                        if DO_IV~=0
                            CorrFhatFdraw((dd-1)+1)=current_CorrFhatFdraw(:);
                            CorrIVChol((dd-1)+1,:)=current_CorrIVChol(:,:);
                        end
                        for jj=1:m
                            R{jj}(1:m_all,:, dd)=current_R{jj}(:,:);
                        end
                    end
                end
                
            if DO_DISPLAY
                if NoError
                    fprintf('.');
                else
                    fprintf('x');
                end
                if mod(dd, 100)==0
                    fprintf('%1.2fpc', 100*(dd)/DD);
                    fprintf('\n');
                end
            end
        end
        
        % 4) Compute MLE IRF
        S_0=S_posterior(myBy,myBz);
        Wc=S_0(1:m,1:m);
        K=K_hat;
        IV_cov=S_0(m+(1:mz),1:m);
        run my_IRF_loop_v8

        if DO_IV~=0
            for jj=1:ShockNo
                R_IV_MLE{jj}(:, :)=mean(current_R_IV{jj,2}(:,:, :),3);
            end
        end
        if DO_CHOL    
            for jj=1:m
                R_MLE{jj}(:,:)=current_R{jj}(:,:);
            end
        end
        
    end
    
    
    
end

%% Plot and save
if NO_IRF~=1 && usejava('jvm')
    % what is the share of government spending 
    if ~exist('DO_FED', 'var')
        DO_FED=0;
    end
    G_share=0.2;
    
    if ~exist('OriginalData', 'var')
        if isempty(strcmp('k',fieldnames(OriginalData)))
            OriginalData.k=k;
        end
    end
    if ~exist('CI_lvl', 'var')
        CI_lvl=[a a2];
    end
        
    quarter_string=[num2str(floor(quarter(OriginalData.k+1:end)),'%1.0f') num2str( (quarter(OriginalData.k+1:end)-floor(quarter(OriginalData.k+1:end)))*4+1,':%1.0f') ];
    quarter_string=quarter_string(:,3:end);
    NoShocks=size(IV,2)+length(DO_IV_CHOL_RES)*(DO_IV_CHOL_RES>0);

    if DO_IV~=0
        for j=1:NoShocks
            RameyScaling_IV{j,1}=prctile(squeeze(R_IV{j,1}(CholToIV(j),1,:))',50);
            RameyScaling_IV{j,2}=prctile(squeeze(R_IV{j,2}(CholToIV(j),1,:))',50);
        end
    end
    %%
    close(figure(11));
    if DO_IV~=0
       NoPlots=NoShocks;
    else
       NoPlots=1;
    end
    %% Add variables of interest that are linear combinations of included variables
    % Real rate
    if (~isempty(strmatch('TB3',upper(Labels),'exact')) || ~isempty(strmatch('FFR',upper(Labels),'exact')) ) && ~isempty(strmatch('INF',upper(Labels),'exact')) & isempty(strmatch('Real rate',Labels,'exact'))
        for j=1:NoPlots
            if ~isempty(strmatch('TB3',upper(Labels),'exact'))
                i_Y=strmatch('TB3',upper(Labels),'exact');
            else
                i_Y=strmatch('FFR',upper(Labels),'exact');
            end
            i_H=strmatch('INF',upper(Labels),'exact');
            if DO_IV~=0
                R_IV{j,1}(end+1,1:h,:)=R_IV{j,1}(i_Y,1:h,:)-R_IV{j,1}(i_H,2:(h+1),:);
                R_IV{j,2}(end+1,1:h,:)=R_IV{j,2}(i_Y,1:h,:)-R_IV{j,2}(i_H,2:(h+1),:);
            end
            if DO_CHOL
                R{CholToIV(j)}(end+1,1:h,:)=R{CholToIV(j)}(i_Y,1:h,:)-R{CholToIV(j)}(i_H,2:(h+1),:);
            end
        end
        Labels=[Labels(:); 'Real rate'];
        Units=[Units(:); 'p.p.'];   
        m_all=m_all+1;
    end
    
    FirstColor=[0 0 1];
    SecondColor=[1 0 0];
    ThirdColor=[0 0.5 0];

    for j=1:NoPlots
        AddTerm='';
        if j>1
            if isequal(CholToIV(j),CholToIV(j-1))
                AddTerm=num2str(j);
            end
        end

        close all;
        if DO_CHOL
            if WHICH_DATA==3
                RameyScaling{j}=-max(prctile(squeeze(R{CholToIV(j)}(CholToIV(j) ,:,:))',50));
            else
                if WHICH_DATA~=1
                    RameyScaling{j}=prctile(squeeze(R{CholToIV(j)}(CholToIV(j) ,1,:))',50);
                else
                    RameyScaling{j}=max(prctile(squeeze(R{CholToIV(j)}(CholToIV(j) ,:,:))',50));
                end
            end
        end
        if DO_MR_Normal
            RameyScaling{j}=1;
            RameyScaling_IV{j,1}=1;
            RameyScaling_IV{j,2}=1;
        end
        for i=1:m_all
            if i<=length(PICK_VARS)
                % Take account of variables expressed relative to GDP
                if ~isempty(strfind(PICK_VARS{i},'_Y'))
                    ADD_Y=1;
                else
                    ADD_Y=0;
                end
            else
                ADD_Y=0;
            end
            if DO_IV~=0 
                if ADD_Y
                    YData=prctile(squeeze(R_IV{j,1}(i,1:h,:)+R_IV{j,1}(strcmp('Y',Labels),1:h,:)*ADD_Y)',[(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)])/RameyScaling_IV{j,1};
                else
                    YData=prctile(squeeze(R_IV{j,1}(i,1:h,:))',[(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)])/RameyScaling_IV{j,1};
                end
                hndl=my_make_IRF(h-1,YData','DoAreaPlot', true, 'YLabel',Units{i},'XLabel','quarters');
                hold on;
            else
                figure;
                YData=0;
            end
            plot([0 (h-1)], [0 0],'-k');
            hold on;
            title([Labels{i} ' to unit shock in ' Labels{CholToIV(j)}]);
            if WHICH_DATA==-1
                xlabel('months');
            else
                xlabel('quarters');
            end
            ylabel(Units{i});
            grid on;
            set(findall(gcf,'type','axes'),'fontsize',18);
            set(findall(gcf,'type','text'),'fontSize',18);      
            if min(ylim)<0 && max(ylim)>0
                plot([0 h-1], [0 0], '-k');
            end
            if DO_PRINT 
                print('-depsc', [GraphFolder '/IRF_' regexprep( Labels{i}, ' ', '_') '_' regexprep( Labels{CholToIV(j)}, ' ', '_') AddTerm VAR_suffix 'IV_simple.eps']);
            end            


            if DO_CHOL
                if DO_IV~=0
                    delete(hndl);
                end
                hndl=plot(0:1:(h-1), prctile(squeeze(R{CholToIV(j)}(i,1:h,:)+R{CholToIV(j)}(strcmp('Y',Labels),1:h,:)*ADD_Y)',[(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)])/RameyScaling{j});
                set(hndl, {'LineWidth'}, {1;2;3;2;1},{'LineStyle'}, {'-';'-';'-';'-';'-'}, {'Color'}, {ThirdColor;ThirdColor;ThirdColor;ThirdColor;ThirdColor});
                axis tight;
                pause(0.5);
                if DO_PRINT 
                    print('-depsc', [GraphFolder '/IRF_' regexprep( Labels{i}, ' ', '_') '_' regexprep( Labels{CholToIV(j)}, ' ', '_') AddTerm VAR_suffix '.eps']);
                end
            end
            
            if DO_PRINT
                if isequal(Labels{i}, 'Y')
                    close(gcf);
                    YData=prctile(squeeze(R_IV{j,1}(i,1:h,:)-G_share*R_IV{j,1}(strcmp(Labels,'G'),1:h,:))',[(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)])/RameyScaling_IV{j,1};

                    [~, my_fig]=my_make_IRF(h-1,YData','DoAreaPlot', true, 'YLabel',Units{i},'XLabel','quarters');
                    title(['Private Output to ' Labels{CholToIV(j)} ]);
                    plot([0 (h-1)], [0 0],'-k');
                    if DO_PRINT
                        print('-depsc', [GraphFolder '/IRF_PrivY_' regexprep( Labels{CholToIV(j)}, ' ', '_') AddTerm VAR_suffix 'IV_simple.eps']);                    
                    end 

                    if isequal(Labels{CholToIV(j)}, 'G')
                        close(my_fig);
                        YData=prctile(squeeze(cumsum(repmat(0.99.^(0:h-1),[1,1,DD]).*R_IV{j,1}(i,1:h,:),2)./ ...
                            cumsum(repmat(0.99.^(0:h-1),[1,1,DD]).*G_share.*R_IV{j,1}(strcmp(Labels,'G'),1:h,:),2))',[(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)]);

                        [~, my_fig]=my_make_IRF(h-1,YData','DoAreaPlot', true, 'YLabel','','XLabel','quarters');
                        title(['PDV Multiplier to ' Labels{CholToIV(j)} ]);
                        plot([0 (h-1)], [0 0],'-k');
                        if DO_PRINT
                            print('-depsc', [GraphFolder '/IRF_Mult_' regexprep( Labels{CholToIV(j)}, ' ', '_') AddTerm VAR_suffix 'IV_simple.eps']);                    
                        end 

                        close(my_fig);
                        YData=prctile(squeeze(cumsum(repmat(0.99.^(0:h-1),[1,1,DD]).*(R_IV{j,1}(i,1:h,:)-G_share.*R_IV{j,1}(strcmp(Labels,'G'),1:h,:)),2)./ ...
                            cumsum(repmat(0.99.^(0:h-1),[1,1,DD]).*G_share.*R_IV{j,1}(strcmp(Labels,'G'),1:h,:),2))',[(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)]);

                        [~, my_fig]=my_make_IRF(h-1,YData','DoAreaPlot', true, 'YLabel','','XLabel','quarters');
                        title(['PDV Multiplier to ' Labels{CholToIV(j)} ]);
                        plot([0 (h-1)], [0 0],'-k');
                        if DO_PRINT
                            print('-depsc', [GraphFolder '/IRF_PrivMult_' regexprep( Labels{CholToIV(j)}, ' ', '_') AddTerm VAR_suffix 'IV_simple.eps']);                    
                        end 
                    
                    end
                    if isequal(Labels{CholToIV(j)}, 'tax')
                        close(my_fig);
                        YData=prctile(squeeze(cumsum(-repmat(0.99.^(0:h-1),[1,1,DD]).*R_IV{j,1}(i,1:h,:),2)./ ...
                            cumsum(repmat(0.99.^(0:h-1),[1,1,DD]).*0.1.*R_IV{j,1}(strcmp(Labels,'tax'),1:h,:),2))',[(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)]);

                        [~, my_fig]=my_make_IRF(h-1,YData','DoAreaPlot', true, 'YLabel','','XLabel','quarters');
                        title(['PDV Multiplier to ' Labels{CholToIV(j)} ]);
                        plot([0 (h-1)], [0 0],'-k');
                        if DO_PRINT
                            print('-depsc', [GraphFolder '/IRF_Mult_' regexprep( Labels{CholToIV(j)}, ' ', '_') AddTerm VAR_suffix 'IV_simple.eps']);                    
                        end 
                        
                        close(my_fig);
                        YData=prctile(squeeze(cumsum(-repmat(0.99.^(0:h-1),[1,1,DD]).*(R_IV{j,1}(i,1:h,:)-G_share*R_IV{j,1}(strcmp(Labels,'G'),1:h,:)),2)./ ...
                            cumsum(repmat(0.99.^(0:h-1),[1,1,DD]).*0.1.*R_IV{j,1}(strcmp(Labels,'tax'),1:h,:),2))',[(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)]);

                        [~, my_fig]=my_make_IRF(h-1,YData','DoAreaPlot', true, 'YLabel','','XLabel','quarters');
                        title(['PDV Multiplier to ' Labels{CholToIV(j)} ]);
                        plot([0 (h-1)], [0 0],'-k');
                        if DO_PRINT
                            print('-depsc', [GraphFolder '/IRF_PrivMult_' regexprep( Labels{CholToIV(j)}, ' ', '_') AddTerm VAR_suffix 'IV_simple.eps']);                    
                        end 
                    end
                end
            end
            

        end
    end

    %%
    if DO_IV~=0
        my_fid=fopen([GraphFolder '/Diagnostics' VAR_suffix '.tex'], 'w');
        fprintf(my_fid,'%s \n',['1st stage sampling: corr$[\hat F, F^{(i)}]$ &' num2str(prctile(CorrFhatFdraw,50),'%1.3f') '& (' num2str(prctile(CorrFhatFdraw,(50-CI_lvl(2)/2)), '%1.3f')  ', ' num2str(prctile(CorrFhatFdraw,(50+CI_lvl(2)/2)), '%1.3f')  ') \\']);
        for kk=1:size(IV,2)
            fprintf(my_fid,'%s \n',['IRF identification: corr$[A_{\circ,1}^{\text{IV}}, A_{\circ,1}^{\text{Cholesky}}]$ &' num2str(prctile(CorrIVChol(:,kk),50),'%1.3f') '& (' num2str(prctile(CorrIVChol(:,kk),(50-CI_lvl(2)/2)), '%1.3f')  ', ' num2str(prctile(CorrIVChol(:,kk),(50+CI_lvl(2)/2)), '%1.3f')  ') \\']); 
        end
        fclose(my_fid);
    end

end

    if MY_PRIOR==2
        DO_THIS_LOOP=false;
        if isstruct(historical_draws)
           DO_THIS_LOOP= isempty(find(strcmp(fieldnames(historical_draws), 'KalmanShocks'))) || ~exist('DSGE_IRF', 'var') ;
        else
           DO_THIS_LOOP= isempty(whos(historical_draws, 'KalmanShocks')) || ~exist('DSGE_IRF', 'var') ;
        
        end

	% Compute historical shocks
        if DO_THIS_LOOP
	    % initialize
            historical_draws.KalmanShocks=NaN(T,mz,DD);
            ShockCorr=NaN(DD,mz);
            DSGE_IRF=NaN(m,h+1,mz,DD); % save DSGE IRF for identified shocks
            DSGE_Q=NaN(m,m,DD); % save DSGE rotations for DN-S type of identification
            % now loop over draws
            for d=1:DD
                my_draw=mat_draws.S(d,:)';
                if isequal(ModFile(end-3:end),'.mod')
                    evalc(['run ' ModFile(1:end-4) '.m']);
                else
                    evalc(['run ' ModFile '.m']);
                end
                [DSGE_IRF(:,:,:,d), Coeff, ModelStructure, States]= my_DSGE_IRF(h, oo_ ,M_,CoreList, InstrumentList, ForecastErrIdx, ModelStructure,CholToIV);
                
                Shocks_smoother=Koopman_KF_KS_fast(YY', Coeff, ModelStructure, States,CoreList, ShockIndex, 0, 0);
                for mm=1:mz
                   historical_draws.KalmanShocks(:,mm,d)=reshape(Shocks_smoother(CholToIV(mm),OriginalData.k+2:end),1,[])';
                   ShockCorr(d,mm)=nancorr(Shocks_smoother(CholToIV(mm),OriginalData.k+2:end)', historical_draws.R_IdentifiedShocks(:,mm,d,1));
                end
                if DO_DISPLAY
                    if NoError
                        fprintf('.');
                    else
                        fprintf('x');
                    end
                    if mod(d, 100)==0;
                        fprintf('%1.2fpc', 100*(d)/DD);
                        fprintf('\n');
                    end
                end

            end
        end
        if usejava('jvm') 
            IV_Shock_Corr=NaN(mz,DD,2);
            for j=1:mz
                if NO_IRF~=1
                    for i=1:m
                        Plot_DSGE_IRF=prctile(squeeze(DSGE_IRF(i,:,j,:))', [(100-CI_lvl([2 1]))/2 50 100-(100-CI_lvl)/2]');
                        YData=prctile(squeeze(R_IV{j,1}(i,1:h,:))',[(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)])/RameyScaling_IV{j,1};
                        [~, my_fig]=my_make_IRF(h-1,YData','DoAreaPlot', true, 'YLabel',Units{i},'XLabel','quarters');
                        hndl=my_make_IRF(h-1,Plot_DSGE_IRF(:,1:h)','DoOverLap', my_fig.Number, 'YLabel',Units(i),'XLabel','');
                        title([Labels{i} ' to ' Labels{CholToIV(j)} ]);
                        plot([0 (h-1)], [0 0],'-b');
                        if DO_PRINT
                            print('-depsc', [GraphFolder '/DSGE_IRF_' regexprep( Labels{i}, ' ', '_') '_' regexprep( Labels{CholToIV(j)}, ' ', '_') AddTerm VAR_suffix '.eps']);                    
                        end 
                        if isequal(Labels{CholToIV(j)}, 'G')
                            close(my_fig);
                            G_Plot_DSGE_IRF=prctile(squeeze(DSGE_IRF(j,:,j,:))', 50);
                            G_YData=prctile(squeeze(R_IV{j,1}(j,1:h,:))',50)/RameyScaling_IV{j,1};
                            [~, my_fig]=my_make_IRF(h-1,YData','DoAreaPlot', true, 'YLabel',Units{i},'XLabel','quarters');
                            hndl=my_make_IRF(h-1,Plot_DSGE_IRF(:,1:h)'*sum(G_YData(1,1:h))/sum(G_Plot_DSGE_IRF(1,1:h)),'DoOverLap', my_fig.Number, 'YLabel',Units(i),'XLabel','');
                            title([Labels{i} ' to ' Labels{CholToIV(j)} ]);
                            plot([0 (h-1)], [0 0],'-b');
                            if DO_PRINT
                                print('-depsc', [GraphFolder '/DSGE_IRF_' regexprep( Labels{i}, ' ', '_') '_' regexprep( Labels{CholToIV(j)}, ' ', '_') AddTerm VAR_suffix '_resc.eps']);                    
                            end 
                        end
                        if isequal(Labels{i}, 'Y')
                            close(my_fig);
                            Plot_DSGE_IRF=prctile(squeeze(DSGE_IRF(i,:,j,:)-G_share*DSGE_IRF(strcmp(Labels,'G'),:,j,:))', [(100-CI_lvl([2 1]))/2 50 100-(100-CI_lvl)/2]');

                            YData=prctile(squeeze(R_IV{j,1}(i,1:h,:)-G_share*R_IV{j,1}(strcmp(Labels,'G'),1:h,:))',[(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)])/RameyScaling_IV{j,1};

                            [~, my_fig]=my_make_IRF(h-1,YData','DoAreaPlot', true, 'YLabel',Units{i},'XLabel','quarters');
                            hndl=my_make_IRF(h-1,Plot_DSGE_IRF(:,1:h)','DoOverLap', my_fig.Number, 'YLabel',Units(i),'XLabel','');
                            title(['Private Output to ' Labels{CholToIV(j)} ]);
                            plot([0 (h-1)], [0 0],'-b');
                            if DO_PRINT
                                print('-depsc', [GraphFolder '/DSGE_IRF_PrivY_' regexprep( Labels{CholToIV(j)}, ' ', '_') AddTerm VAR_suffix '.eps']);                    
                            end 

                            if isequal(Labels{CholToIV(j)}, 'G')
                                close(my_fig);
                                Plot_DSGE_IRF=prctile(squeeze(cumsum(repmat(0.99.^(0:h-1),[1,1,1,DD]).*DSGE_IRF(i,1:h,j,:),2)./ ...
                                    cumsum(repmat(0.99.^(0:h-1),[1,1,1,DD]).*G_share.*DSGE_IRF(strcmp(Labels,'G'),1:h,j,:),2))',[(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)]);

                                YData=prctile(squeeze(cumsum(repmat(0.99.^(0:h-1),[1,1,DD]).*R_IV{j,1}(i,1:h,:),2)./ ...
                                    cumsum(repmat(0.99.^(0:h-1),[1,1,DD]).*G_share.*R_IV{j,1}(strcmp(Labels,'G'),1:h,:),2))',[(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)]);

                                [~, my_fig]=my_make_IRF(h-1,YData','DoAreaPlot', true, 'YLabel','','XLabel','quarters');
                                hndl=my_make_IRF(h-1,Plot_DSGE_IRF(:,1:h)','DoOverLap', my_fig.Number, 'YLabel',Units(i),'XLabel','');
                                title(['PDV Multiplier to ' Labels{CholToIV(j)} ]);
                                plot([0 (h-1)], [0 0],'-b');
                                if DO_PRINT
                                    print('-depsc', [GraphFolder '/DSGE_IRF_Mult_' regexprep( Labels{CholToIV(j)}, ' ', '_') AddTerm VAR_suffix '.eps']);                    
                                end 
                            end
                            if isequal(Labels{CholToIV(j)}, 'tax')
                                close(my_fig);
                                Plot_DSGE_IRF=prctile(squeeze(cumsum(-repmat(0.99.^(0:h-1),[1,1,1,DD]).*DSGE_IRF(i,1:h,j,:),2)./ ...
                                    cumsum(repmat(0.99.^(0:h-1),[1,1,1,DD]).*0.1.*DSGE_IRF(strcmp(Labels,'tax'),1:h,j,:),2))',[(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)]);

                                YData=prctile(squeeze(cumsum(-repmat(0.99.^(0:h-1),[1,1,DD]).*R_IV{j,1}(i,1:h,:),2)./ ...
                                    cumsum(repmat(0.99.^(0:h-1),[1,1,DD]).*0.1.*R_IV{j,1}(strcmp(Labels,'tax'),1:h,:),2))',[(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)]);

                                [~, my_fig]=my_make_IRF(h-1,YData','DoAreaPlot', true, 'YLabel','','XLabel','quarters');
                                hndl=my_make_IRF(h-1,Plot_DSGE_IRF(:,1:h)','DoOverLap', my_fig.Number, 'YLabel',Units(i),'XLabel','');
                                title(['PDV Multiplier to ' Labels{CholToIV(j)} ]);
                                plot([0 (h-1)], [0 0],'-b');
                                if DO_PRINT
                                    print('-depsc', [GraphFolder '/DSGE_IRF_Mult_' regexprep( Labels{CholToIV(j)}, ' ', '_') AddTerm VAR_suffix '.eps']);                    
                                end 
                            end
                        end
                        % Real rate
                        if isequal(upper(Labels{CholToIV(j)}), 'FFR')
                            if ~isempty(strmatch('TB3',upper(Labels),'exact'))
                                i_Y=strmatch('TB3',upper(Labels),'exact');
                            else
                                i_Y=strmatch('FFR',upper(Labels),'exact');
                            end
                            i_H=strmatch('INF',upper(Labels),'exact');
                            close(my_fig);
                            Plot_DSGE_IRF=prctile(squeeze(DSGE_IRF(i_Y,1:h,j,:)-DSGE_IRF(i_H,2:h+1,j,:))', [(100-CI_lvl([2 1]))/2 50 100-(100-CI_lvl)/2]');

                            YData=prctile(squeeze(R_IV{j,1}(i_Y,1:h,:)-R_IV{j,1}(i_H,2:h+1,:))',[(50-CI_lvl(2)/2) (50-CI_lvl(1)/2) 50 (50+CI_lvl(1)/2) (50+CI_lvl(2)/2)])/RameyScaling_IV{j,1};

                            [~, my_fig]=my_make_IRF(h-1,YData','DoAreaPlot', true, 'YLabel','','XLabel','quarters');
                            hndl=my_make_IRF(h-1,Plot_DSGE_IRF(:,1:h)','DoOverLap', my_fig.Number, 'YLabel',Units(i),'XLabel','');
                            title(['Real rate to ' Labels{CholToIV(j)} ]);
                            plot([0 (h-1)], [0 0],'-b');
                            if DO_PRINT
                                print('-depsc', [GraphFolder '/DSGE_IRF_real_rate_' regexprep( Labels{CholToIV(j)}, ' ', '_') AddTerm VAR_suffix '.eps']);                    
                            end 

                        end                
                    end
                end
                for dd=1:DD
                    try
                        IV_Shock_Corr(j,dd,1)=corr(squeeze(historical_draws.R_IdentifiedShocks( (OriginalData.IV(:,j)~=0),j,dd,1)),OriginalData.IV( (OriginalData.IV(:,j)~=0),j));
                    end
                    tmp_shocks=squeeze(historical_draws.KalmanShocks( : ,j,dd));
                    IV_Shock_Corr(j,dd,2)=corr(tmp_shocks( OriginalData.IV(:,j)~=0),OriginalData.IV( (OriginalData.IV(:,j)~=0),j));
                end
            end
            effective_quarter=quarter(find(isnan(quarter), 1,'last')+OriginalData.k+1:end);
            my_periods={ 1:length(effective_quarter), find(effective_quarter>=1970 & effective_quarter<1990) , ...
                find(~isnan(effective_quarter) & effective_quarter<1970)  , find(effective_quarter>=1990)};
            for pp=1:size(my_periods,2)
                if pp>1
                   ZoomSuffix=num2str(floor(effective_quarter(min(my_periods{pp}))));
                else
                   ZoomSuffix='';
                end
                for mm=1:mz
                    % Plot historical shocks
                    if ~isempty(my_periods{pp})
                        PlotDataVAR=prctile(squeeze(historical_draws.R_IdentifiedShocks(my_periods{pp}  ,mm,:,1))',[(100-CI_lvl([2 1]))/2 50 100-(100-CI_lvl)/2]')';
                        PlotDataVAR=(PlotDataVAR-mean(PlotDataVAR(:,3))); %/std(PlotDataVAR(:,3));
                        PlotDataDSGE=prctile(squeeze(historical_draws.KalmanShocks(my_periods{pp} ,mm,:))',[(100-CI_lvl([2 1]))/2 50 100-(100-CI_lvl)/2]')';
                        PlotDataDSGE=(PlotDataDSGE-mean(PlotDataDSGE(:,3))); %/std(PlotDataDSGE(:,3));
                        my_ylim=[floor(min([PlotDataVAR(:);PlotDataDSGE(:)])), ceil(max([PlotDataVAR(:);PlotDataDSGE(:)]))];
                        [hndl my_fig]=my_make_IRF(effective_quarter(my_periods{pp}),PlotDataVAR,'DoStretched', true, 'DoAreaPlot', true, 'YLabel','standard deviations','XLabel','');
                        hndl=my_make_IRF(effective_quarter(my_periods{pp}),PlotDataDSGE,'DoOverLap', my_fig.Number, 'YLabel','standard deviations','XLabel','');      
                        axis([effective_quarter(my_periods{pp}(1)) effective_quarter(my_periods{pp}(end)) my_ylim]);
                        if pp==1
                            title([Labels{CholToIV(mm)} ' shock correlation = ' num2str(median(ShockCorr(:,mm)), '%1.2f') ' (' num2str(prctile(ShockCorr(:,mm),50-CI_lvl(2)/2), '%1.2f, ') num2str(prctile(ShockCorr(:,mm),50+CI_lvl(2)/2), '%1.2f ') ')']);
                        else
                            title([Labels{CholToIV(mm)} ' shock correlation = ' num2str(corr(PlotDataVAR(:,3), PlotDataDSGE(:,3)), '%1.2f') ]);
                        end
                        if DO_PRINT 
                            set(findall(my_fig, 'Type', 'Text'),'FontWeight', 'Normal');
                            print('-depsc', [GraphFolder '/HistShocks' VAR_suffix '-' num2str(mm) ZoomSuffix '.eps']);
                        end
                        % if ranges are too different, make a rescaled plot
                        if (max(PlotDataDSGE(:,end))-min(PlotDataDSGE(:,1)))> 3*(max(PlotDataVAR(:,end))-min(PlotDataVAR(:,1))) ...
                                || (max(PlotDataDSGE(:,end))-min(PlotDataDSGE(:,1)))/3<(max(PlotDataVAR(:,end))-min(PlotDataVAR(:,1)))
                            close(my_fig.Number);
                            PlotDataDSGE=PlotDataDSGE*(max(PlotDataVAR(:,end))-min(PlotDataVAR(:,1))) /(max(PlotDataDSGE(:,end))-min(PlotDataDSGE(:,1)));
                            my_ylim=[floor(min([PlotDataVAR(:);PlotDataDSGE(:)])), ceil(max([PlotDataVAR(:);PlotDataDSGE(:)]))];
                            [hndl my_fig]=my_make_IRF(effective_quarter(my_periods{pp}),PlotDataVAR,'DoStretched', true, 'DoAreaPlot', true, 'YLabel','standard deviations','XLabel','');
                            hndl=my_make_IRF(effective_quarter(my_periods{pp}),PlotDataDSGE,'DoOverLap', my_fig.Number, 'YLabel','standard deviations (rescaled)','XLabel','');      
                            axis([effective_quarter(my_periods{pp}(1)) effective_quarter(my_periods{pp}(end)) my_ylim]);
                            if pp==1
                                title([Labels{CholToIV(mm)} ' shock correlation = ' num2str(median(ShockCorr(:,mm)), '%1.2f') ' (' num2str(prctile(ShockCorr(:,mm),50-CI_lvl(2)/2), '%1.2f, ') num2str(prctile(ShockCorr(:,mm),50+CI_lvl(2)/2), '%1.2f ') ')']);
                            else
                                title([Labels{CholToIV(mm)} ' shock correlation = ' num2str(corr(PlotDataVAR(:,3), PlotDataDSGE(:,3)), '%1.2f') ]);
                            end
                            if DO_PRINT 
                                print('-depsc', [GraphFolder '/HistShocksScaled' VAR_suffix '-' num2str(mm) ZoomSuffix '.eps']);
                            end
                        end
                    end
                end
            end
            disp('shock correlations: DSGE vs VAR?');
            display(prctile(ShockCorr(:,:),[50 5 95])');
            disp('correlation of shock with instrument: VAR');
            display(prctile(squeeze(IV_Shock_Corr(:,:,1))',[50 5 95])');
            disp('correlation of shock with instrument: DSGE');
            display(prctile(squeeze(IV_Shock_Corr(:,:,2))',[50 5 95])');
        end
    end

% end
%%
if DO_POLICY_RULES==1 && usejava('jvm')
    for ff=1:1 % no longer make plot for rule with "certain" variance covariance matrix

        my_fid=fopen([GraphFolder '/Taylor' VAR_suffix '-' num2str(ff) '.tex'], 'w');
        PrintHeader=[' ' ];
        for m_idx=1:m
            PrintHeader=[PrintHeader ' & \multicolumn{1}{c}{' Labels{m_idx} '}'];
        end
        PrintHeader=[PrintHeader ' \\ \hline ' ];
        fprintf(my_fid,'%s \n',PrintHeader);
        fig_all=figure;
        subplot(2,1,1);
        for ss=1:length(CholToIV)
            fig_s=figure;
            Print=[char(Labels{CholToIV(ss)}) ];
            % A^{-1} = [q'; Q'] Chol(Sigma)^{-1}. Thus, row ss recovers rule with shock epsilon(ss) 
            Taylor_Coeffs=squeeze(mat_draws.A_inverse(:,ss,:,ff) ) ./ ...
                            squeeze(-repmat(mat_draws.A_inverse(:,ss,find(strcmp(Labels{CholToIV(ss)},Labels)),ff) ,1,m));

            for m_idx=setdiff(1:m,find(strcmp(Labels{CholToIV(ss)},Labels)))

                % Print on screen
                display(Labels{m_idx});
                PrintHeader=[PrintHeader ' & \multicolumn{1}{c}{' Labels{m_idx} '}'];
                Coeff_Plot=prctile(Taylor_Coeffs(:,m_idx),50+[0 -CI_lvl(2)/2 -CI_lvl(1)/2 CI_lvl(1)/2 CI_lvl(2)/2]);
                figure(fig_all);
                hndl=plot([0.05 0.45]+(ss-1)*m/2+(m_idx-1)/2, Coeff_Plot'*[1,1]);
                hold on;
                plot([0.25 0.25]+(ss-1)*m/2+(m_idx-1)/2, Coeff_Plot([2 5])','-b');
                set(hndl,{'LineWidth'},{3;1;2;2;1},{'Color'},{[0 0 1];[0 0 1];[0 0 1];[0 0 1];[0 0 1]},{'LineStyle'},{'-';'--';'--';'--';'--'});
                hold all

                % Plot
                figure(fig_s);
                hndl=plot([0.05 0.45]+(m_idx-1)/2, Coeff_Plot'*[1,1]);
                hold on;
                plot([0.25 0.25]+(m_idx-1)/2, Coeff_Plot([2 5])','-b');
                set(hndl,{'LineWidth'},{3;1;2;2;1},{'Color'},{[0 0 1];[0 0 1];[0 0 1];[0 0 1];[0 0 1]},{'LineStyle'},{'-';'--';'--';'--';'--'});
                hold all
                Coeff=prctile(Taylor_Coeffs(:,m_idx),50+[0 -CI_lvl(2)/2 CI_lvl(2)/2]);
                Print=[Print char(regexprep(cellstr(num2str(Coeff, '\\& %1.2f (%1.2f, %1.2f) ')), '\\&', '&'))];
            end
            Print=[Print repmat('\\',1,1)];
            display(Print);
            fprintf(my_fid,'%s \n',Print);
            set(gca,'FontSize',20);
            set(gca,'YGrid','on');
            set(gca,'Xtick', 0.25:0.5:(m/2));
            set(gca,'XTicklabel',repmat(char(Labels(1:m)),3,1));
            axis([0 m/2 ylim]);
            if DO_PRINT 
                print('-depsc', [GraphFolder '/Taylor' VAR_suffix '-' Labels{CholToIV(ss)} '-' num2str(ff) '.eps']);
            end
        end
        fclose(my_fid);

        figure(fig_all);
        set(gca,'YGrid','on');
        plot([(1:length(CholToIV)-1)*m/2;(1:length(CholToIV)-1)*m/2],repmat(ylim',1,length(CholToIV)-1),'-k', 'LineWidth',2);
        set(gca,'Xtick', 0.25:0.5:(ss*m/2));
        set(gca,'XTicklabel',repmat(char(Labels(1:m)),3,1));
        axis([0 ss*m/2 ylim]);
        text((0.4:length(CholToIV))*m/2,max(ylim)*ones(1,length(CholToIV))+diff(ylim)/20,Labels(CholToIV), 'FontSize',16);
        if DO_PRINT 
            print('-depsc', [GraphFolder '/Taylor' VAR_suffix '-' num2str(ff) '.eps']);
        end
    end

end

%% Structural parameters?
if MY_PRIOR==2
    TypeLabels=lower(regexprep(PriorStructure.param_type, '_', '. '));
    
    ParamLabels=regexprep(PriorStructure.param_name, '_', '-');
    ParamLabels=regexprep(ParamLabels, '//se-signal', 'Rel. st. dev. IV');
    ParamLabels=regexprep(ParamLabels, '//c-signal', 'Loading IV');
    ParamLabels=regexprep(ParamLabels, 'se', 'st.dev.');
    ParamLabels=regexprep(ParamLabels, 'crho', 'AR(1)-');
    ParamLabels=regexprep(ParamLabels, 'cry', 'Taylor-y');
    ParamLabels=regexprep(ParamLabels, 'crpi', 'Taylor-Infl.');
    ParamLabels=regexprep(ParamLabels, 'cpsi-g', 'G-to-');
    ParamLabels=regexprep(ParamLabels, 'cpsi-s', 'Transf.-to-');
    ParamLabels=regexprep(ParamLabels, 'cpsi-l', 'Tax-to-');
    ParamLabels=regexprep(ParamLabels, 'cr', 'smoothing-');
    ParamLabels=regexprep(ParamLabels, 'csadjcost', 'Adj. cost');
    ParamLabels=regexprep(ParamLabels, 'czcap', 'Util. cost');
    ParamLabels=regexprep(ParamLabels, 'cfc', 'Fixed cost');
    ParamLabels=regexprep(ParamLabels, 'chabb', 'Habit');
    ParamLabels=regexprep(ParamLabels, 'csigl', 'Labor supply ela.');
    ParamLabels=regexprep(ParamLabels, 'cprobp', 'Calvo prices');
    ParamLabels=regexprep(ParamLabels, 'cindp', 'Index. prices');
    ParamLabels=regexprep(ParamLabels, 'cprobw', 'Calvo wages');
    ParamLabels=regexprep(ParamLabels, 'cindw', 'Index. wages');
    ParamLabels=regexprep(ParamLabels, '--', '-');
    ParamLabels=regexprep(ParamLabels, '-a', '-TFP');
    ParamLabels=regexprep(ParamLabels, '-r', '-FFR');
    ParamLabels=regexprep(ParamLabels, '-y', '-GDP');
    ParamLabels=regexprep(ParamLabels, '-b', '-Debt');
    ParamLabels=regexprep(ParamLabels, '-g', '-G');
    ParamLabels=regexprep(ParamLabels, '-ms', '-FFR');
    ParamLabels=regexprep(ParamLabels, '-m', '-FFR');
    ParamLabels=regexprep(ParamLabels, '-s', '-Transf.');
    ParamLabels=regexprep(ParamLabels, '-t-l', '-Tax');
    ParamLabels=regexprep(ParamLabels, '-tl', '-Tax');
    ParamLabels=regexprep(ParamLabels, '-pinf', '-Infl.');

    display('comparing posterior and prior');
    display([char(ParamLabels), num2str(median(mat_draws.S)', '%1.3f ' ), ...
        num2str(prctile(mat_draws.S, 5)', '(%1.3f, ' ), num2str(prctile(mat_draws.S, 95)', '%1.3f) ::' ), ...
        num2str(mean(mat_draws.S)', '%1.3f ' ), num2str(std(mat_draws.S)', ' (%1.3f) :: ' ), ...
        num2str(PriorStructure.prior_m(:), '%1.3f' ), num2str(PriorStructure.prior_s(:), ' (%1.3f) ' ) ]);

    my_fid=fopen([GraphFolder '/Structural' VAR_suffix '.tex'], 'w');
    fprintf(my_fid,'%s \n',['Parameter & Prior type  & Prior mean & (SD) & Mean & (SD) &  Median & (90\% CI) \\ \hline']);
    for p_idx=1:PriorStructure.param_no
        fprintf(my_fid,'%s \n',[ParamLabels{p_idx}  ' & ' TypeLabels{p_idx}  ' & ' num2str(PriorStructure.prior_m(p_idx), '%1.3f' ) ' & ' ...
        num2str(PriorStructure.prior_s(p_idx), ' (%1.3f) ' ) ' & ' ...
        num2str(mean(mat_draws.S(:,p_idx))', '%1.3f ' ) ' & '  num2str(std(mat_draws.S(:,p_idx))', ' (%1.3f) ' ) ' & ' ...
        num2str(median(mat_draws.S(:,p_idx)), '%1.3f ' ), ' & ' ...
        num2str(prctile(mat_draws.S(:,p_idx), 5)', '(%1.3f, ' ), num2str(prctile(mat_draws.S(:,p_idx), 95)', '%1.3f)  ' )  ' \\ ']);
    end
    fclose(my_fid);        
    
    display('comparing 1st and 2nd half')
    display([char(ParamLabels), num2str(median(mat_draws.S(1:floor(DD/2),:))', '& %1.3f' ), ...
        repmat(' ', PriorStructure.param_no, 1), ...
        num2str(prctile(mat_draws.S(1:floor(DD/2),:), 5)', '(%1.3f, ' ), num2str(prctile(mat_draws.S(1:floor(DD/2),:), 95)', '%1.3f) ' ), ...
        repmat(' ', PriorStructure.param_no, 1) num2str(median(mat_draws.S(floor(DD/2)+1:end,:))', '& %1.3f ' ), ...
        repmat(' ', PriorStructure.param_no, 1), ...
        num2str(prctile(mat_draws.S(floor(DD/2)+1:end,:), 5)', ' (%1.3f, ' ), num2str(prctile(mat_draws.S(floor(DD/2)+1:end,:), 95)', '%1.3f) \\\\' ) ]);
    
    my_fid=fopen([GraphFolder '/StructuralDiagnostic' VAR_suffix '.tex'], 'w');
    fprintf(my_fid,'%s \n',['Parameter & Median & (90\% CI) &   & Median & (90\% CI) \\ \hline']);
    for p_idx=1:PriorStructure.param_no
        fprintf(my_fid,'%s \n',[ParamLabels{p_idx} ' & ' num2str(median(mat_draws.S(1:floor(DD/2),p_idx)), '%1.3f ' ), ' & ' ...
        num2str(prctile(mat_draws.S(1:floor(DD/2),p_idx), 5)', '(%1.3f, ' ), num2str(prctile(mat_draws.S(1:floor(DD/2),p_idx), 95)', '%1.3f) ' ) ' & ' ...
        ' & ' num2str(median(mat_draws.S(floor(DD/2)+1:end,p_idx)), '%1.3f ' ), ' & ' ...
        num2str(prctile(mat_draws.S(floor(DD/2)+1:end,p_idx), 5)', '(%1.3f, ' ), num2str(prctile(mat_draws.S(floor(DD/2)+1:end,p_idx), 95)', '%1.3f) ' ) ' \\ ' ]);
    end
    fclose(my_fid);  
    
    display(['Unconditional acceptance rate: ' num2str(mean(mat_draws.accept(:,1))*100)]);
    TmpAccept=mat_draws.accept(:,1);
    clear TmpAccept;
end

%% Gibbs Sampling Diagnostics
if ~exist('mat_draws', 'var')
    mat_draws=matfile('Data/Draws_data.mat');
end

if usejava('jvm')
    figure;    
    Mean1=mean(2*mat_draws.LogL(1:floor(DD/2),1)/T);
    Std1=std(2*mat_draws.LogL(1:floor(DD/2),1)/T);
    [f1,xi]=ksdensity( (2*mat_draws.LogL(1:floor(DD/2),1)/T - Mean1)/Std1 );
    [f2,~]=ksdensity( (2*mat_draws.LogL(floor(DD/2)+1:end,1)/T - Mean1) / Std1,xi);
    hndl=plot(xi,[f1;f2]);
    set(hndl, {'LineWidth'}, {3;3},{'LineStyle'}, {'-';'--'});
    axis tight;
    xlabel('standard deviations from mean');
    ylabel('density');
    grid on;
    legend(hndl, {'1st half';'2nd half'}, 'Location', 'Best', 'FontSize', 18);
    set(findall(gcf,'type','axes'),'fontsize',18);
    set(findall(gcf,'type','text'),'fontSize',18);        

    if DO_PRINT 
        print('-depsc', [GraphFolder '/LogL_' VAR_suffix '.eps']);
    end


    % max eigenvalue of autoregressive K-matrix
    [~, my_fig]=my_ACF_plot(mat_draws.MaxEigs(:,2),0,10);
    if DO_PRINT 
        print('-depsc', [GraphFolder '/ACF_B_rho_Skip' num2str(GibbsSkip) '_' VAR_suffix '.eps']);
    end
    % max eigenvalue of variance matrix
    [~, my_fig]=my_ACF_plot(mat_draws.MaxEigs(:,3),0,10);
    if DO_PRINT 
        print('-depsc', [GraphFolder '/ACF_V_rho_Skip' num2str(GibbsSkip) '_' VAR_suffix '.eps']);
    end
    [~, my_fig]=my_ACF_plot(mat_draws.LogL(:,1),0,10);
    if DO_PRINT 
        print('-depsc', [GraphFolder '/ACF_LL_Skip' num2str(GibbsSkip) '_' VAR_suffix '.eps']);
    end

    if MY_PRIOR==2
        figure;
        subplot(3,1,1);
        plot(mat_draws.LogL);
        ylabel('log density');
        subplot(3,1,2);
        plot(mat_draws.MaxEigs(:,1));
        ylabel('max prior \rho');
        subplot(3,1,3);
        plot(mat_draws.MaxEigs(:,2));
        ylabel('max posterior \rho');
        if DO_PRINT 
            print('-depsc', [GraphFolder '/TS_Draw' num2str(GibbsSkip) '_' VAR_suffix '.eps']);
        end
        figure;
        subplot(3,1,1);
        plot( (cumsum(mat_draws.B,1)./repmat( (1:DD)', 1,size(mat_draws.B,2))-repmat(mean( mat_draws.B(1:ceil(DD/2),:),1), DD,1))./repmat(std( mat_draws.B(1:ceil(DD/2),:),1), DD,1) );
        axis tight;
        ylabel('cumulative t-stats B');
        subplot(3,1,2);
        plot( (cumsum(mat_draws.V,1)./repmat( (1:DD)', 1,size(mat_draws.V,2))-repmat(mean( mat_draws.V(1:ceil(DD/2),:),1), DD,1))./repmat(std( mat_draws.V(1:ceil(DD/2),:),1), DD,1) );
        ylabel('cumulative t-stats V');
        axis tight;
        subplot(3,1,3);
        plot( (cumsum(mat_draws.S,1)./repmat( (1:DD)', 1,size(mat_draws.S,2))-repmat(mean( mat_draws.S(1:ceil(DD/2),:),1), DD,1))./repmat(std( mat_draws.S(1:ceil(DD/2),:),1), DD,1) );
        ylabel('cumulative t-stats \theta ');
        axis tight;
        if DO_PRINT 
            print('-depsc', [GraphFolder '/BrooksGelman' VAR_suffix '.eps']);
        end
    else
        figure;
        subplot(2,1,1);
        plot(mat_draws.LogL);
        ylabel('log density');
        subplot(2,1,2);
        plot(mat_draws.MaxEigs(:,2));
        ylabel('max posterior \rho');
        if DO_PRINT 
            print('-depsc', [GraphFolder '/TS_Draw' num2str(GibbsSkip) '_' VAR_suffix '.eps']);
        end    
        figure;
        subplot(2,1,1);
        plot( (cumsum(mat_draws.B,1)./repmat( (1:DD)', 1,size(mat_draws.B,2))-repmat(mean( mat_draws.B(1:ceil(DD/2),:),1), DD,1))./repmat(std( mat_draws.B(1:ceil(DD/2),:),1), DD,1) );
        axis tight;
        ylabel('cumulative t-stats B');
        subplot(2,1,2);
        plot( (cumsum(mat_draws.V,1)./repmat( (1:DD)', 1,size(mat_draws.V,2))-repmat(mean( mat_draws.V(1:ceil(DD/2),:),1), DD,1))./repmat(std( mat_draws.V(1:ceil(DD/2),:),1), DD,1) );
        ylabel('cumulative t-stats V');
        axis tight;
        if DO_PRINT 
            print('-depsc', [GraphFolder '/BrooksGelman' VAR_suffix '.eps']);
        end        
    end
end

%%
switch MY_PRIOR
    case {33, 34}
%         my_Chib_Likelihood; 
        ModelStructure.NoParamsC=NoParamsC;
        log_m_llhood_Chib=my_Chib_Likelihood_fcn(prior_beta, prior_N0, S_prior, mat_draws, OriginalData, ModelStructure, DD);
        fprintf(num2str(log_m_llhood_Chib, '%1.2f \\n'));
    case 2
%         my_ChibRamamurthy_Likelihood;
        if ~exist('ConvergencePlot', 'var')
            my_ChibGeweke_Likelihood;
        end
end

if DO_PRINT 
    close all;
    save(['Data' VAR_suffix num2str(WHICH_DATA)]);
else
    display('*******************************************************************************');
    fprintf(2, '                          RESULTS ARE NOT SAVED \n');
    display('*******************************************************************************');
end


%% display parameter estimates
if MY_PRIOR==2
    CalibratedParams=setdiff(M_.param_names, PriorStructure.param_name);
    CalibratedParams(strmatch('conste', CalibratedParams))=[];
    CalibratedParams(strmatch('c_', CalibratedParams))=[];
    CalibratedParams(strmatch('se_', CalibratedParams))=[];
    CalibratedParams(strmatch('st_', CalibratedParams))=[];
    CalibratedParams=[CalibratedParams; 'constebeta'];
    for ii=1:length(CalibratedParams)
        display([CalibratedParams{ii}, ' & ' ,  num2str(M_.params(strmatch(CalibratedParams{ii} , M_.param_names, 'exact')), '%1.3f \\\\' ) ]);
    end
end