% load data, depending on chosen model

if ~exist('DO_MR_Normal','var')
    DO_MR_Normal=0;
end
if ~exist('USE_FF','var')
    USE_FF=0;
end

if ~exist('DO_IV_CHOL_RES','var')
    DO_IV_CHOL_RES=0;
end

if ~exist('DO_IV_PRIOR', 'var')
    DO_IV_PRIOR=0;
end


if ~exist('DO_HISTORICAL', 'var')
    DO_HISTORICAL=0;
end
if ~exist('DO_FED','var')
    DO_FED=0;
end

switch upper(WHICH_MODEL)
    case {'FORESIGHT','FORESIGHT+REV','FORESIGHT+INF','FORESIGHT+K','FORESIGHT+I'}
        load ../GB_simple_data_q
        g_signal_def_lvl=diff_DefS; % ex post forecast error
        m_signal=rom_rr_shock_all; %rom_rr_shock_new_CPI2;

    case 'OLD_IV'
        load ../simple_data_q
    otherwise
        if Post1966~=1 && Post66k8smple~=1
            load ../simple_data_q
            new_IV=load('../GB_simple_data_q', 'diff_DefS','rom_rr_shock_all','Date');

            IV_IDX=find(Date==new_IV.Date(1)):find(Date==new_IV.Date(end));
            ZERO_IDX=isnan(g_signal_def_lvl);
            g_signal_def_lvl(IV_IDX)=new_IV.diff_DefS;
            if OLD_IV_SAMPLE>0
                g_signal_def_lvl(ZERO_IDX)=0;
            end
            ZERO_IDX=isnan(m_signal);
            m_signal(IV_IDX)=new_IV.rom_rr_shock_all;
            if OLD_IV_SAMPLE==1
                m_signal(ZERO_IDX)=0;
            end
            if OLD_IV_SAMPLE<0
                m_PI(g_signal_def_lvl==0)=0;
                m_CI(g_signal_def_lvl==0)=0;
            end
        else
            load ../GB_simple_data_q
            g_signal_def_lvl=diff_DefS; % ex post forecast error
            m_signal=rom_rr_shock_all; %rom_rr_shock_new_CPI2;                    
        end
end

if DO_FED == 1
    DEBT_Y = fDEBT_Y;
elseif DO_FED == 2
    DEBT_Y = fDEBT_Y;
    tauP = ftauP*1;
elseif DO_FED == 3
    DEBT_Y = fDEBT_Y;
    tauP = ftauP*1;
    lvl_g = lvl_gf;
else
    tauP = tauP*1;
end

ZeroMean=1; % using demeaned / detrended data

DateLvl=Date;        
quarter=Date;

m_PI(isnan(m_PI))=0;
m_CI(isnan(m_CI))=0;
g_signal_def_lvl(isnan(g_signal_def_lvl))=0;
rom_rr_shock_all(isnan(rom_rr_shock_all))=0;
rom_rr_shock_new_CPI2(isnan(rom_rr_shock_new_CPI2))=0;
m_signal(isnan(m_signal))=0;
m_signal_futures(isnan(m_signal_futures))=0;


YY=[];
VAR_suffix='_';
for vv=1:length(PICK_VARS)
    YY=eval(['[YY, ' PICK_VARS{vv} '];']);
    VAR_suffix=eval(['[VAR_suffix ''' Labels{vv}(1) '''];']);  
    if vv==m && m<m_all
        VAR_suffix=[VAR_suffix '_' ];
    end
end
   

[ll,cc]=find(isnan(YY)==1);
ll=unique(ll);
if ~isempty(ll)
    if ll(1)==1
        if isempty( find(diff(ll)>1,1))
            SKIPstart=max([max(ll)+1 1]);
        else
            SKIPstart=max([ll(find(diff(ll)>1,1))+1 1]);
        end
        SKIPend=min([ll(1+find(diff(ll)>1,1))-1 size(YY,1)]);
    else
        SKIPstart=1;
        SKIPend=min([ll(1) size(YY,1)]);
    end
else
    SKIPstart=1;
    SKIPend=size(YY,1);
end

YY=YY(SKIPstart:SKIPend,:);
quarter=quarter(SKIPstart:SKIPend,:);


            if USE_FF==1
                m_signal=m_signal_futures_lvl;
            end
            switch DO_IV
                case 2
                    if Post1982_IV==2
                        IV=[g_signal_def_lvl(SKIPstart:SKIPend) m_signal_futures_lvl(SKIPstart:SKIPend)]; 
                        VAR_suffix=[VAR_suffix '_SPF_FF_IV'];   
                    else
                        IV=[g_signal_def_lvl(SKIPstart:SKIPend) m_signal(SKIPstart:SKIPend)]; 
                        VAR_suffix=[VAR_suffix '_SPF_RR_IV'];   
                    end
                        CholToIV=[strmatch('G',Labels, 'exact'), strmatch('dG',Labels, 'exact'), strmatch('TB3',upper(Labels), 'exact') strmatch('FFR',upper(Labels), 'exact')];                
                case 3
                    IV=[m_signal(SKIPstart:SKIPend) ]; 
                    VAR_suffix=[VAR_suffix '_RR_IV'];    
                    CholToIV=[strmatch('TB3',upper(Labels), 'exact') strmatch('FFR',upper(Labels), 'exact')];
                case 4
                    IV=[m_PI(SKIPstart:SKIPend) m_signal(SKIPstart:SKIPend) ]; 
                    VAR_suffix=[VAR_suffix '_MR_RR_IV'];    
                        CholToIV=[strmatch('TAX',upper(Labels), 'exact') strmatch('FFR',upper(Labels), 'exact')];     
                case 5
                    IV=[g_signal_def_lvl(SKIPstart:SKIPend) m_PI(SKIPstart:SKIPend) m_signal(SKIPstart:SKIPend) ]; 
                    VAR_suffix=[VAR_suffix '_SPF_RR_MR_IV'];                        
                        CholToIV=[strmatch('G',upper(Labels), 'exact') strmatch('DG',upper(Labels), 'exact') strmatch('TAX',upper(Labels), 'exact') strmatch('LTAX',upper(Labels), 'exact') strmatch('FFR',upper(Labels), 'exact')];     
                case 6
                    IV=[m_PI(SKIPstart:SKIPend) ]; 
                    VAR_suffix=[VAR_suffix '_MR_IV'];    
                        CholToIV=[strmatch('TAX',upper(Labels), 'exact') ];     
                case 7
                    IV=[m_PI(SKIPstart:SKIPend) g_signal_def_lvl(SKIPstart:SKIPend) m_signal(SKIPstart:SKIPend) ]; 
                    VAR_suffix=[VAR_suffix '_MR_SPF_RR_IV'];                        
                        CholToIV=[strmatch('TAX',upper(Labels), 'exact') strmatch('G',upper(Labels), 'exact') strmatch('DG',upper(Labels), 'exact') strmatch('FFR',upper(Labels), 'exact')];     
                case 8
                    IV=[g_signal_def_lvl(SKIPstart:SKIPend) m_PI(SKIPstart:SKIPend)]; 
                    VAR_suffix=[VAR_suffix '_SPF_MR_IV'];                        
                        CholToIV=[strmatch('G',upper(Labels), 'exact') strmatch('DG',upper(Labels), 'exact') strmatch('TAX',upper(Labels), 'exact')  strmatch('LTAX',upper(Labels), 'exact') ];     
                end
                if USE_FF==1
                    VAR_suffix=regexprep(VAR_suffix, '_RR','_FF');
                end

switch WhichChol
    case 2
       VAR_suffix=[VAR_suffix '_MRl'];    % 0 - cholesky of a11a11', 1 - cholesky of s11s11', 2 - MR lower, 3 - MR upper
    case 3
       VAR_suffix=[VAR_suffix '_MRu'];    % 0 - cholesky of a11a11', 1 - cholesky of s11s11', 2 - MR lower, 3 - MR upper
    otherwise
       VAR_suffix=[VAR_suffix '_chol' num2str(WhichChol)];    % 0 - cholesky of a11a11', 1 - cholesky of s11s11', 2 - MR lower, 3 - MR upper
end

if Post1982_IV>0  
    if Post1982_IV~=2  
        IV(quarter<1983,:)=0;
        VAR_suffix=[VAR_suffix '_post82IV'];    
    else
        IV(quarter<1994,:)=0;
        VAR_suffix=[VAR_suffix '_post95IV'];    
    end
elseif Post1982_IV<0  
    IV(quarter<1983,:)=0;
    VAR_suffix=[VAR_suffix '_pre82IV'];    
end

if OriginalData.k~=4
    VAR_suffix=[VAR_suffix '-k' num2str(OriginalData.k)];    
end

if DO_IV_PRIOR==1
    VAR_suffix=[VAR_suffix '-PriorIV'];    
end
