% Draw from DSGE model prior and translate into VAR prior
floor_T_B=floor(T*(DSGE_lambda));
floor_T_S=floor(T*(DSGE_lambda_S));

draw_idx=0;
NewDrawNeeded=true;
while draw_idx<20 && NewDrawNeeded
    draw_idx=draw_idx+1;
    run('../my_Dynare_DSGEVAR_Prior_m.m');
    if NewDrawNeeded
        fprintf(2,'Problem with VAR representation of prior DSGE draw, trying again \n');
    end
end

ImplicitXy=chol(NXX, 'upper');
if mz>0
    ImplicitXz=ImplicitXy(:,m*OriginalData.k+1);
else
    ImplicitXz=NaN(size(ImplicitXy,1),0);
end

X_dum=sqrt(floor_T_B/size(ImplicitXy,1))*ImplicitXy;
Y_dum=[X_dum*B_prior zeros(OriginalData.NoParamsC, ModelStructure.mz)];
Xz_dum=sqrt(floor_T_B/size(ImplicitXz,1))*ImplicitXz;
Z_dum=Xz_dum*zeros(OriginalData.NoXz,ModelStructure.mz);

if MY_PRIOR~=3  
    Y=[Y_dum; [OriginalData.Y(:,1:m) OriginalData.IV]];
    Xy=[X_dum; OriginalData.Xy];
    Xz=[Xz_dum; OriginalData.Xz];
end

X_0=sparse([kron(eye(m), X_dum), zeros(m*NoParamsC,mz); zeros(mz*NoParamsC,m*NoParamsC), kron(eye(mz),Xz_dum)]);
Y_0=Y_dum(:); %vectorize

try
    invCholS=inv(chol(S_prior));
catch
    if min(eig(S_prior))>0
        invCholS=(S_prior)^(-1/2);    
    else
        error('negative definite prior variance-covariance');
    end
end
CholS=chol(S_prior, 'lower');
%%
% piece-wise inverse
Vinv_yy=inv(S_prior(1:m,1:m)-( S_prior(1:m,m+(1:mz))/(S_prior(m+(1:mz),m+(1:mz))) )*S_prior(m+(1:mz),1:m));
Vinv_zz=inv(S_prior(m+(1:mz),m+(1:mz))-( S_prior(m+(1:mz),1:m)/(S_prior(1:m,1:m)) )*S_prior(1:m,m+(1:mz)));
Vinv_yz=-S_prior(1:m,1:m)\(S_prior(1:m,m+(1:mz))*Vinv_zz);
Vinv_zy=-Vinv_zz*S_prior(m+(1:mz),1:m)/S_prior(1:m,1:m);
Vinv=[Vinv_yy, Vinv_yz; Vinv_zy, Vinv_zz];

X_0_tilde=sparse(kron(chol(Vinv,'lower')',eye(NoParamsC))*X_0);
Y_0_tilde=sparse(kron(chol(Vinv,'lower')',eye(NoParamsC))*Y_0);
N_XX_0_tilde=(X_0_tilde'*X_0_tilde); 
N_XY_0_tilde=(X_0_tilde'*Y_0_tilde); 
XkronX=[kron(Vinv_yy,NXX) kron(Vinv_yz,[NXX(:,m*OriginalData.k+1)*1 zeros(NoParamsC,NoXz-1)]); ...
    kron(Vinv_zy,[zeros(NoXz-1,NoParamsC); NXX(m*OriginalData.k+1,:)*1 ]) kron(Vinv_zz,[1, zeros(1,NoXz-1) ; zeros(NoXz-1,NoXz) ])];
    
beta_0=full(N_XX_0_tilde\N_XY_0_tilde);

if  MY_PRIOR~=3  
    if DO_IV
        Z=Y(:,(m+1):end);
    else
        Z=NaN(size(Y,1),0);
    end
    Y(:,(m+1):end)=[];
end
if norm(reshape(beta_0(1:NoParamsC*m),NoParamsC,m)-B_prior)> 1e-8
    if 1-nancorr(beta_0(1:NoParamsC*m),B_prior(:))>1e-6
        display([norm(reshape(beta_0(1:NoParamsC*m),NoParamsC,m)-B_prior) , 1-nancorr(beta_0(1:NoParamsC*m),B_prior(:))]);
        fprintf(2, 'Dummy variables don''t implement the prior correctly \n');
    end
end

IV=Y(:,end-(mz-1):end);
nu_prior=floor_T_S; 

if DO_COMPUTE_LL && DoMean==0
    myBy=(Xy'*Xy)\(Xy'*Y);
    myBz=(Xz'*Xz)\(Xz'*Z);
    myV=[(Y(:,:)-Xy(:,:)*myBy)'*(Y(:,:)-Xy(:,:)*myBy) (Y(:,:)-Xy(:,:)*myBy)'*(Z(:,:)-Xz(:,:)*myBz); ...
        (Z(:,:)-Xz(:,:)*myBz)'*(Y(:,:)-Xy(:,:)*myBy) (Z(:,:)-Xz(:,:)*myBz)'*(Z(:,:)-Xz(:,:)*myBz) ]/(T+floor_T_B);

    log_post_kernel_hyper = ((T+floor_T_B)/2)* (2*sum(-log(diag(chol(myV))))) ... determinant of DSGE-draw implied variance
            - (1/2) * (m+mz)*(T+floor_T_B)... SSR relative to prior variance
            - sum(my_log_prior);
end

