fclose all;
if ~exist('SourceModFile', 'var')
%     clear variables
    SourceModFile='NK_priors_v1_loose_SD_rules_capital_Taylor_corr.mod';
end
if ~exist('OverWriteModFile', 'var')
    OverWriteModFile='../SW_override_v3.mod';
end

if ~exist('NO_TRUNCATION', 'var')
    NO_TRUNCATION=0;
end

if ~exist('ESTIMATE_IV_ERR', 'var')
    ESTIMATE_IV_ERR=3;
end

if ~exist('NON_DIAGONAL_G', 'var')
    NON_DIAGONAL_G=false;
end

if ~exist('Depreciation_CapU','var')
    Depreciation_CapU=0;
end

if ~exist('DO_SIMULATE', 'var')
    DO_SIMULATE=1;
end

if ~exist('DoResumeSampling', 'var')
    DoResumeSampling=0;
end

my_fid= fopen(SourceModFile,'r');
PriorStart_Text= 'estimated_params;';

line  = 0;
found = false;
while ~feof(my_fid) && ~found

    tline = fgetl(my_fid);
    line = line + 1;

    if ischar(tline) && ~isempty(strfind(tline, PriorStart_Text))
        found = true;
    end
end

if ~found
    line = NaN; 
    error('Could not find prior in mod-file!');
elseif ~DoResumeSampling
    clear PriorStructure
    found_end=false;
    param_no=0;
    se_signal_no=0;
    PriorStructure.corr_signal_no=0;
    c_signal_no=0;
    while ~feof(my_fid) && ~found_end
        line = line + 1;
        tline = fgetl(my_fid);
        % this condition still reads out priors which are commented out in Dynare 
        if ischar(tline) && ~isempty(strfind(tline, '_PDF')) && ~isequal(strfind(strtrim(tline), '//'),1)  
            param_no=param_no+1;
            
            PriorStructure.param_name{param_no}=strtrim(tline(1: (min( strfind(tline, ',') )-1) ));
            PDF_pos=strfind(tline, '_PDF');
            PriorStructure.param_type{param_no}=tline(max( strfind(tline(1:PDF_pos) , ',') )+1 : PDF_pos-1 );
            TRUNC_COMMA_POS2=max( strfind(tline(1:PDF_pos-1) , ','))-1 ;
            TRUNC_COMMA_POS1=max( strfind(tline(1:TRUNC_COMMA_POS2-1) , ','))-1 ;
            COMMA_POS=PDF_pos+4+ min( strfind(tline(PDF_pos+5:end) , ',')) ;
            PriorStructure.prior_trunc_low(param_no)=str2double(tline( max( strfind(tline(1:TRUNC_COMMA_POS1-1) , ','))+1 : TRUNC_COMMA_POS1 ) ) ;
            PriorStructure.prior_trunc_high(param_no)=str2double(tline( TRUNC_COMMA_POS1+2 : TRUNC_COMMA_POS2) );
            PriorStructure.prior_m(param_no)=str2double(tline( PDF_pos+5 : COMMA_POS-1 ) ) ;
            PriorStructure.prior_s(param_no)=str2double(tline( COMMA_POS+1 : COMMA_POS -1 + min( strfind(tline(COMMA_POS+1:end) , ';') ) ));
      end

        if ischar(tline) && ~isempty(strfind(tline, 'end'))
            found = true;
        end
    end
    
    % now look for measurement error in the instruments
    if ESTIMATE_IV_ERR==1 || ESTIMATE_IV_ERR==3
        IV_SignalOrder_se=nan(mz,1);
        fclose(my_fid); % this resets the line count in the source mod file.
        my_fid= fopen(SourceModFile,'r');
        line  = 0;
        found = false;
        while ~feof(my_fid) && ~found

            tline = fgetl(my_fid);
            line = line + 1;

            if ischar(tline) && ~isempty(strfind(tline, PriorStart_Text))
                found = true;
            end
        end
        
        while ~feof(my_fid) && ~found_end
            line = line + 1;
            tline = fgetl(my_fid);
            % this condition still reads out priors which are commented out in Dynare 
            if ischar(tline) && ~isempty(strfind(tline, '_PDF')) && isequal(strfind(strtrim(tline), '//se_signal'),1) 
                % check if the instrument is actually present
                tmp_string=strtrim(tline);
                if sum(strcmp(['e' tmp_string(length('//se_signal')+2:strfind(tmp_string,',')-1)],ShockList(CholToIV))) + ...
                        sum(strcmp(['e_' tmp_string(length('//se_signal')+2:strfind(tmp_string,',')-1)],ShockList(CholToIV)))==1
                    param_no=param_no+1;
                    se_signal_no=se_signal_no+1;
                    IV_SignalOrder_se(se_signal_no,1)=find( (strcmp(['e' tmp_string(length('//se_signal')+2:strfind(tmp_string,',')-1)],ShockList(CholToIV))) + ...
                        (strcmp(['e_' tmp_string(length('//se_signal')+2:strfind(tmp_string,',')-1)],ShockList(CholToIV))) );

                    PriorStructure.param_name{param_no}=strtrim(tline(1: (min( strfind(tline, ',') )-1) ));
                    PDF_pos=strfind(tline, '_PDF');
                    PriorStructure.param_type{param_no}=tline(max( strfind(tline(1:PDF_pos) , ',') )+1 : PDF_pos-1 );
                    TRUNC_COMMA_POS2=max( strfind(tline(1:PDF_pos-1) , ','))-1 ;
                    TRUNC_COMMA_POS1=max( strfind(tline(1:TRUNC_COMMA_POS2-1) , ','))-1 ;
                    COMMA_POS=PDF_pos+4+ min( strfind(tline(PDF_pos+5:end) , ',')) ;
                    PriorStructure.prior_trunc_low(param_no)=str2double(tline( max( strfind(tline(1:TRUNC_COMMA_POS1-1) , ','))+1 : TRUNC_COMMA_POS1 ) ) ;
                    PriorStructure.prior_trunc_high(param_no)=str2double(tline( TRUNC_COMMA_POS1+2 : TRUNC_COMMA_POS2) );
                    PriorStructure.prior_m(param_no)=str2double(tline( PDF_pos+5 : COMMA_POS-1 ) ) ;
                    PriorStructure.prior_s(param_no)=str2double(tline( COMMA_POS+1 : COMMA_POS -1 + min( strfind(tline(COMMA_POS+1:end) , ';') ) ));
                end
            end
        end
        % order the IV parameters in VAR order
        PriorStructure.param_name(param_no+1-(1:mz))=PriorStructure.param_name(param_no+1-IV_SignalOrder_se);
        PriorStructure.param_type(param_no+1-(1:mz))=PriorStructure.param_type(param_no+1-IV_SignalOrder_se);

        PriorStructure.prior_trunc_low(param_no+1-(1:mz))=PriorStructure.prior_trunc_low(param_no+1-IV_SignalOrder_se);
        PriorStructure.prior_trunc_high(param_no+1-(1:mz))=PriorStructure.prior_trunc_high(param_no+1-IV_SignalOrder_se);
        PriorStructure.prior_m(param_no+1-(1:mz))=PriorStructure.prior_m(param_no+1-IV_SignalOrder_se);
        PriorStructure.prior_s(param_no+1-(1:mz))=PriorStructure.prior_s(param_no+1-IV_SignalOrder_se);
        
        clearvars tmp_string

        % correlation coefficients in measurement error matrix

        fclose(my_fid); % this resets the line count in the source mod file.
        if NON_DIAGONAL_G
            PriorStructure.Corr_pairs=zeros(mz*(mz-1),2); % each parameter occurs once, diagonal is normalized to one
        else
            PriorStructure.Corr_pairs=zeros((mz-1)*mz/2,2); %each parameter appears twice in the correlation matrix
        end
        my_fid= fopen(SourceModFile,'r');
        line  = 0;
        found = false;
        while ~feof(my_fid) && ~found

            tline = fgetl(my_fid);
            line = line + 1;

            if ischar(tline) && ~isempty(strfind(tline, PriorStart_Text))
                found = true;
            end
        end
        
        PriorStructure.param_start_corr = param_no;
        while ~feof(my_fid) && ~found_end
            line = line + 1;
            tline = fgetl(my_fid);
            % this condition still reads out priors which are commented out in Dynare 
            if ischar(tline) && ~isempty(strfind(tline, '_PDF')) && isequal(strfind(strtrim(tline), '//korr'),1) 
                % check if the instrument is actually present
                tmp_string=strtrim(tline);
                % check that first shock and second shock are defined and
                % used
                if (sum(strcmp(['e' tmp_string(length('//korr')+2:strfind(tmp_string,'-')-1)],ShockList(CholToIV))) + ...
                        sum(strcmp(['e_' tmp_string(length('//korr')+2:strfind(tmp_string,'-')-1)],ShockList(CholToIV)))==1) &&  ...
                    ( sum(strcmp(['e' tmp_string( (strfind(tmp_string,'-')+1):strfind(tmp_string,',')-1)],ShockList(CholToIV))) + ...
                        sum(strcmp(['e_' tmp_string( (strfind(tmp_string,'-')+1):strfind(tmp_string,',')-1)],ShockList(CholToIV))) ==1)
                    param_no=param_no+1;
                    PriorStructure.corr_signal_no=PriorStructure.corr_signal_no+1;
                    % save which correlations apply to which pair
                    % Need "e" and "e_" here in case shock names are not streamlined
                    PriorStructure.Corr_pairs(PriorStructure.corr_signal_no,1)=find( (strcmp(['e' tmp_string(length('//korr')+2:strfind(tmp_string,'-')-1)],ShockList(CholToIV))) + ...
                        (strcmp(['e_' tmp_string(length('//korr')+2:strfind(tmp_string,'-')-1)],ShockList(CholToIV))) );

                    PriorStructure.Corr_pairs(PriorStructure.corr_signal_no,2)=find( strcmp(['e' tmp_string( (strfind(tmp_string,'-')+1):strfind(tmp_string,',')-1)],ShockList(CholToIV))  + ...
                        strcmp(['e_' tmp_string( (strfind(tmp_string,'-')+1):strfind(tmp_string,',')-1)],ShockList(CholToIV))  );

                    PriorStructure.param_name{param_no}=strtrim(tline(1: (min( strfind(tline, ',') )-1) ));
                    PDF_pos=strfind(tline, '_PDF');
                    PriorStructure.param_type{param_no}=tline(max( strfind(tline(1:PDF_pos) , ',') )+1 : PDF_pos-1 );
                    TRUNC_COMMA_POS2=max( strfind(tline(1:PDF_pos-1) , ','))-1 ;
                    TRUNC_COMMA_POS1=max( strfind(tline(1:TRUNC_COMMA_POS2-1) , ','))-1 ;
                    COMMA_POS=PDF_pos+4+ min( strfind(tline(PDF_pos+5:end) , ',')) ;
                    PriorStructure.prior_trunc_low(param_no)=str2double(tline( max( strfind(tline(1:TRUNC_COMMA_POS1-1) , ','))+1 : TRUNC_COMMA_POS1 ) ) ;
                    PriorStructure.prior_trunc_high(param_no)=str2double(tline( TRUNC_COMMA_POS1+2 : TRUNC_COMMA_POS2) );
                    PriorStructure.prior_m(param_no)=str2double(tline( PDF_pos+5 : COMMA_POS-1 ) ) ;
                    PriorStructure.prior_s(param_no)=str2double(tline( COMMA_POS+1 : COMMA_POS -1 + min( strfind(tline(COMMA_POS+1:end) , ';') ) ));
                    
                end
            end
        end

        % Write function(s) here that maps from params to off-diagonal
        % matrix
        if ~NON_DIAGONAL_G
            IV_fid= fopen('my_IV_corr_matrix.m','w');
            fprintf(IV_fid, '%s \n', 'function corr_matrix = my_IV_corr_matrix(mz,PriorStructure, draw)');
            fprintf(IV_fid, '%s \n', '%automatically generated by my_dynare_read_write_prior_script');
            fprintf(IV_fid, '%s \n', '%corr_matrix is in ShockList order already');
            fprintf(IV_fid, '%s \n', '');
            fprintf(IV_fid, '%s \n', 'corr_matrix = eye(mz,mz);');
            fprintf(IV_fid, '%s \n', 'for ii=1:PriorStructure.corr_signal_no');
            fprintf(IV_fid, '%s \n', '	% transform distribution on [0,1] to [-1,1];');
            fprintf(IV_fid, '%s \n', '	corr_matrix(PriorStructure.Corr_pairs(ii,1),PriorStructure.Corr_pairs(ii,2))=2*(draw(PriorStructure.param_start_corr+ii)-0.5);');
            fprintf(IV_fid, '%s \n', '	corr_matrix(PriorStructure.Corr_pairs(ii,2),PriorStructure.Corr_pairs(ii,1))=2*(draw(PriorStructure.param_start_corr+ii)-0.5);');
            fprintf(IV_fid, '%s \n', 'end');
            fclose(IV_fid);

            IV_fid= fopen('my_IV_G_matrix.m','w');
            fprintf(IV_fid, '%s \n', 'function G_matrix = my_IV_G_matrix(mz,PriorStructure, draw)');
            fprintf(IV_fid, '%s \n', '%automatically generated by my_dynare_read_write_prior_script');
            fprintf(IV_fid, '%s \n', '%G_matrix is in ShockList order already');
            fprintf(IV_fid, '%s \n', '');
            fprintf(IV_fid, '%s \n', 'G_matrix = eye(mz,mz);');
            fclose(IV_fid);
        else
            IV_fid= fopen('my_IV_G_matrix.m','w');
            fprintf(IV_fid, '%s \n', 'function G_matrix = my_IV_G_matrix(mz,PriorStructure, draw)');
            fprintf(IV_fid, '%s \n', '%automatically generated by my_dynare_read_write_prior_script');
            fprintf(IV_fid, '%s \n', '%G_matrix is in ShockList order already');
            fprintf(IV_fid, '%s \n', '');
            fprintf(IV_fid, '%s \n', 'G_matrix = eye(mz,mz);');
            fprintf(IV_fid, '%s \n', 'for ii=1:PriorStructure.corr_signal_no');
            fprintf(IV_fid, '%s \n', '	% transform distribution on [0,1] to [-1,1];');
            fprintf(IV_fid, '%s \n', '	corr_matrix(PriorStructure.Corr_pairs(ii,1),PriorStructure.Corr_pairs(ii,2))=2*(draw(PriorStructure.param_start_corr+ii)-0.5);');
            % no symmetry!
            fprintf(IV_fid, '%s \n', 'end');
            fclose(IV_fid);

            IV_fid= fopen('my_IV_corr_matrix.m','w');
            fprintf(IV_fid, '%s \n', 'function corr_matrix = my_IV_corr_matrix(mz,PriorStructure, draw)');
            fprintf(IV_fid, '%s \n', '%automatically generated by my_dynare_read_write_prior_script');
            fprintf(IV_fid, '%s \n', '%corr_matrix is in ShockList order already');
            fprintf(IV_fid, '%s \n', '');
            fprintf(IV_fid, '%s \n', 'corr_matrix = eye(mz,mz);');
            fclose(IV_fid);
        end
        clearvars IV_SignalOrder_se tmp_string
    end
    % elements of G matrix
    if ESTIMATE_IV_ERR==2 || ESTIMATE_IV_ERR==3
        IV_SignalOrder_c=nan(mz,1);
        fclose(my_fid); % this resets the line count in the source mod file.
        my_fid= fopen(SourceModFile,'r');
        line  = 0;
        found = false;
        while ~feof(my_fid) && ~found

            tline = fgetl(my_fid);
            line = line + 1;

            if ischar(tline) && ~isempty(strfind(tline, PriorStart_Text))
                found = true;
            end
        end
        
        while ~feof(my_fid) && ~found_end
            line = line + 1;
            tline = fgetl(my_fid);
            % this condition still reads out priors which are commented out in Dynare 
            if ischar(tline) && ~isempty(strfind(tline, '_PDF')) &&  isequal(strfind(strtrim(tline), '//c_signal'),1)  
                % check if the instrument is actually present
                tmp_string=strtrim(tline);
                if sum(strcmp(['e' tmp_string(length('//c_signal')+2:strfind(tmp_string,',')-1)],ShockList(CholToIV))) + ...
                        sum(strcmp(['e_' tmp_string(length('//c_signal')+2:strfind(tmp_string,',')-1)],ShockList(CholToIV)))==1
                    param_no=param_no+1;
                    c_signal_no=c_signal_no+1;
                    IV_SignalOrder_c(c_signal_no,1)=find( (strcmp(['e' tmp_string(length('//c_signal')+2:strfind(tmp_string,',')-1)],ShockList(CholToIV))) + ...
                        (strcmp(['e_' tmp_string(length('//c_signal')+2:strfind(tmp_string,',')-1)],ShockList(CholToIV))) );

                    PriorStructure.param_name{param_no}=strtrim(tline(1: (min( strfind(tline, ',') )-1) ));
                    PDF_pos=strfind(tline, '_PDF');
                    PriorStructure.param_type{param_no}=tline(max( strfind(tline(1:PDF_pos) , ',') )+1 : PDF_pos-1 );
                    TRUNC_COMMA_POS2=max( strfind(tline(1:PDF_pos-1) , ','))-1 ;
                    TRUNC_COMMA_POS1=max( strfind(tline(1:TRUNC_COMMA_POS2-1) , ','))-1 ;
                    COMMA_POS=PDF_pos+4+ min( strfind(tline(PDF_pos+5:end) , ',')) ;
                    PriorStructure.prior_trunc_low(param_no)=str2double(tline( max( strfind(tline(1:TRUNC_COMMA_POS1-1) , ','))+1 : TRUNC_COMMA_POS1 ) ) ;
                    PriorStructure.prior_trunc_high(param_no)=str2double(tline( TRUNC_COMMA_POS1+2 : TRUNC_COMMA_POS2) );
                    PriorStructure.prior_m(param_no)=str2double(tline( PDF_pos+5 : COMMA_POS-1 ) ) ;
                    PriorStructure.prior_s(param_no)=str2double(tline( COMMA_POS+1 : COMMA_POS -1 + min( strfind(tline(COMMA_POS+1:end) , ';') ) ));
                end
            end
        end
        % order the IV parameters in VAR order
        PriorStructure.param_name(param_no+1-(1:mz))=PriorStructure.param_name(param_no+1-IV_SignalOrder_c);
        PriorStructure.param_type(param_no+1-(1:mz))=PriorStructure.param_type(param_no+1-IV_SignalOrder_c);

        PriorStructure.prior_trunc_low(param_no+1-(1:mz))=PriorStructure.prior_trunc_low(param_no+1-IV_SignalOrder_c);
        PriorStructure.prior_trunc_high(param_no+1-(1:mz))=PriorStructure.prior_trunc_high(param_no+1-IV_SignalOrder_c);
        PriorStructure.prior_m(param_no+1-(1:mz))=PriorStructure.prior_m(param_no+1-IV_SignalOrder_c);
        PriorStructure.prior_s(param_no+1-(1:mz))=PriorStructure.prior_s(param_no+1-IV_SignalOrder_c);
        
        clearvars IV_SignalOrder_c tmp_string
    end
end

fclose(my_fid);
PriorStructure.se_signal_no=se_signal_no;
PriorStructure.c_signal_no=c_signal_no;
PriorStructure.param_no=param_no;
% Number of parameters minus those (AT THE END) that are deterministic
PriorStructure.param_no_eff=param_no - sum(single(PriorStructure.prior_s<0));
% error('need to deal with trunaction');
%% Now write function to draw from prior
% In the loop writing the function, I also take one draw for each parameter to check if there are any obvious problems

if DO_SIMULATE~=2
    % this file is for drawing in Matlab
    my_fid= fopen('my_DSGE_Parameter_Prior_draw.m','w');
    fprintf(my_fid,'function [my_draw, my_log_prior]=my_DSGE_Parameter_Prior_draw(PriorStructure) \n');
    fprintf(my_fid,'%% Automatically generated by my_dynare_read_write_prior_script.m \n \n');
    fprintf(my_fid,'my_draw=NaN(PriorStructure.param_no,1); \n');
    fprintf(my_fid,'my_log_prior=NaN(PriorStructure.param_no,1); \n');

    % this file is for computing the prior density in Matlab given a draw in the right scale
    my_fid_dens= fopen('my_DSGE_Parameter_Prior_density.m','w');
    fprintf(my_fid_dens,'function [my_log_prior]=my_DSGE_Parameter_Prior_density(PriorStructure, my_draw) \n');
    fprintf(my_fid_dens,'%% Automatically generated by my_dynare_read_write_prior_script.m \n \n');
    fprintf(my_fid_dens,'my_log_prior=NaN(PriorStructure.param_no,1); \n');
    fprintf(my_fid_dens,'if min(PriorStructure.prior_trunc_high(:)-my_draw(:))>0 && max(PriorStructure.prior_trunc_low(:)-my_draw(:))<0 \n');
    % fprintf(my_fid_dens,'my_log_Jacob=NaN(PriorStructure.param_no,1); \n');

    % this file is for computing the transformation in Matlab given a continuous draw in R (i.e. mv normal)
    my_fid_from_real= fopen('my_DSGE_Parameter_Prior_draw_from_real.m','w');
    fprintf(my_fid_from_real,'function [my_draw,my_log_prior,my_log_Jacob]=my_DSGE_Parameter_Prior_draw_from_real(PriorStructure,RealDraw) \n');
    fprintf(my_fid_from_real,'%% Automatically generated by my_dynare_read_write_prior_script.m \n \n');
    fprintf(my_fid_from_real,'my_log_prior=NaN(PriorStructure.param_no,1); \n');
    fprintf(my_fid_from_real,'my_draw=NaN(PriorStructure.param_no,1); \n');
    fprintf(my_fid_from_real,'my_log_Jacob=NaN(PriorStructure.param_no,1); \n');


    % this file is for computing the mv normal counterpart of 
    my_fid_reverse= fopen('my_DSGE_Parameter_reverse.m','w');
    fprintf(my_fid_reverse,'function [RealDraw]=my_DSGE_Parameter_reverse(PriorStructure,my_draw) \n');
    fprintf(my_fid_reverse,'%% Automatically generated by my_dynare_read_write_prior_script.m \n \n');
    fprintf(my_fid_reverse,'RealDraw=NaN(PriorStructure.param_no,1); \n');

    my_fid_m= fopen('../my_DSGE_Parameter_Prior_draw_m.m','w');
    % fprintf(my_fid,'function my_draw=my_DSGE_Parameter_Prior_draw(PriorStructure) \n');
    fprintf(my_fid_m,'%% Automatically generated by my_dynare_read_write_prior_script.m \n \n');
    fprintf(my_fid_m,'my_draw=NaN(PriorStructure.param_no,1); \n');
    fprintf(my_fid_m,'my_log_prior=NaN(PriorStructure.param_no,1); \n');

    % this file is for reading the draws into Dynare
    my_fid_mod= fopen(OverWriteModFile,'w');
    fprintf(my_fid_mod,'%% Automatically generated by my_dynare_read_write_prior_script.m \n \n');

    fprintf(my_fid_mod,['@#define DO_SIMULATE=1 \n']);
    fprintf(my_fid_mod,['@#define CAP_U_IS_DEPRECIATION=' num2str(Depreciation_CapU) '\n']);
    fprintf(my_fid_mod,['@#define DO_COST_CHANNEL=' num2str(DO_COST_CHANNEL) '\n']);
    fprintf(my_fid_mod,['@#define COMPLEMENT_G=0 \n']);
else
    my_fid_mod= fopen(OverWriteModFile,'w');
    fprintf(my_fid_mod,'%% Automatically generated by my_dynare_read_write_prior_script.m \n \n');

    fprintf(my_fid_mod,['@#define DO_SIMULATE=2 \n']);
    fprintf(my_fid_mod,['@#define CAP_U_IS_DEPRECIATION=' num2str(Depreciation_CapU) '\n']);
    fprintf(my_fid_mod,['@#define DO_COST_CHANNEL=' num2str(DO_COST_CHANNEL) '\n']);
    fprintf(my_fid_mod,['@#define COMPLEMENT_G=0 \n']);
end
% rng(1)
my_draw=NaN(PriorStructure.param_no,1);
my_log_prior=NaN(PriorStructure.param_no,1);


% for tt=1:100
for ll=1:PriorStructure.param_no
    string_to_write_param=[PriorStructure.param_name{ll} '=my_draw(' num2str(ll) '); '];

    % do not write the narrative measurement error into the mod file
    if ll<=(PriorStructure.param_no-PriorStructure.se_signal_no-PriorStructure.c_signal_no)
        fwrite(my_fid_mod, [string_to_write_param]);
        fprintf(my_fid_mod,'%%  \n');
    end
 
    switch PriorStructure.param_type{ll}
        case 'BETA'
            if NO_TRUNCATION % undo the truncation of the Dynare priors
                PriorStructure.prior_trunc_low(ll)=0;
                PriorStructure.prior_trunc_high(ll)=1;
            end
            % Note: the transformation does not work with infinite upper bounds
            string_to_write_Jacob=['my_log_Jacob(' num2str(ll) ')=log(' num2str(PriorStructure.prior_trunc_high(ll)-PriorStructure.prior_trunc_low(ll),15) ')' ...
                '/(1+exp(-RealDraw(' num2str(ll) '))+' num2str(PriorStructure.prior_trunc_low(ll),15) ');'];
            string_to_write_from_real=['my_draw(' num2str(ll) ')=(' num2str(PriorStructure.prior_trunc_high(ll)-PriorStructure.prior_trunc_low(ll),15) ...
                '/ ( 1+exp( -RealDraw(' num2str(ll) ') ) ) +' num2str(PriorStructure.prior_trunc_low(ll),15) ') ;'];
            string_to_write_reverse=['RealDraw(' num2str(ll) ')=-log(' num2str(PriorStructure.prior_trunc_high(ll)-PriorStructure.prior_trunc_low(ll),15) ...
                '/ (my_draw(' num2str(ll) ')-' num2str(PriorStructure.prior_trunc_low(ll),15) ') -1);'];
            
            if PriorStructure.prior_s(ll)>0
                MatlabParam1=-PriorStructure.prior_m(ll)+...
                    PriorStructure.prior_m(ll)^2*(1-PriorStructure.prior_m(ll))/PriorStructure.prior_s(ll)^2;
                MatlabParam2=-1+PriorStructure.prior_m(ll)+...
                    (1-PriorStructure.prior_m(ll))^2*PriorStructure.prior_m(ll)/PriorStructure.prior_s(ll)^2;

                my_draw(ll)=betarnd(MatlabParam1,MatlabParam2);
                trunc_low=betacdf(PriorStructure.prior_trunc_low(ll),MatlabParam1,MatlabParam2);
                trunc_high=betacdf(PriorStructure.prior_trunc_high(ll),MatlabParam1,MatlabParam2);
                trunc_diff=trunc_high-trunc_low;
                my_log_prior(ll)=(MatlabParam1-1)*log(my_draw(ll))+(MatlabParam2-1)*log(1-my_draw(ll))-betaln(MatlabParam1, MatlabParam2)-log(trunc_diff);
                string_to_write_param=['my_draw(' num2str(ll) ')=betainv(' num2str(trunc_low, 15) '+rand(1)*' num2str(trunc_diff, 15) ',' num2str(MatlabParam1, 15) ...
                    ',' num2str(MatlabParam2, 15) ');'];
                string_to_write_prior=['my_log_prior(' num2str(ll) ')=(' num2str(MatlabParam1-1,15) ')*log(my_draw(' num2str(ll) '))+' num2str(MatlabParam2-1,15) '*log(1-my_draw(' num2str(ll) '))' ...
                    '+' num2str(-betaln(MatlabParam1,MatlabParam2)-log(trunc_diff), 15) ';'];
            else
                my_draw(ll)=PriorStructure.prior_m(ll);
                my_log_prior(ll)=0;
                string_to_write_param=['my_draw(' num2str(ll) ')=' num2str(PriorStructure.prior_m(ll), 15) ';'];
                string_to_write_prior=['my_log_prior(' num2str(ll) ')=0;'];
                string_to_write_from_real=['my_draw(' num2str(ll) ')= ( RealDraw (' num2str(ll) ') );'];
                string_to_write_reverse=['RealDraw(' num2str(ll) ')=( my_draw(' num2str(ll) ') );'];
            end
        case 'GAMMA'
            if NO_TRUNCATION % undo the truncation of the Dynare priors
                PriorStructure.prior_trunc_low(ll)=0;
                PriorStructure.prior_trunc_high(ll)=inf;
                string_to_write_Jacob=['my_log_Jacob(' num2str(ll) ')=NaN;'];
                string_to_write_from_real=['my_draw(' num2str(ll) ')= log( RealDraw (' num2str(ll) ') );'];
                string_to_write_reverse=['RealDraw(' num2str(ll) ')=exp( my_draw(' num2str(ll) ') );'];
            else
                % Note: the transformation does not work with infinite upper bounds
                string_to_write_Jacob=['my_log_Jacob(' num2str(ll) ')=log(' num2str(PriorStructure.prior_trunc_high(ll)-PriorStructure.prior_trunc_low(ll),15) ')' ...
                    '/(1+exp(-RealDraw(' num2str(ll) '))+' num2str(PriorStructure.prior_trunc_low(ll),15) ');'];
                string_to_write_from_real=['my_draw(' num2str(ll) ')=(' num2str(PriorStructure.prior_trunc_high(ll)-PriorStructure.prior_trunc_low(ll),15) ...
                    '/ ( 1+exp( -RealDraw(' num2str(ll) ') ) ) +' num2str(PriorStructure.prior_trunc_low(ll),15) ') ;'];
                string_to_write_reverse=['RealDraw(' num2str(ll) ')=-log(' num2str(PriorStructure.prior_trunc_high(ll)-PriorStructure.prior_trunc_low(ll),15) ...
                    '/ (my_draw(' num2str(ll) ')-' num2str(PriorStructure.prior_trunc_low(ll),15) ') -1);'];
            end
            if PriorStructure.prior_s(ll)>0
                MatlabParam1=PriorStructure.prior_m(ll)^2 / PriorStructure.prior_s(ll)^2 ;
                MatlabParam2=PriorStructure.prior_s(ll)^2 / PriorStructure.prior_m(ll) ;
                my_draw(ll)=gamrnd(MatlabParam1,MatlabParam2);
                trunc_low=gamcdf(PriorStructure.prior_trunc_low(ll),MatlabParam1,MatlabParam2);
                trunc_high=gamcdf(PriorStructure.prior_trunc_high(ll),MatlabParam1,MatlabParam2);
                trunc_diff=trunc_high-trunc_low;
                my_log_prior(ll)=(MatlabParam1-1)*log(my_draw(ll))-my_draw(ll)/MatlabParam2 - MatlabParam1*log(MatlabParam2)-gammaln(MatlabParam1)-log(trunc_diff);
                string_to_write_param=['my_draw(' num2str(ll) ')=gaminv(' num2str(trunc_low) '+rand(1)*' num2str(trunc_diff) ',' num2str(MatlabParam1) ...
                    ',' num2str(MatlabParam2) ');'];
                string_to_write_prior=['my_log_prior(' num2str(ll) ')=(' num2str(MatlabParam1-1,15) ')*log(my_draw(' num2str(ll) '))-my_draw(' num2str(ll) ')/' num2str(MatlabParam2,15)  ...
                    '+' num2str(-MatlabParam1*log(MatlabParam2)-gammaln(MatlabParam1)-log(trunc_diff),15)   ';'];
            else
                my_draw(ll)=PriorStructure.prior_m(ll);
                my_log_prior(ll)=0;
                string_to_write_param=['my_draw(' num2str(ll) ')=' num2str(PriorStructure.prior_m(ll), 15) ';'];
                string_to_write_prior=['my_log_prior(' num2str(ll) ')=0;'];
                string_to_write_from_real=['my_draw(' num2str(ll) ')= ( RealDraw (' num2str(ll) ') );'];
                string_to_write_reverse=['RealDraw(' num2str(ll) ')=( my_draw(' num2str(ll) ') );'];
            end            
        case 'INV_GAMMA'
            if NO_TRUNCATION % undo the truncation of the Dynare priors
                PriorStructure.prior_trunc_low(ll)=0;
                PriorStructure.prior_trunc_high(ll)=inf;
                string_to_write_Jacob=['my_log_Jacob(' num2str(ll) ')=NaN;'];
                string_to_write_from_real=['my_draw(' num2str(ll) ')= log( RealDraw (' num2str(ll) ') );'];
                string_to_write_reverse=['RealDraw(' num2str(ll) ')=exp( my_draw(' num2str(ll) ') );'];
            else
                % Note: the transformation does not work with infinite upper bounds
                string_to_write_Jacob=['my_log_Jacob(' num2str(ll) ')=log(' num2str(PriorStructure.prior_trunc_high(ll)-PriorStructure.prior_trunc_low(ll),15) ')' ...
                    '/(1+exp(-RealDraw(' num2str(ll) '))+' num2str(PriorStructure.prior_trunc_low(ll),15) ');'];
                string_to_write_from_real=['my_draw(' num2str(ll) ')=(' num2str(PriorStructure.prior_trunc_high(ll)-PriorStructure.prior_trunc_low(ll),15) ...
                    '/ ( 1+exp( -RealDraw(' num2str(ll) ') ) ) +' num2str(PriorStructure.prior_trunc_low(ll),15) ') ;'];
                string_to_write_reverse=['RealDraw(' num2str(ll) ')=-log(' num2str(PriorStructure.prior_trunc_high(ll)-PriorStructure.prior_trunc_low(ll),15) ...
                    '/ (my_draw(' num2str(ll) ')-' num2str(PriorStructure.prior_trunc_low(ll),15) ') -1);'];
            end
            if PriorStructure.prior_s(ll)>0
                MatlabParam1=2+PriorStructure.prior_m(ll)^2/PriorStructure.prior_s(ll)^2;
                MatlabParam2=PriorStructure.prior_m(ll)+PriorStructure.prior_m(ll)^3/PriorStructure.prior_s(ll)^2;

                if PriorStructure.prior_trunc_low(ll)==-inf
                    trunc_low=0;
                else
                    trunc_low=gammainc(MatlabParam2/PriorStructure.prior_trunc_low(ll),MatlabParam1,'upper');
                end
                trunc_high=gammainc(MatlabParam2/PriorStructure.prior_trunc_high(ll),MatlabParam1,'upper');
                trunc_diff=trunc_high-trunc_low;

                my_log_prior(ll)=(-MatlabParam1-1)*log(my_draw(ll))-MatlabParam2/my_draw(ll) + MatlabParam1*log(MatlabParam2)-gammaln(MatlabParam1)-log(trunc_diff);
                string_to_write_param=['my_draw(' num2str(ll) ')=my_InvGamInvCDF(' num2str(trunc_low) '+rand(1)*' num2str(trunc_diff) ',' num2str(MatlabParam1) ...
                    ',' num2str(MatlabParam2) ');'];
                string_to_write_prior=['my_log_prior(' num2str(ll) ')=(' num2str(-MatlabParam1-1,15) ')*log(my_draw(' num2str(ll) '))-' num2str(MatlabParam2,15) '/my_draw(' num2str(ll) ')' ...
                    '+' num2str(MatlabParam1*log(MatlabParam2)-gammaln(MatlabParam1)-log(trunc_diff), 15)  ';'];
            else
                my_draw(ll)=PriorStructure.prior_m(ll);
                my_log_prior(ll)=0;
                string_to_write_param=['my_draw(' num2str(ll) ')=' num2str(PriorStructure.prior_m(ll), 15) ';'];
                string_to_write_prior=['my_log_prior(' num2str(ll) ')=0;'];
                string_to_write_from_real=['my_draw(' num2str(ll) ')= ( RealDraw (' num2str(ll) ') );'];
                string_to_write_reverse=['RealDraw(' num2str(ll) ')=( my_draw(' num2str(ll) ') );'];
            end
        case 'NORMAL'
            if NO_TRUNCATION % undo the truncation of the Dynare priors
                PriorStructure.prior_trunc_low(ll)=-inf;
                PriorStructure.prior_trunc_high(ll)=inf;
                % Real into reals - no need for a mapping
                string_to_write_Jacob=['my_log_Jacob(' num2str(ll) ')=NaN;'];
                string_to_write_from_real=['my_draw(' num2str(ll) ')= RealDraw (' num2str(ll) ');'];
                string_to_write_reverse=['RealDraw(' num2str(ll) ')=my_draw(' num2str(ll) ');'];
            else
                % Note: the transformation does not work with infinite upper bounds
                string_to_write_Jacob=['my_log_Jacob(' num2str(ll) ')=log(' num2str(PriorStructure.prior_trunc_high(ll)-PriorStructure.prior_trunc_low(ll),15) ')' ...
                    '/(1+exp(-RealDraw(' num2str(ll) '))+' num2str(PriorStructure.prior_trunc_low(ll),15) ');'];
                string_to_write_from_real=['my_draw(' num2str(ll) ')=(' num2str(PriorStructure.prior_trunc_high(ll)-PriorStructure.prior_trunc_low(ll),15) ...
                    '/ ( 1+exp( -RealDraw(' num2str(ll) ') ) ) +' num2str(PriorStructure.prior_trunc_low(ll),15) ') ;'];
                string_to_write_reverse=['RealDraw(' num2str(ll) ')=-log(' num2str(PriorStructure.prior_trunc_high(ll)-PriorStructure.prior_trunc_low(ll),15) ...
                    '/ (my_draw(' num2str(ll) ')-' num2str(PriorStructure.prior_trunc_low(ll),15) ') -1);'];
            end
            if PriorStructure.prior_s(ll)>0
                MatlabParam1=PriorStructure.prior_m(ll);
                MatlabParam2=PriorStructure.prior_s(ll);

                trunc_low=normcdf(PriorStructure.prior_trunc_low(ll),MatlabParam1,MatlabParam2);
                trunc_high=normcdf(PriorStructure.prior_trunc_high(ll),MatlabParam1,MatlabParam2);
                trunc_diff=trunc_high-trunc_low;

                string_to_write_param=['my_draw(' num2str(ll) ')=norminv(' num2str(trunc_low) '+rand(1)*' num2str(trunc_diff) ',' num2str(MatlabParam1) ...
                    ',' num2str(MatlabParam2) ');'];
                string_to_write_prior=['my_log_prior(' num2str(ll) ')=-' num2str(0.5/MatlabParam2^2, 15) '*( my_draw(' num2str(ll) ') - ' num2str(MatlabParam1,15) ')^2 ' ...
                    '+' num2str(-log(MatlabParam2)-log(2*pi)/2-log(trunc_diff), 15)  ';'];
            else
                my_draw(ll)=PriorStructure.prior_m(ll);
                my_log_prior(ll)=0;
                string_to_write_param=['my_draw(' num2str(ll) ')=' num2str(PriorStructure.prior_m(ll), 15) ';'];
                string_to_write_prior=['my_log_prior(' num2str(ll) ')=0;'];
                string_to_write_from_real=['my_draw(' num2str(ll) ')= ( RealDraw (' num2str(ll) ') );'];
                string_to_write_reverse=['RealDraw(' num2str(ll) ')=( my_draw(' num2str(ll) ') );'];
            end                
        otherwise
            error(['unknown prior: ' PriorStructure.param_type{ll}])
    end    
    eval(string_to_write_param); %execute code once in case of problems
    eval(string_to_write_prior); %execute code once in case of problems
    eval(string_to_write_reverse); %execute code once in case of problems
    eval(string_to_write_Jacob); %execute code once in case of problems
    if DO_SIMULATE~=2
        fprintf(my_fid,[string_to_write_param '\n']);
        fprintf(my_fid_m,[string_to_write_param '\n']);
        fprintf(my_fid,[string_to_write_prior '\n']);
        fprintf(my_fid_m,[string_to_write_prior '\n']);
        fprintf(my_fid_dens,[string_to_write_prior '\n']);
        fprintf(my_fid_reverse,[string_to_write_reverse '\n']);

        fprintf(my_fid_from_real,[string_to_write_from_real '\n']);
        fprintf(my_fid_from_real,[string_to_write_prior '\n']);
        fprintf(my_fid_from_real,[string_to_write_Jacob '\n']);
    end
end

if DO_SIMULATE~=2
    fprintf(my_fid_dens,'else \n');
    fprintf(my_fid_dens,'	my_log_prior=-Inf(PriorStructure.param_no,1); \n');
    fprintf(my_fid_dens,'end \n');

    % close all files
    fclose(my_fid);
    fclose(my_fid_reverse);
    fclose(my_fid_dens);
    fclose(my_fid_m);
    fclose(my_fid_from_real);
end
fclose(my_fid_mod);

PriorStructure.NON_DIAGONAL_G = NON_DIAGONAL_G;